jQuery(document).ready(function($){
  "use strict";
  /* dropDownList */
  $.fn.dropDownListFW = function () {
    return this.each(function () {
      
      var $select = $(this), $selectWrapper = null, $selected = null, $selectList = [], $dropDownList = null, openFlag = false, hideTimer;
      
      function updateSize(){
        var width = $selected.width(),
            eTop = $selected.offset().top, //get the offset top of the element
            eLeft = $selected.offset().left, //get the offset left of the element
            right = $(window).width() - (eLeft + width), //get the offset right of the element
            top = eTop - $(window).scrollTop(); //position of the ele w.r.t window
        $dropDownList.css({
          width: width,
          top: top,
          right: right
        });
      }
      
      function openDDL() {
        openFlag = true;
        // off previously
        $dropDownList.off("mouseleave");
        $dropDownList.off("mouseenter");
        updateSize();
        // отображаем селект
        $dropDownList.stop(true, true).slideDown({duration: 250, easing: "easeOutQuart"}).css("z-index", 10);
        // если ничего не выбрано, прячем список через 3 сек
        $($dropDownList).on("mouseleave", function () {
          hideTimer = setTimeout(function () {
            // hide dropdownlist
            $dropDownList.stop(true, true).slideUp({duration: 250, easing: "easeOutQuart"});
            openFlag = false;
          }, 3000);
        });
        // обнулить таймер при наведении
        $($dropDownList).on("mouseenter", function () {
          clearTimeout(hideTimer);
        });
        // если клик в другом месте
        $(document).click(function (event) {
          if ($(event.target).closest($selectWrapper).length) {
            return;
          }
          // hide dropdownlist
          $dropDownList.stop().slideUp({duration: 250, easing: "easeOutQuart"}).css("z-index", 1);
          openFlag = false;
          event.stopPropagation();
        });
      }
      
      function buildDDL() {
        // wrap to container
        $select.wrap("<div class='fw_select'></div>");
        // hide select tag
        $select.hide();
        // select wrapper
        $selectWrapper = $select.parent();
        // current select
        $selectWrapper.append("<div class='fw_selected'></div>");
        // get selected container
        $selected = $selectWrapper.find(".fw_selected");
        // create list
        $selectList.push('<ul class="fw_select_wrapper shadow-depth-5 overflow">');
        $select.find("option").each(function () {
          // find selected
          if($(this).attr("selected")){
            $selected.text($(this).text());
          }
          $selectList.push('<li data-value="' + $(this).val() + '">' + $(this).text() + '</li>');
        })
        $selectList.push('</ul>');
        // append and set list, than hide
        $selectWrapper.append($selectList.join(" "));
        $dropDownList = $selectWrapper.find(".fw_select_wrapper");
        $dropDownList.hide();
        
        // open drop down list
        $selected.on("click", function(e){
          e.stopPropagation();
          openDDL();
        });
        // open when focus
        $select.on("focus", function(){
          if(!openFlag) {
            openDDL();
          }
          $select.blur();
        });
        
        $(window).resize(function($){
          updateSize();
        });
        
        // select option
        $dropDownList.children().on("click", function(){
          $dropDownList.children().removeClass('selected');
          $(this).addClass('selected');
          $select.val($(this).data("value"));
          $selected.text($select.find(":selected").text());
          $select.change();
          // hide dropdownlist
          $dropDownList.stop(true, true).slideUp({duration: 250, easing: "easeOutQuart"}).css("z-index", 1);
          setTimeout(function(){
            openFlag = false;
          }, 500);
        });
        
        // если изменили селект из вне, для колор пикера
        $select.on("change", function(){
          $dropDownList.children().removeClass('selected');
          $dropDownList.find('*[data-value="' + $select.val() + '"]').addClass('selected');
          $selected.text($select.find(":selected").text());
        });
        
      }
      
      buildDDL();
      
      
    });
  };
  
  $.fn.dropdownListActionFW = function (options) {

    var settings = $.extend({
      'location'         : 'top',
      'background-color' : 'blue'
    }, options);

    return this.each(function () {
      var $wrapper = $(this),
        $select_wrapper,
        $dropDownList,
        $select,
        hideTimer;
      
      $select = $wrapper.find(".fw_select_dropdown");
      $dropDownList = $wrapper.find(".fw_dropdown_list");
      
      /* ÐžÐ¢ÐšÐ Ð«Ð¢Ð˜Ð• */
      $select.on("click", function () {
        $dropDownList.slideUp(250);
        var pageHeight = $("body").height(),
          docHeight = $(document).height(),
          selectPos = $select.offset(),
          selectHeight = selectPos.top + ($select.children().length * 40),
          wrapperWidth = 0;
        
        if (pageHeight > docHeight) {
          if (selectHeight < pageHeight) {
            $dropDownList.css("top", 0);
            $dropDownList.css("bottom", "auto");
          } else {
            $dropDownList.css("top", "auto");
            $dropDownList.css("bottom", 0);
          }
        } else {
          if (selectHeight < docHeight) {
            $dropDownList.css("top", 0);
            $dropDownList.css("bottom", "auto");
          } else {
            $dropDownList.css("top", "auto");
            $dropDownList.css("bottom", 0);
          }
        }
        
		$dropDownList.slideDown(250);
        
        $($dropDownList.find("a")).each(function () {
          console.log(wrapperWidth);
          if ($(this).width() > wrapperWidth) {
            wrapperWidth = $(this).width() + 50;
          }
          $(this).css({
            display: "block"
          });
        });
        /*
        $dropDownList.css({
          left: 30 - (wrapperWidth + 20),
          width: wrapperWidth + 20
        });
        */
      });
      
      // hide after 3 sec
      $($dropDownList).on("mouseleave", function () {
        hideTimer = setTimeout(function () {
          
		  $dropDownList.slideUp(250);
        }, 3000);
      });
      
      // cleartimer on hover
      $($dropDownList).on("mouseenter", function () {
        clearTimeout(hideTimer);
      });
      
      $(document).click(function (event) {
        if ($(event.target).closest($select).length) {
          return;
        }
		$dropDownList.slideUp(250);
        event.stopPropagation();
      });
    });
  };
  
  // init FW
  $(".fw_wrapper select[multiple!='multiple']").dropDownListFW();
  $(".fw_dropdown_wrapper").dropdownListActionFW();
});