(function ($) {
  "use strict";
  (function (window) {
    var modalFW = (function () {
      var $modal, $modalHeading, $modalClose, $modalCancel;
      
      function close() {
        //console.log("close");
        $modal.removeAttr("style").addClass("close");
      }
      
      function open(options) {
        //console.log("open");
        var settings = $.extend({
          'heading': null,
          'modal' : null
        }, options);
        
        $modal = settings.modal;
        $modalHeading = $modal.find(".h6");
        $modalClose = $modal.find(".fw_close");
        $modalCancel = $modal.find("#fw_mdl_cancel");
        
        // set heading
        $modalHeading.text(settings.heading);
        
        // show modal
        $modal.removeClass("close").css('borderSpacing', 0).animate({ borderSpacing: 1 }, {
          step: function(now, fx) {
            $(this).css({
              '-webkit-transform': 'translate(-50%, -50%) scale(' + now + ', ' + now + ')',
              '-ms-transform': 'translate(-50%, -50%) scale(' + now + ', ' + now + ')',
              '-o-transform': 'translate(-50%, -50%) scale(' + now + ', ' + now + ')',
              'transform': 'translate(-50%, -50%) scale(' + now + ', ' + now + ')'
            });  
          },
          duration: 1500,
          easing: "easeOutElastic"
        });
        
        // close mdl by icon close
        $modalClose.off("click");
        $modalClose.on("click", function(e){
          //console.log("close by icon");
          e.preventDefault();
          close();
        });
        
        // close by cancel
        $modalCancel.off("click");
        $modalCancel.on("click", function(e){
          //console.log("close by cancel");
          e.preventDefault();
          
          var confirmFlag = false;
          $modal.find("input").each(function(){
            if($(this).val() != "") {
              confirmFlag = true;
            }
          });
          if(confirmFlag) {
            if (confirm("Attention, the entered information will be lost. Are you sure?")) {
              close();
              confirmFlag = false;
            }
          } else {
            close();
          }
        });
      }
      
      return {
        close: close,
        open: open
      };
    }());

    window.modalFW = modalFW;

  }(window));
}(jQuery));
