jQuery(document).ready(function($){
  /* Tabs */
  $.fn.tabFW = function () {
    "use strict";
    return this.each(function () {
      var $tabs = $(this),
        $border = $(this).find('.fw_tabs-border'),
        activeTabPos = null,
        borderPos = null,
        widthTo = null,
        tabIndex = 0;

      // Change Position of border
      function changePos() {
        // update data
        activeTabPos = $tabs.find('.fw_tabs-header .active').position(); // active tab pos
        borderPos = $border.position(); // current border pos
        widthTo = null; // width from current border pos to active tab pos
        // if pos of active tab > position of border
        if (activeTabPos.left > borderPos.left) {
          // width of border anim = border pos - active tab pos + tab width
          widthTo = Math.abs(borderPos.left - activeTabPos.left) + $tabs.find('.fw_tabs-header .active').width();
        } else {
          // width of border anim = border pos - active tab pos + border width
          widthTo = (borderPos.left - activeTabPos.left) + $border.width();
          borderPos = activeTabPos;
        }
        // if start width of bord anim = active tab
        if (widthTo === 0) {
          widthTo = $tabs.find('.fw_tabs-header .active').outerWidth(true);
        }
        // Start border animation
        $border.stop(true, false).animate({
          left: borderPos.left,
          width: widthTo
        }, 250, "easeOutQuint");
        // set new height
        //console.log($tabs.find('.fw_tab').eq(tabIndex).outerHeight(true));
        $tabs.find('.fw_tabs-content').stop(true, false).animate({
          height: $tabs.find('.fw_tab').eq(tabIndex).outerHeight(true),
          overflow: "hidden"
        }, 250, "easeOutQuint", function () {
          // slide tab
          $tabs.find(".fw_tabs-slider").stop(true, true).animate({
            left: -$tabs.find('.fw_tabs-content').outerWidth(true) * tabIndex
          }, 500, "easeOutQuint", function () {
            $tabs.find('.fw_tabs-content').css({
              overflow: "visible"
            });
          });
          // end of border animation
          $border.stop(true, true).animate({
            left: $tabs.find('.fw_tabs-header .active').position().left,
            width: $tabs.find('.fw_tabs-header .active').outerWidth(true)
          }, 500, "easeOutQuart");
        });
      }

      // init
      changePos();

      //change position of border when resize
      $(window).resize(function () {
        changePos();
      });

      $tabs.find('.fw_tabs-header li').on("click", function () {
        // Tab index
        tabIndex = $(this).index();
        // Remove Active State from nav
        $tabs.find('.fw_tabs-header li').removeClass('active');
        // Add Active State for nav
        $(this).addClass('active');
        changePos();
      });

    });
  };
});
jQuery(document).ready(function($){
  "use strict";
  // init tabs
  jQuery(".fw_tabs").tabFW();
});
