jQuery(document).ready(function ($) {
  "use strict";
  var sngTmplt = "", frame_audio, saveflag = false;
  
  /* SONG TEMPLATE */
  sngTmplt += "<tr title='{name}'>";
  sngTmplt += "  <td class='fw_input_field'>";
  sngTmplt += "    <label><input type='checkbox' name='idList[]' value='{id}'><span class='fw_checkbox'></span></label>";
  sngTmplt += "    <input type='hidden' name='ads_list[{temp_id}][name]' value='{name}'>";
  sngTmplt += "    <input type='hidden' name='ads_list[{temp_id}][url]' value='{url}'>";
  sngTmplt += "  </td>";
  sngTmplt += "  <td class='wptpa_drag ui-sortable-handle'><i class='fas fa-arrows-alt'></i></td>";
  sngTmplt += "  <td class='wptpa_song'><b>{name}</b></td>";
  sngTmplt += "</tr>";
  
  /* CHECKBOX */
  
  // select and unselect all items
  $("#select_all").on("change", function () {
    if ($(this).attr("checked")) {
      $("input[name='idList[]']").attr("checked", true).parent().parent().parent().addClass("checked");
    } else {
      $("input[name='idList[]']").attr("checked", false).parent().parent().parent().removeClass("checked");
    }
  });
  
  // highlights for checkbox
  $("body").on("change", "input[name='idList[]']", function () {
    if ($(this).attr("checked")) {
      $(this).parent().parent().parent().addClass("checked");
    } else {
      $(this).parent().parent().parent().removeClass("checked");
    }
  });

  // клик по итему активирует чекбокс в редактирование плейлиста
  $("body").on("click", "#wptpa_playlist tbody tr", function () {
    // если инпут выбран снимаем чекед
    if ($(this).find("input[name='idList[]']").attr("checked")) {
      $(this).find("input[name='idList[]']").attr("checked", false).change();
    } else {
      $(this).find("input[name='idList[]']").attr("checked", true).change();
    }
  });
  
  /* PLAYLIST EDIT */
  
  // получаем данные о треке
  function getSongInfo($song) {
    var array = {
      name: $song.find("input[name*='name']"),
      url: $song.find("input[name*='url']")
    };
    return array;
  }
  
  // получаем данные о треке из модального окна
  function modalParse() {
    var array = {
      name: $("#name").val(),
      url: $("#url").val()
    }, length = 0;
    // проверяем каждое поле на количество букв
    $.each(array, function( index, value ) {
      length += value.length
    });
    // если нет букв не в одном поле возвращаем фалс иначе массив
    if(length === 0) {
      return false;
    } else {
      return array;
    }
  }
  
  // првоерка есть ли терки в плейлисте
  function emptyMSg() {
    var count = $("#wptpa_playlist tbody tr:not(.wptpa_empty_pls)").length;
    if (count < 1) {
      $(".wptpa_empty_pls").show();
    } else {
      $(".wptpa_empty_pls").hide();
    }
  }
  
  // проверяем есть ли треки в плейлисте
  emptyMSg();
  
  // генератор случайого айди
  function makeid() {
    var text = $(".playlist_list").children().length,
      possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
      i;
    for (i = 0; i < 5; i++) {
      text += possible.charAt(Math.floor(Math.random() * possible.length));
    }
    return text;
  }
  
  // render after update
  function updateSongItemRender($song) {
    // get current data
    var data = {
      name: $song.find("input[name*='name']").val(),
      url: $song.find("input[name*='url']").val()
    }
    // update song name
    $song.find(".wptpa_song").html("<b>" + data.name + "</b>");
  }
  
  /* Sorting */
  $("#wptpa_playlist tbody").sortable({
    forceHelperSize: false,
    tolerance: "pointer",
    forcePlaceholderSize: false,
    axis: "y",
    placeholder: "ui-state-highlight",
    handle: ".wptpa_drag"
  });
  $("#wptpa_playlist").disableSelection();
  
  
  /* ADD SONG */
  $("#add_songs").on("click", function () {
    $("input[name='idList[]']").attr("checked", false).change();
    // reset all inputs
    $("#song_modall").find("input").val("").removeAttr("placeholder").change();
    modalFW.open({
      heading: "Add Advertisement Audio",
      modal: $($(this).attr("href"))
    });
  });
  
  /* Edit SONG */
  $("#edit_songs").on("click", function () {
    var countSelected = $("input[name='idList[]']:checked").length, song;
    // reset all inputs
    $("#song_modall").find("input").val("").removeAttr("placeholder").change();
    // проверяем выбраны ли элементы
    if (countSelected > 0) {
      // если выбрано больше одного трека
      if (countSelected > 1) {
        //
        $("#song_modall").find("input").attr("placeholder", "Multiply Values").change();
      } else {
        // get song info and set to modal
        song = getSongInfo($("input[name='idList[]']:checked").parent().parent());
        // set in modal inputs
        console.log(song)
        $("#name").val(song.name.val()).change();
        $("#url").val(song.url.val()).change();
      }
      modalFW.open({
        heading: "Edit Advertisement Audio",
        modal: $($(this).attr("href"))
      });
    } else {
      notifyFW.send({
        "heading": "Delete",
        "text": "Please, <b>Select</b> item for Editing."
      });
    }
  });
  
  /* Delete Song */
  $("#delete_song").on("click", function (e) {
    e.preventDefault();
    var countSelected = $("input[name='idList[]']:checked").length; // количество выбраных треков
    //проверяем выбран ли трек
    if (countSelected > 0) {
      $("input[name='idList[]']:checked").each(function () {
        $(this).closest('tr').remove();
      });
      emptyMSg(); // если треки закончились выводим поле пустого плейлиста
    } else {
      notifyFW.send({
        "heading": "Delete",
        "text": "Please, <b>Select</b> item for Deleting."
      });
    }
  });
  
  
  /* CLICK OK IN MODAL */
  $("#fw_mdl_ok").on("click", function (e) {
    e.preventDefault();
    var countSelected, $element, $replacedElement, dwnStatus, buyStatus, modalValue;
    // get values
    countSelected = $("input[name='idList[]']:checked").length;
    modalValue = modalParse();
    console.log(modalValue);
    // если больше 0 изменяем трек, меньшь добавляем
      //console.log("work");
    if (countSelected > 0) {
      // если один трек
      //console.log("edit");
      if (countSelected <= 1) {
        $replacedElement = $("tr.checked");
        $replacedElement.find("input[name*='name']").val(modalValue.name);
        $replacedElement.find("input[name*='url']").val(modalValue.url);
        // обновляем рендер
        updateSongItemRender($replacedElement);
      } else {
        //console.log("multy edit");
        //console.log(modalValue);
        // больше одного трека
        if(modalValue){
          $("tr.checked").each(function () {
            $replacedElement = $(this);
            if (modalValue.name !== "") {
              $replacedElement.find("input[name*='name']").val(modalValue.name);
            }
            if (modalValue.url !== "") {
              $replacedElement.find("input[name*='url']").val(modalValue.url);
            }
            updateSongItemRender($replacedElement);
          });
        }
      }
    } else {
      // если значение есть добавляем
      if(modalValue){
        //console.log("add");
        if(modalValue.name != ""){
          modalValue.name = modalValue.name;
        } else {
          modalValue.name = "Unnamed Advertisement";
        }
        $element = sngTmplt
          .replace(/\{temp_id\}/g, makeid())
          .replace(/\{name\}/g, modalValue.name)
          .replace('{url}', modalValue.url);
        $("#wptpa_playlist tbody").append($($element));
      }
    }
    // проверяем есть ли треки в плейлисте
    emptyMSg();
    modalFW.close();
  });

  // upload song
  $("#wptpa_select_audio").on("click", function(e){
    e.preventDefault();
    var $elements;
    
    if (frame_audio) {
      frame_audio.open();
      return;
    }
    // Create a new media frame_audio
    frame_audio = wp.media({
      title: 'Select or Upload Audio',
      button: {
        text: 'Select'
      },
      library : {type : 'audio'},
      multiple: true  // Set to true to allow multiple files to be selected
    });
    frame_audio.on('select', function () {
      // Get media attachment details from the frame_audio state
      var attachment = frame_audio.state().get('selection').toJSON(), songInfo;
      // проверяем количество выбранных элементов
      if (attachment.length < 2) {
        //если один
        songInfo = attachment[0];
        // заполняем аудио линк и ковер
        $("#url").val(songInfo.url).change();
      } else {
        //если больше одного трека выбрано
        $.each(attachment, function (index, value) {
          var song = "";
          song = 'Unnamed Advertisement';
          
          // заполняем темплейт
          $elements = sngTmplt
            .replace(/\{temp_id\}/g, makeid())
            .replace(/\{name\}/g, song)
            .replace('{url}', value.url)
          //добавляем итем
          $("#wptpa_playlist tbody").append($($elements));
        });
        // закріваем окно модальное
        modalFW.close();
        // чистим емпти мдж
        emptyMSg();
      }
    });
    // Finally, open the modal on click
    frame_audio.open();
  });
  
  
  // проверяем случайный уход со страницы
  var params = window.location.search.replace('?','').split('&').reduce(
    function(p,e){
      var a = e.split('=');
      p[ decodeURIComponent(a[0])] = decodeURIComponent(a[1]);
      return p;
    },
    {}
  );

  
  
  $("button[name='action']").on("click", function (){
    saveflag = true;
  });
  
  window.onbeforeunload = function (event) {
    //console.log(saveflag);
    if(params["action"] == "edit" && !saveflag){
      if (confirm) {
        return true;
      } else {
        return false;
      }
    }
  }
});