jQuery(document).ready(function ($) {
  "use strict";
  var sngTmplt = "", frame_audio, frame_cover, frame_defaultCover, saveflag = false, defaultCover = null;
  
  /* SONG TEMPLATE */
  sngTmplt += "<tr title='{artist} - {title}'>";
  sngTmplt += "  <td class='fw_input_field'>";
  sngTmplt += "    <label><input type='checkbox' name='idList[]' value='{id}'><span class='fw_checkbox'></span></label>";
  sngTmplt += "    <input type='hidden' name='playlist[items][{temp_id}][artist]' value='{artist}'>";
  sngTmplt += "    <input type='hidden' name='playlist[items][{temp_id}][title]' value='{title}'>";
  sngTmplt += "    <input type='hidden' name='playlist[items][{temp_id}][audio]' value='{audio}'>";
  sngTmplt += "    <input type='hidden' name='playlist[items][{temp_id}][cover]' value='{cover}'>";
  sngTmplt += "    <input type='hidden' name='playlist[items][{temp_id}][dwn]' value='{dwn}'>";
  sngTmplt += "    <input type='hidden' name='playlist[items][{temp_id}][buy]' value='{buy}'>";
  sngTmplt += "  </td>";
  sngTmplt += "  <td class='wptpa_drag ui-sortable-handle'><i class='fas fa-arrows-alt'></i></td>";
  sngTmplt += "  <td class='wptpa_cover'><img src='{cover}'></td>";
  sngTmplt += "  <td class='wptpa_song'>{song}</td>";
  sngTmplt += "  <td class='wptpa_dwn {dwn_state}' title='Download Link'><i class='fas fa-download'></i></td>";
  sngTmplt += "  <td class='wptpa_buy {buy_state}' title='Buy Link'><i class='fas fa-shopping-cart'></i></td>";
  sngTmplt += "</tr>";
  
  /* CHECKBOX */
  // checkbox click
	$("body").on("change", "input[name='idList[]']", function () {
		if ($(this).prop("checked")) {
      $(this).parent().parent().parent().addClass("checked");
    } else {
      $(this).parent().parent().parent().removeClass("checked");
    }
		// если выбраны все чекбоксы, включаем селет алл, иначе деактивиукем
		if($("input[name='idList[]']").length === $("input[name='idList[]']:checked").length) {
			$("#select_all").prop("checked", true);
		} else {
			$("#select_all").prop("checked", false);
		}
  });

	// select and unselect all items
  $("#select_all").on("change", function () {
    if ($("#select_all").prop("checked")) {
      $("input[name='idList[]']").prop("checked", true);
			$("input[name='idList[]']").parent().parent().parent().addClass("checked");
    } else {
      $("input[name='idList[]']").prop("checked", false);
			$("input[name='idList[]']").parent().parent().parent().removeClass("checked");
    }
  });
	
	// клик по итему активирует чекбокс в редактирование плейлиста
  $("body").on("click", "#wptpa_playlist tbody tr", function () {
    // если инпут выбран снимаем чекед
    if ($(this).find("input[name='idList[]']").prop("checked")) {
      $(this).find("input[name='idList[]']").prop("checked", false);
      $(this).removeClass("checked");
    } else {
      $(this).find("input[name='idList[]']").prop("checked", true);
      $(this).addClass("checked");
    }
		// если выбраны все чекбоксы, включаем селет алл, иначе деактивиркем
		if($("input[name='idList[]']").length === $("input[name='idList[]']:checked").length) {
			$("#select_all").prop("checked", true);
		} else {
			$("#select_all").prop("checked", false);
		}
  });
	
  /* SEARCH PLAYLIST */
  // поиск
  $("#wptpa_search_playlist").on("keyup focus", function () {
    var searchValue = $(this).val(), data;
    //console.log(searchValue);
    // ищем после трех введенных символов
    if (searchValue.length > 2) {
      data = {
        action: "wptpa_search_playlist",
        searchValue: searchValue
      };
      // ajax
      $.ajax({
        type: "POST",
        url: ajaxurl,
        data: data,
        beforeSend: function () {
          $("#wptpa_search_playlist").addClass("loading");
        },
        success: function (response) {
          $("#wptpa_search_playlist").removeClass("loading");
          $("#wptpa_search_results").html(response);
          $("#wptpa_search_results").slideDown();
        }
      });
    }
  });
  
  // прячем результаты поиска
  $("#wptpa_search_playlist").on("focusout", function () {
    setTimeout(function () {
      $("#wptpa_search_results").slideUp(function () {
        $("#wptpa_search_results").empty();
      });
    }, 50);
  });
  
  
  /* PLAYLIST EDIT */
  
  // получаем данные о треке
  function getSongInfo($song) {
    var array = {
      artist: $song.find("input[name*='artist']"),
      title: $song.find("input[name*='title']"),
      audio: $song.find("input[name*='audio']"),
      cover: $song.find("input[name*='cover']"),
      dwn: $song.find("input[name*='dwn']"),
      buy: $song.find("input[name*='buy']")
    };
    return array;
  }
  
  // получаем данные о треке из модального окна
  function modalParse() {
    var array = {
      artist: $("#artist").val(),
      title: $("#title").val(),
      audio: $("#audio").val(),
      cover: $("#cover").val(),
      dwn: $("#dwn").val(),
      buy: $("#buy").val()
    }, length = 0;
    // проверяем каждое поле на количество букв
    $.each(array, function( index, value ) {
      length += value.length
    });
    // если нет букв не в одном поле возвращаем фалс иначе массив
    if(length === 0) {
      return false;
    } else {
      return array;
    }
  }
  
  // првоерка есть ли терки в плейлисте
  function emptyMSg() {
    var count = $("#wptpa_playlist tbody tr:not(.wptpa_empty_pls)").length;
    if (count < 1) {
      $(".wptpa_empty_pls").show();
    } else {
      $(".wptpa_empty_pls").hide();
    }
  }
  
  // проверяем есть ли треки в плейлисте
  emptyMSg();
  
  // генератор случайого айди
  function makeid() {
    var text = $(".playlist_list").children().length,
      possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",
      i;
    for (i = 0; i < 5; i++) {
      text += possible.charAt(Math.floor(Math.random() * possible.length));
    }
    return text;
  }
  
  // render after update
  function updateSongItemRender($song) {
    // get current data
    var data = {
      artist: $song.find("input[name*='artist']").val(),
      title: $song.find("input[name*='title']").val(),
      audio: $song.find("input[name*='audio']").val(),
      cover: $song.find("input[name*='cover']").val(),
      dwn: $song.find("input[name*='dwn']").val(),
      buy: $song.find("input[name*='buy']").val()
    }
    // update cover
    $song.find(".wptpa_cover img").attr("src", data.cover);
    // update song name
    if (data.title != "") {
      $song.find(".wptpa_song").html("<b>" + data.artist + "</b> - " + data.title);
    } else {
      $song.find(".wptpa_song").html("<b>" + data.artist + "</b>");
    }
    // update dwn icon
    if (data.dwn !== "") {
      $song.find(".wptpa_dwn").addClass("on");
    } else {
      $song.find(".wptpa_dwn").removeClass("on");
    }
    // update buy icon
    if (data.buy !== "") {
      $song.find(".wptpa_buy").addClass("on");
    } else {
      $song.find(".wptpa_buy").removeClass("on");
    }
  }
  
  /* Sorting */
  $("#wptpa_playlist tbody").sortable({
    forceHelperSize: false,
    tolerance: "pointer",
    forcePlaceholderSize: false,
    axis: "y",
    placeholder: "ui-state-highlight",
    handle: ".wptpa_drag"
  });
  $("#wptpa_playlist").disableSelection();
  
  
  /* ADD SONG */
  $("#add_songs").on("click", function () {
    $("input[name='idList[]']").attr("checked", false).change();
    // reset all inputs
    $("#song_modall").find("input").val("").removeAttr("placeholder").change();
    if(defaultCover) {
      $("#song_modall").find("#cover").val(defaultCover).change();
    }
    modalFW.open({
      heading: "Add Song",
      modal: $($(this).attr("href"))
    });
  });
  
  /* Edit SONG */
  $("#edit_songs").on("click", function () {
    var countSelected = $("input[name='idList[]']:checked").length, song;
    // reset all inputs
    $("#song_modall").find("input").val("").removeAttr("placeholder").change();
    // проверяем выбраны ли элементы
    if (countSelected > 0) {
      // если выбрано больше одного трека
      if (countSelected > 1) {
        //
        $("#song_modall").find("input").attr("placeholder", "Multiply Values").change();
      } else {
        // get song info and set to modal
        song = getSongInfo($("input[name='idList[]']:checked").parent().parent());
        // set in modal inputs
        $("#artist").val(song.artist.val()).change();
        $("#title").val(song.title.val()).change();
        $("#audio").val(song.audio.val()).change();
        $("#cover").val(song.cover.val()).change();
        $("#dwn").val(song.dwn.val()).change();
        $("#buy").val(song.buy.val()).change();
      }
      if(defaultCover) {
        $("#song_modall").find("#cover").val(defaultCover).change();
      }
      modalFW.open({
        heading: "Edit Song",
        modal: $($(this).attr("href"))
      });
    } else {
      notifyFW.send({
        "heading": "Delete",
        "text": "Please, <b>Select</b> item for Editing."
      });
    }
  });
  
  /* Delete Song */
  $("#delete_song").on("click", function (e) {
    e.preventDefault();
    var countSelected = $("input[name='idList[]']:checked").length; // количество выбраных треков
    //проверяем выбран ли трек
    if (countSelected > 0) {
      $("input[name='idList[]']:checked").each(function () {
        $(this).closest('tr').remove();
      });
      emptyMSg(); // если треки закончились выводим поле пустого плейлиста
    } else {
      notifyFW.send({
        "heading": "Delete",
        "text": "Please, <b>Select</b> item for Deleting."
      });
    }
  });
  
  
  /* CLICK OK IN MODAL */
  $("#fw_mdl_ok").on("click", function (e) {
    e.preventDefault();
    var countSelected, $element, $replacedElement, dwnStatus, buyStatus, modalValue;
    // get values
    countSelected = $("input[name='idList[]']:checked").length;
    modalValue = modalParse();
    // если больше 0 изменяем трек, меньшь добавляем
      //console.log("work");
    if (countSelected > 0) {
      // если один трек
      //console.log("edit");
      if (countSelected <= 1) {
        $replacedElement = $("tr.checked");
        $replacedElement.find("input[name*='artist']").val(modalValue.artist);
        $replacedElement.find("input[name*='title']").val(modalValue.title);
        $replacedElement.find("input[name*='audio']").val(modalValue.audio);
        $replacedElement.find("input[name*='cover']").val(modalValue.cover);
        $replacedElement.find("input[name*='dwn']").val(modalValue.dwn);
        $replacedElement.find("input[name*='buy']").val(modalValue.buy);
        // обновляем рендер
        updateSongItemRender($replacedElement);
      } else {
        //console.log("multy edit");
        //console.log(modalValue);
        // больше одного трека
        if(modalValue){
          $("tr.checked").each(function () {
            $replacedElement = $(this);
            if (modalValue.artist !== "") {
              $replacedElement.find("input[name*='artist']").val(modalValue.artist);
            }
            if (modalValue.title !== "") {
              $replacedElement.find("input[name*='title']").val(modalValue.title);
            }
            if (modalValue.audio !== "") {
              $replacedElement.find("input[name*='audio']").val(modalValue.audio);
            }
            if (modalValue.cover !== "") {
              $replacedElement.find("input[name*='cover']").val(modalValue.cover);
            }
            if (modalValue.dwn !== "") {
              $replacedElement.find("input[name*='dwn']").val(modalValue.dwn);
            }
            if (modalValue.buy !== "") {
              $replacedElement.find("input[name*='buy']").val(modalValue.buy);
            }
            updateSongItemRender($replacedElement);
          });
        }
      }
    } else {
      // если значение есть добавляем
      if(modalValue){
        //console.log("add");
        dwnStatus = modalValue.dwn !== "" ? "on" : "";
        buyStatus = modalValue.buy !== "" ? "on" : "";
        var song = "";
        if(modalValue.title != "") {
          song = '<b>' + modalValue.artist.replace(/'/g, "&#39;").replace(/"/g, "&#34;") + '</b> - ' + modalValue.title.replace(/'/g, "&#39;").replace(/"/g, "&#34;");
        } else {
          song = '<b>' + modalValue.artist.replace(/'/g, "&#39;").replace(/"/g, "&#34;") + '<b>';
        }
          //console.log(modalValue.artist);
        $element = sngTmplt
          .replace(/\{temp_id\}/g, makeid())
          .replace('{song}', song)
          .replace(/\{artist\}/g, modalValue.artist.replace(/'/g, "&#39;").replace(/"/g, "&#34;"))
          .replace(/\{title\}/g, modalValue.title.replace(/'/g, "&#39;").replace(/"/g, "&#34;"))
          .replace('{audio}', modalValue.audio)
          .replace(/\{cover\}/g, modalValue.cover)
          .replace('{dwn}', modalValue.dwn)
          .replace('{buy}', modalValue.buy)
          .replace('{dwn_state}', dwnStatus)
          .replace('{buy_state}', buyStatus);
        $("#wptpa_playlist tbody").append($($element));
      }
    }
    // проверяем есть ли треки в плейлисте
    emptyMSg();
    modalFW.close();
  });

  // upload song
  $("#wptpa_select_audio").on("click", function(e){
    e.preventDefault();
    var $elements;
    
    if (frame_audio) {
      frame_audio.open();
      return;
    }
    // Create a new media frame_audio
    frame_audio = wp.media({
      title: 'Select or Upload Audio',
      button: {
        text: 'Select'
      },
      library : {type : 'audio'},
      multiple: true  // Set to true to allow multiple files to be selected
    });
    frame_audio.on('select', function () {
      // Get media attachment details from the frame_audio state
      var attachment = frame_audio.state().get('selection').toJSON(), songInfo;
      // проверяем количество выбранных элементов
      if (attachment.length < 2) {
        //если один
        songInfo = attachment[0];
        // проверяем если известен аритист и его не написали ранее, то заполняем
        if (songInfo.meta.artist && $("#artist").val() == "") {
          $("#artist").val(songInfo.meta.artist).change();
        }
        // проверяем если известено название и его не написали ранее, то заполняем
        if (songInfo.title && $("#title").val() == "") {
          $("#title").val(songInfo.title).change();
        }
        // заполняем аудио линк и ковер
        $("#audio").val(songInfo.url).change();
        
        // проверяем если его не указали ранее, то заполняем
        if ($("#cover").val() == "") {
          $("#cover").val(songInfo.image.src).change();
        }
      } else {
        //если больше одного трека выбрано
        $.each(attachment, function (index, value) {
          var artist, title;
          artist = value.meta.artist || "";
          title = value.title || "";
          var song = "";
          if(title != "") {
            song = '<b>' + artist.replace(/'/g, "&#39;").replace(/"/g, "&#34;") + '</b> - ' + title.replace(/'/g, "&#39;").replace(/"/g, "&#34;");
          } else {
            song = '<b>' + artist.replace(/'/g, "&#39;").replace(/"/g, "&#34;") + '<b>';
          }
          // заполняем темплейт
          $elements = sngTmplt
            .replace(/\{temp_id\}/g, makeid())
            .replace('{song}', song)
            .replace(/\{artist\}/g, artist.replace(/'/g, "&#39;").replace(/"/g, "&#34;"))
            .replace(/\{title\}/g, title.replace(/'/g, "&#39;").replace(/"/g, "&#34;"))
            .replace('{audio}', value.url)
            .replace(/\{cover\}/g, value.image.src)
            .replace('{dwn}', "")
            .replace('{buy}', "")
            .replace('{dwn_state}', "")
            .replace('{buy_state}', "");
          //добавляем итем
          $("#wptpa_playlist tbody").append($($elements));
        });
        // закріваем окно модальное
        modalFW.close();
        // чистим емпти мдж
        emptyMSg();
      }
    });
    // Finally, open the modal on click
    frame_audio.open();
  });

  // выбор обложки
  $("#wptpa_select_cover").on("click", function(e){
    e.preventDefault();
    if (frame_cover) {
      frame_cover.open();
      return;
    }
    // Create a new media frame_cover
    frame_cover = wp.media({
      title: 'Select or Upload Image',
      button: {
        text: 'Select'
      },
      library : { type : 'image' },
      multiple: false  // Set to true to allow multiple files to be selected
    });
    frame_cover.on('select', function () {
      // Get media attachment details from the frame_cover state
      var attachment = frame_cover.state().get('selection').toJSON();
      $("#cover").val(attachment[0].url).change();
    });
    // Finally, open the modal on click
    frame_cover.open();
  });

  
  // клик по кнопке установить дефолтную обложку
  $("#set_covers").on("click", function(e){
    e.preventDefault();
    if (frame_defaultCover) {
      frame_defaultCover.open();
      return;
    }
    // Create a new media frame_cover
    frame_defaultCover = wp.media({
      title: 'Select or Upload Image',
      button: {
        text: 'Select'
      },
      library : { type : 'image' },
      multiple: false  // Set to true to allow multiple files to be selected
    });
    frame_defaultCover.on('select', function () {
      // Get media attachment details from the frame_cover state
      var attachment = frame_defaultCover.state().get('selection').toJSON();
      defaultCover = attachment[0].url;
      // заменить все пути в текущих треках и добавить в модалку
      jQuery("#wptpa_playlist").find("input[name*='cover']").each(function(){
        jQuery(this).val(defaultCover);
      });
      jQuery(".wptpa_cover").find("img").each(function(){
        jQuery(this).attr("src", defaultCover);
      });
    });
    // Finally, open the modal on click
    frame_defaultCover.open();
  });

  
  
  
  // проверяем случайный уход со страницы
  var params = window.location.search.replace('?','').split('&').reduce(
    function(p,e){
      var a = e.split('=');
      p[ decodeURIComponent(a[0])] = decodeURIComponent(a[1]);
      return p;
    },
    {}
  );

  
  
  
  
  $("button[name='action']").on("click", function (){
    saveflag = true;
  });
  
  window.onbeforeunload = function (event) {
    //console.log(saveflag);
    if(params["action"] == "edit" && !saveflag){
      if (confirm) {
        return true;
      } else {
        return false;
      }
    }
  }
});