/*jslint plusplus: true */
/*jslint browser: true*/
/*global jQuery, console, Audio, location, wptpa_data, clearInterval, setInterval, setTimeout, window, ResizeSensor*/
/*eslint no-console: ["error", { allow: ["log", "error"] }] */
(function ($) {
  "use strict";
  $.fn.wptpa = function (options) {

    // Создаём настройки по-умолчанию, расширяя их с помощью параметров, которые были переданы
    var settings = $.extend({
      'playlist': null,
      'autoplay': false,
      'compactMode': false,
      'cursng': 0,
      'curtm': 0,
      'shuffle': true,
      'shuffleOn': false,
      'share': true,
      'embed': true,
      'showPls': true,
      'volume': 10,
      'scroll': 0,
      'sharetext': "",
      'ads': true,
      'adsMode': "seconds",
      'adsIntervalSeconds': 6,
      'adsIntervalSongs': 5,
      'adsUrl': null,
      'covers': true,
      'coverRadio': true,
      'radioInterval': 30,
      'stats': false,
      'preload': "auto",
      'window': true
    }, options);

    return this.each(function () {
      var wrapper = $(this),
        $cvr_wrapper,
        $covers,
        $cover,
        $heading,
        $songInf,
        $playback,
        $seek,
        $progress,
        $currentTime,
        $duration,
        $prev,
        $repeat,
        $next,
        $shuffle,
        $share,
        $shareClose,
        $window,
        $plsToggle,
        $volume,
        $volumeSeek,
        $volumeValue,
        $pllst_container,
        $playlist,
        $playlistItem,
        $playlistSong,
        $download,
        $scroll_rail,
        $scroll_bar,
        $volume_modal,
        $f_num,
        $s_num,
        $t_num,
        $social_links,
        $share_modal,
        audio,
        adsAudio = new Audio(),
        playlist = settings.playlist,
        currentSong = settings.cursng,
        plsOpen = true,
        seeking = false,
        repeat = false,
        repeatMode = 'none',
        shuffleMode = false,
        shuffleArray = null,
        ads = false,
        isPaused = true,
        isStart = true,
        adsTime = 0,
        timeStarted = false,
        songCount = 0,
        adsList = null,
        adsCurrentAdsInList = 0,
        radioFlag = false,
        radioUpdate = null,
        updateNow = false,
        i,
        start = new Date().getTime(),
        time = 0,
        resize = null,
        svg = {
          play: "M0,0 10,5, 10,15 0,20z M10,5 20,10, 20,10 10,15z",
          pause: "M0,0 4,0, 4,20 0,20z M16,0 20,0, 20,20 16,20z",
          prev: "M10,0 0,10, 10,20z M20,0 10,10 20,20z",
          prev_anm: "M8,0 0,10, 8,20z M18,0 6,10 18,20z",
          repeat: "M3,5.5 15,5.5 15,8 20,4 15,0 15,2.5 0,2.5 0,13 3,10.6z M17,14.5 5,14.5 5,12 0,16 5,20 5,17.5 20,17.5 20,7 17,9.4z",
          repeatSong: "M3,5.5 15,5.5 15,8 20,4 15,0 15,2.5 0,2.5 0,13 3,10.6z M17,14.5 5,14.5 5,12 0,16 5,20 5,17.5 20,17.5 20,7 17,9.4z M8.5,7 11.5,7 11.5,13 8.5,13z",
          repeat_anm: "M6,7 13,7 13,9.5 18,5.5 13,1.5 13,4 3,4 3,14.5 6,12.1z M14,13 7,13 7,10.5 2,14.5 7,18.5 7,16 17,16 17,5.5 14,7.9z",
          next: "M0,0 10,10, 0,20z M10,0 20,10 10,20z",
          next_anm: "M2,0 14,10, 2,20z M12,0 20,10 12,20z",
          shuffle: "M20,0 13,0 15.4,2.4 0,18 2,20 17.6,4.6 20,7z M5.9,8.1 0,2 2,0 8.1,5.9z M20,20 20,13 17.6,15.4 14.1,11.9 11.9,14.1 15.4,17.6 13,20z",
          window_sq: "M20,20 0,20 0,0 10,0 10,3 3,3 3,17 17,17 17,10 20,10z",
          window_arrw: "M12,0 15,3 7,11 9,13 17,5 20,8 20,0Z",
          share: "M16.5,13c-0.9,0-1.6,0.3-2.3,0.8l-7.3-3.3C7,10.4,7,10.2,7,10c0-0.2,0-0.4-0.1-0.6l7.3-3.3C14.9,6.7,15.6,7,16.5,7C18.4,7,20,5.4,20,3.5S18.4,0,16.5,0c-1.9,0-3.4,1.5-3.5,3.4L5.2,6.9C4.7,6.7,4.1,6.5,3.5,6.5C1.6,6.5,0,8.1,0,10s1.6,3.5,3.5,3.5c0.6,0,1.2-0.2,1.7-0.4l7.8,3.5c0,1.9,1.6,3.4,3.5,3.4c1.9,0,3.5-1.6,3.5-3.5S18.4,13,16.5,13z",
          plsOpen: "M0,1 20,1 20,5 0,5z M0,8 20,8 20,12 0,12z M0,15 20,15 20,19 0,19z",
          plsClose: "M2.75,0 20,17.25 17.25,20 0,2.75z M10,8 10,8 10,12 10,12z M0,17 17,0 20,2.75 2.75,20z",
          volSpeaker: "M5,6H0v8h5l6.2,5.3V0.7L5,6z M5,6",
          volMute: "M5.7,8.6 4.2,7.2 2.8,8.6 1.4,7.2 0,8.6 1.4,10 0,11.4 1.4,12.8 2.8,11.4 4.2,12.8 5.7,11.4 4.2,10z",
          volB: "M18.6,10.7c0,3.1-1,6-2.5,8.3L17,20c1.9-2.5,3-5.9,3-9.3c0-4.1-1.5-7.9-4-10.7l-0.6,1.3  C17.4,3.7,18.6,7.1,18.6,10.7L18.6,10.7z M18.6,10.7",
          volM: "M14.7,2.5L14,3.9c1.4,1.9,2.1,4.3,2.1,6.8c0,2.3-0.6,4.3-1.6,6.1l0.9,1.1c1.4-2,2.1-4.5,2.1-7.2  C17.4,7.6,16.4,4.8,14.7,2.5L14.7,2.5z M14.7,2.5",
          volL: "M13.4,5.2l-0.6,1.5c0.6,1.2,1,2.5,1,4c0,1.3-0.4,2.7-0.9,3.9l0.9,1.2c0.7-1.5,1.2-3.2,1.2-4.9  C14.9,8.7,14.4,6.8,13.4,5.2L13.4,5.2z M13.4,5.2",
          vol_anm: "M10.3,10.2c0,0.9-0.3,1.8-0.7,2.5L9.8,13c0.6-0.8,0.9-1.8,0.9-2.8c0-1.2-0.4-2.4-1.2-3.2L9.3,7.4  C9.9,8.1,10.3,9.1,10.3,10.2L10.3,10.2z M10.3,10.2",
          vol_anm_m: "M18.8,8.6 17.4,7.2 16,8.6 14.6,7.2 13.2,8.6 14.6,10 13.2,11.4 14.6,12.8 16,11.4 17.4,12.8 18.8,11.4 17.4,10z",
          dwn: "M8.8,0v9H6l4,5l4-5h-2.8V0H8.8z M18,11v7H2v-7L0,9v8v3h20V9L18,11z",
          buy: "M20,3l-4-3v2H7v2h9v2L20,3z M4,16v-2l-4,3l4,3v-2h9v-2H4z M10,8h3V6h-2V5H9v1.2C7.8,6.5,7,7.5,7,8.5C7,9.9,8.3,11,10,11c0.3,0,0.6,0.2,0.6,0.5S10.3,12,10,12H7v2h2v1h2v-1.2c1.2-0.3,2-1.3,2-2.3c0-1.4-1.3-2.5-3-2.5C9.7,9,9.4,8.8,9.4,8.5S9.7,8,10,8z"
        };
      function buildPlayer() {
        var html;
        html =
          '<div class="wptpa_player_container">';
        if (settings.covers) {
          html +=
            '  <div class="wptpa_cvr_wrapper">' +
            '    <ul class="wptpa_covers">' +
            '    </ul>' +
            '  </div>';
        }
        html +=
          '  <div class="wptpa_player">' +
          '    <div class="wptpa_heading">' +
          '      <div class="wptpa_song_infrmtn" title=""> </div>' +
          '    </div>' +
          '    <div class="wptpa_control">' +
          '      <div class="wptpa_playback wptpa_btn">' +
          '        <svg class="wptpa_icon">' +
          '          <path d="' + svg.play + '" />' +
          '        </svg>' +
          '      </div>' +
          '      <div class="wptpa_seek">' +
          '        <div class="wptpa_progress"></div>' +
          '        <div class="wptpa_currenttime">00:00</div>' +
          '        <div class="wptpa_duration">00:00</div>' +
          '        <div class="wptpa_loader"><span></span><span></span><span></span></div>' +
          '      </div>' +
          '      <div class="wptpa_prev wptpa_btn">' +
          '        <svg class="wptpa_icon">' +
          '          <path d="' + svg.prev + '" />' +
          '        </svg>' +
          '      </div>' +
          '      <div class="wptpa_repeat wptpa_btn">' +
          '        <svg class="wptpa_icon">' +
          '          <path d="' + svg.repeat + '" />' +
          '        </svg>' +
          '      </div>' +
          '      <div class="wptpa_next wptpa_btn">' +
          '        <svg class="wptpa_icon">' +
          '          <path d="' + svg.next + '" />' +
          '        </svg>' +
          '      </div>';
        if (settings.shuffle) {
          html +=
            '      <div class="wptpa_shuffle wptpa_btn">' +
            '        <svg class="wptpa_icon">' +
            '          <path d="' + svg.shuffle + '" />' +
            '        </svg>' +
            '      </div>';
        }
        if (settings.share || settings.embed) {
          html +=
            '      <div class="wptpa_share wptpa_btn">' +
            '        <svg class="wptpa_icon">' +
            '          <path d="' + svg.share + '" />' +
            '        </svg>' +
            '      </div>';
        }
        if (settings.window) {
          html +=
            '      <div class="wptpa_window wptpa_btn">' +
            '        <svg class="wptpa_icon">' +
            '          <path d="' + svg.window_sq + '" />' +
            '          <path d="' + svg.window_arrw + '" />' +
            '        </svg>' +
            '      </div>';
        }
        html +=
          '    </div>';
        html +=
          '    <div class="wptpa_additional">';
        // проверяем, если плейлист состоит больше чем из одного трека, то выводим кнопку плейлиста
        if (settings.playlist.length > 1) {
          html +=
            '      <div class="wptpa_pls_toggle wptpa_btn">' +
            '        <svg class="wptpa_icon">' +
            '          <path d="' + svg.plsClose + '" />' +
            '        </svg>' +
            '      </div>';
        } else {
          // если плейлист состоит из одного трека
          // проверяем есть ли ссылка на покупку, если да выводим ее
          if (settings.playlist[0].buy !== "") {
            html +=
              '      <a target="_blank" title="Buy" href="' + settings.playlist[0].buy + '" class="wptpa_btn">' +
              '        <svg class="wptpa_icon">' +
              '          <path d="' + svg.buy + '" />' +
              '        </svg>' +
              '      </a>';
          }
          // проверяем есть ли ссылка на скачивание, если да выводим ее
          if (settings.playlist[0].dwn !== "") {
            html +=
              '      <a download title="Download" target="_blank" href="' + settings.playlist[0].dwn + '" class="wptpa_btn wptpa_dwn">' +
              '        <svg class="wptpa_icon">' +
              '          <path d="' + svg.dwn + '"/>' +
              '        </svg>' +
              '      </a>';
          }
          // если нету не одной из ссылок выводим заглушку
          if (settings.playlist[0].dwn === "" && settings.playlist[0].buy === "") {
            html += '<div></div>';
          }
        }
        html +=
          '      <div class="wptpa_volume_control">' +
          '        <div class="wptpa_volume wptpa_btn">' +
          '          <svg class="wptpa_icon">' +
          '            <path class="volspeaker" d="' + svg.volSpeaker + '" />' +
          '            <path class="volmute" d="' + svg.volMute + '" />' +
          '            <path class="volb" d="' + svg.volB + '" />' +
          '            <path class="volm" d="' + svg.volM + '" />' +
          '            <path class="voll" d="' + svg.volL + '" />' +
          '          </svg>' +
          '        </div>' +
          '        <div class="wptpa_volume_seek">' +
          '          <div class="wptpa_volume_value"></div>' +
          '        </div>' +
          '      </div>' +
          '    </div>' +
          '  </div>' +
          '</div>' +
          '<div class="wptpa_pllst_container">' +
          '  <ul class="wptpa_pllst plsopn">' +
          '  </ul>' +
          '  <div class="wptpa_scroll_rail">' +
          '    <div class="wptpa_scroll_bar"></div>' +
          '  </div>' +
          '</div>' +
          '<div class="wptpa_volume_modal">' +
          '  <ul class="wptpa_f_num"></ul>' +
          '  <ul class="wptpa_s_num"></ul>' +
          '  <ul class="wptpa_t_num"></ul>' +
          '</div>' +
          '<div class="wptpa_share_modal">' +
          '  <h2 class="wptpa_h2">Share:</h2>' +
          '  <div class="wptpa_close_share">' +
          '    <svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="20px" height="20px" viewBox="0 0 20 20" enable-background="new 0 0 20 20" xml:space="preserve">' +
          '      <line stroke-width="4" stroke-linecap="round" stroke-miterlimit="10" x1="2" y1="2" x2="18" y2="18"/>' +
          '      <line stroke-width="4" stroke-linecap="round" stroke-miterlimit="10" x1="18" y1="2" x2="2" y2="18"/>' +
          '    </svg>' +
          '  </div>';
        if (settings.share) {
          html += '  <div class="wptpa_links">' +
            '    <a target="_blank" class="wptpa_social_links" href="http://www.facebook.com/sharer.php?u=' + encodeURIComponent(location.href) + '">' +
            '      <svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 40 40" enable-background="new 0 0 40 40" xml:space="preserve" class="wptpa_social_icon" width="30px">' +
            '        <path d="M30,0l-5.2,0c-5.8,0-9.6,3.9-9.6,9.8v4.5H10c-0.4,0-0.8,0.4-0.8,0.8v6.6c0,0.4,0.4,0.8,0.8,0.8h5.2v16.6            c0,0.4,0.4,0.8,0.8,0.8h6.8c0.5,0,0.8-0.4,0.8-0.8V22.6h6.1c0.5,0,0.8-0.4,0.8-0.8l0-6.6c0-0.2-0.1-0.4-0.2-0.6c-0.2-0.2-0.4-0.2-0.6-0.2h-6.1v-3.8c0-1.8,0.4-2.8,2.8-2.8l3.5,0c0.5,0,0.8-0.4,0.8-0.8V0.8C30.8,0.4,30.4,0,30,0L30,0z M30,0"/>' +
            '      </svg>' +
            '    </a>' +
            '    <a target="_blank" class="wptpa_social_links" href="http://twitter.com/share?text=' + encodeURIComponent(settings.sharetext) + '&url=' + encodeURIComponent(location.href) + '">' +
            '      <svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="-4 0 48 40" enable-background="new -4 0 48 40" xml:space="preserve" class="wptpa_social_icon" width="36px">' +
            '        <path d="M43.3,4.8c-1.1,0.5-2.1,0.8-3.3,1.1c1.2-1.2,2.1-2.6,2.7-4.3l0,0c0.1-0.4-0.4-0.8-0.8-0.6l0,0c-1.6,1-3.2,1.7-5,2c-0.1,0-0.2,0-0.4,0c-0.4,0-0.6-0.1-0.8-0.4C33.7,1,31.3,0,28.8,0c-1.1,0-2.1,0.1-3.2,0.5c-3.3,1.1-6,3.8-6.7,7.2c-0.4,1.3-0.4,2.5-0.2,3.8c0,0.1,0,0.2-0.1,0.2c-0.1,0.1-0.1,0.1-0.2,0.1l0,0C10.9,11.5,4.2,7.9-0.4,2.1l0,0C-0.7,1.9-1,1.9-1.3,2.3l0,0c-1,1.6-1.4,3.3-1.4,5.1c0,2.7,1.1,5.4,3.1,7.3c-0.8-0.2-1.7-0.5-2.4-1l0,0c-0.4-0.2-0.8,0-0.8,0.5l0,0c0,4.2,2.4,7.9,6,9.6c-0.1,0-0.1,0-0.2,0c-0.6,0-1.2,0-1.8-0.1l0,0c-0.4-0.1-0.7,0.4-0.6,0.7l0,0c1.2,3.7,4.3,6.4,8.1,7C5.5,33.6,1.8,34.6-2,34.6h-1.2c-0.4,0-0.7,0.2-0.7,0.6c-0.1,0.4,0.1,0.7,0.4,1C0.8,38.7,5.7,40,10.7,40c4.4,0,8.5-0.8,12.2-2.6c3.3-1.6,6.3-3.8,8.8-6.7c2.4-2.6,4.2-5.7,5.5-9.1c1.2-3.2,1.8-6.7,1.8-9.9v-0.1c0-0.5,0.2-1.1,0.6-1.3c1.6-1.3,3-2.7,4.1-4.5l0,0C44.2,5.1,43.8,4.7,43.3,4.8L43.3,4.8z"/>' +
            '      </svg>' +
            '    </a>' +
            '    <a target="_blank" class="wptpa_social_links" href="https://www.tumblr.com/widgets/share/tool?shareSource=legacy&canonicalUrl=' + encodeURIComponent(location.href) + '">' +
            '      <svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 40 40" enable-background="new 0 0 40 40" xml:space="preserve" class="wptpa_social_icon" width="30px">' +
            '        <path d="M29.4,31.8c0,0-1.2,1.4-3.4,1.4s-3.3-1.4-3.3-3.4c0-0.8,0-5.8,0-11.4H30v-6.9h-7.3c0-6.1,0-11.4,0-11.4h-5.5 C16.4,5.1,13,9.4,8.4,11.5v6.9h5.4c0,6.7,0,12.7,0,13.2c0,1.8,1.7,8.5,10.5,8.5c5.2,0,7.3-3.3,7.3-3.3L29.4,31.8z"/>' +
            '      </svg>' +
            '    </a>' +
            '  </div>';
        }
        if (settings.embed) {
          html += '  <p class="wptpa_embed_code">&lt;iframe src="' + wptpa_data.siteurl + '?do=wptpa&id=' + settings.playlistId + '&autoplay=false&compact=false&cursng=0&curtm=0&curvlm=100&pls=true" frameborder="0" width="100%" height="100%" align="left" scrolling="no" seamless&gt;&lt;/iframe&gt;</p>';
        }
        html += '</div>' +
          '<audio id="wptpa_audio" src=""></audio>';
        wrapper.html(html);
        
      }
      
      function updateStat() {
        var updateItem = currentSong, data;
        //обновляем статистику
        data = {
          action: "wptpa_update_stat",
          song_id: playlist[updateItem].id,
          time: audio.currentTime
        };
        if (data.time > 30) {
          jQuery.post(wptpa_data.ajaxurl, data, function () {
            //console.log(response);
            playlist[updateItem].all_count = parseInt(playlist[updateItem].all_count, 10) + 1;
            $playlistItem.eq(updateItem).find(".wptpa_play_cnt").attr("title", playlist[updateItem].all_count + " Plays");
            if (playlist[updateItem].all_count >= 1000) {
              $playlistItem.eq(updateItem).find(".wptpa_play_cnt").html((playlist[updateItem].all_count / 1000).toFixed(2) + "K");
            } else {
              $playlistItem.eq(updateItem).find(".wptpa_play_cnt").html(playlist[updateItem].all_count);
            }
          });
        }
      }
      // при переходе или закрытии страницы
      window.onbeforeunload = function () {
        updateStat();
      };
      
      // слайдинг названия если не помещается
      function slidingSngCheck() {
        // если ширина контейнера больше, чем ширина родительского контейнера, вешаем класс скрола если меньше - удаляем
        if ($songInf.width() > $heading.width()) {
          if (!$heading.hasClass("scrll")) {
            $heading.animate({
              "opacity": 0
            }, 150, function () {
              $heading.addClass("scrll");
              $heading.animate({
                "opacity": 1
              }, 150);
            });
          }
        } else {
          $heading.removeClass("scrll");
        }
      }
      
      
      // реклама с интервалом в секунды
      function adsBySeconds() {
        // таймер рекламы
        window.setInterval(function () {
          timeStarted = true;
          if (!isPaused) {
            adsTime++;
            if (adsTime === settings.adsIntervalSeconds) {
              adsAudio.play();
            }
          }
          console.log(adsTime);
        }, 1000);
      }
      
      // реклама через количество треков
      function adsBySongs() {
        if (songCount === settings.adsIntervalSongs) {
          adsAudio.play();
          songCount = 0;
        }
      }
      
      // проиграть рекламу при первом воспроизведении
      function adsByStart() {
        if (isStart) {
          adsAudio.play();
          isStart = false;
        }
      }
      
      function adsControl() {
        // проверяем какой тип рекламы включен
        switch (settings.adsMode) {
        case "seconds":
          // проверяем не запущен ли таймер
          if (!timeStarted) {
            adsBySeconds();
          }
          break;
        case "songs":
          adsBySongs();
          break;
        case "start":
          adsByStart();
          break;
        }
      }
      
      
      // compactMode
      function compactMode() {
        // запускаем проверку слайдинга названия трека
        slidingSngCheck();
        // если есть обложка
        if (settings.covers) {
        // проверяем если ширина плеера меньше 600 пкс или включен режим компакт вешаем класс, иначе иудаляем
          if (wrapper.width() < 600 || settings.compactMode) {
            wrapper.addClass("wptpa_widget");
            $cvr_wrapper.css("height", $cvr_wrapper.width());
            // задаем высоту обложкам
            $cover.css("height", $cvr_wrapper.width());
            // обновляем их позицию
            $covers.css({
              top: -($cover.height() * currentSong)
            });
          } else {
            wrapper.removeClass("wptpa_widget");
            $cvr_wrapper.css("height", 200);
            // задаем высоту обложкам
            $cover.css("height", 200);
            // обновляем их позицию
            $covers.css({
              top: -(200 * currentSong)
            });
          }
        } else {
          if (wrapper.width() < 400 || settings.compactMode) {
            wrapper.addClass("wptpa_widget");
            $cvr_wrapper.css("height", $cvr_wrapper.width());
            // задаем высоту обложкам
            $cover.css("height", $cvr_wrapper.width());
            // обновляем их позицию
            $covers.css({
              top: -($cover.height() * currentSong)
            });
          } else {
            wrapper.removeClass("wptpa_widget");
            $cvr_wrapper.css("height", 200);
            // задаем высоту обложкам
            $cover.css("height", 200);
            // обновляем их позицию
            $covers.css({
              top: -(200 * currentSong)
            });
          }
        }

      }
      
      function timer() {
        time += 100;
        var diff = (new Date().getTime() - start) - time;
        window.setTimeout(timer, (100 - diff));
        compactMode();
      }

      
      // create shuffle array
      function shuffle() {
        var array = [], j = 0, temp = null;
        // создаем массив чисел от 0 до длины плейлиста
        for (i = 0; i < playlist.length; i++) {
          array.push(i);
        }
        i = 0;
        // перемешиваем массив и возвращаем его
        for (i = array.length - 1; i > 0; i--) {
          j = Math.floor(Math.random() * (i + 1));
          temp = array[i];
          array[i] = array[j];
          array[j] = temp;
        }
        return array;
      }
      
      // функция проверки нужен ли 0 в начале
      Number.prototype.lead0 = function (n) {
        var nz = this.toString();
        while (nz.length < n) {
          nz = "0" + nz;
        }
        return nz;
      };

      // time convert
      function timeConvert(sec) {
        if (!sec) {
          sec = 0;
        }
        var
          m = Math.floor(sec / 60),
          s = Math.floor(sec % 60);
        return m.lead0(2) + ":" + s.lead0(2);
      }
      
      // обновление время
      function timeupdate() {
        // если нет сикинга обновляем время
        if (!seeking) {
          $currentTime.text(timeConvert(audio.currentTime));
          if (!radioFlag) {
            $progress.css("width", (audio.currentTime * 100 / audio.duration) + "%");
          }
        }
      }
      
      function getTitle() {
        if (!updateNow) {
          updateNow = true;
          var data = {
            "action": "wptpa_getCurrentSong",
            "url": playlist[currentSong].audio,
            "cover": settings.coversRadio
          };
          jQuery.post(wptpa_data.ajaxurl, data, function (response) {
            updateNow = false;
            var data = $.parseJSON(response);
            console.log(data);
            if (data.artist) {
              $songInf
                .attr("title", data.title !== "" ? data.artist + " - " + data.title : data.artist)
                .html(data.title !== "" ? "<b>" + data.artist + "</b> - " + data.title : "<b>" + data.artist + "</b>");
              slidingSngCheck();
            } else {
              $songInf
                .attr("title", playlist[currentSong].title !== "" ? playlist[currentSong].artist + " - " + playlist[currentSong].title : playlist[currentSong].artist)
                .html(playlist[currentSong].title !== "" ? "<b>" + playlist[currentSong].artist + "</b> - " + playlist[currentSong].title : "<b>" + playlist[currentSong].artist + "</b>");
              slidingSngCheck();
            }
            if (data.cover) {
              $cover.eq(currentSong).find("img").attr("src", data.cover);
            } else {
              $cover.eq(currentSong).find("img").attr("src", playlist[currentSong].cover);
            }
          });
        }
      }
      
      // воспроизведение
      function play() {
        // делаем задержку проверки фикс для автоплей
        setTimeout(function () {
          //console.log(radioFlag);
          if (radioFlag) {
            getTitle();
            clearInterval(radioUpdate);
            radioUpdate = setInterval(function () {
              getTitle();
            }, settings.radioInterval * 1000);
          } else {
            clearInterval(radioUpdate);
          }
        }, settings.radioInterval * 1000);

        // проверяем каждый аудио контейнер, если это не текущий плеер останавливаем его
        $("body").find("audio").each(function (index, value) {
          if (value.src !== audio.src) {
            value.pause();
          }
        });
        
        // ads controll
        if(settings.ads) {
          isPaused = false; // запускаем таймер рекламы
          adsControl();
        }
        
        // меняем кнопку на паузу и добавляем клас для текущего трека
        $playback.find("path").attr("d", svg.pause);
        $playlistItem.eq(currentSong).addClass("crrnt");
      }
      
      // пауза
      function pause() {
        //console.log("pause");
        //обновляем статистику
        updateStat();
        clearInterval(radioUpdate);
        // меняем кнопку на паузу и удаляем клас для текущего трека
        $playback.find("path").attr("d", svg.play);
        $playlistItem.removeClass("crrnt");
        isPaused = true; // останавливаем таймер рекламы
      }
      
      // loadstart
      function loadstart() {
        jQuery(".wptpa_loader").fadeIn();
        //console.log("loadstart");
      }
      
      // отображения уровня громкости
      function volumeTxt(value) {
        var f, s, t, w, num = value.toString();
        // если число меньше 10, первый ряд 0, второй 0, третий значение, ширина контейнера 200, прячем первый и второй ряд
        if (num < 10) {
          f = 0;
          s = 11;
          t = num;
          w = 200;
          $f_num.hide();
          $s_num.hide();
        }
        // если число из двух цифр, первый ряд 0, второй значение, третий значение, ширина контейнера 300, прячем первый  ряд
        if (num.length > 1) {
          f = 0;
          s = num.substr(0, 1);
          t = num.substr(1, 1);
          w = 300;
          $f_num.hide();
          $s_num.show();
        }
        // если число из трех цифр, первый ряд 1, второй 0, третий 0, ширина контейнера 400, показываем все рядки
        if (num.length > 2) {
          f = 1;
          s = t = 10;
          w = 400;
          $f_num.show();
          $s_num.show();
        }
        // задем ширину контейнера
        $volume_modal.css({
          width: w
        });
        // анимируем цифры
        $f_num.stop(true, true).animate({
          top: -f * 200
        }, 400, 'easeOutCirc');
        $s_num.stop(true, true).animate({
          top: -s * 200
        }, 400, 'easeOutCirc');
        $t_num.stop(true, true).animate({
          top: -t * 200
        }, 400, 'easeOutCirc');
      }
      
      // volumechange
      function volumechange() {
        // задаем ширину значения громкости
        $volumeValue.css("width", audio.volume * 100 + "%");
        // анимации иконки в зависимости от значения
        if (audio.volume < 0.75) {
          $volume.find(".volb").attr("d", svg.vol_anm);
        } else {
          $volume.find(".volb").attr("d", svg.volB);
        }
        if (audio.volume < 0.5) {
          $volume.find(".volm").attr("d", svg.vol_anm);
        } else {
          $volume.find(".volm").attr("d", svg.volM);
        }
        if (audio.volume < 0.25) {
          $volume.find(".voll").attr("d", svg.vol_anm);
        } else {
          $volume.find(".voll").attr("d", svg.volL);
        }
        if (audio.volume === 0) {
          $volume.find(".volmute").attr("d", svg.vol_anm_m);
        } else {
          $volume.find(".volmute").attr("d", svg.volMute);
        }
      }
      
      // событие при загрузки метадаты
      function loadedmetadata() {
        jQuery(".wptpa_loader").fadeOut();
        //console.log("loadedmetadata");
        // отсылаем ссылку, если есть порт, значит радио, иначе аудио
        var data = {
          "action": "wptpa_getType",
          "url": playlist[currentSong].audio
        };
        jQuery.post(wptpa_data.ajaxurl, data, function (response) {
          if (response === "true") {
            radioFlag = true;
          } else {
            radioFlag = false;
          }
          //console.log(radioFlag);
        });
        
        audio.addEventListener("timeupdate", timeupdate, false);
        // задаем громкость
        if (audio.muted) {
          audio.volume = 0;
        } else {
          audio.volume = settings.volume / 100;
        }
        // задаем ширину значения громкости
        $volumeValue.css("width", audio.volume * 100 + "%");
        // устанавливаем продолжительность трека
        // проверяем если есть продолжительность устанавливаем его, если нет, то нули
        if ($.isNumeric(audio.duration)) {
          $duration.text(timeConvert(audio.duration));
        } else {
          $duration.text("00:00");
        }
        //создаем сиккинг трека
        $seek.slider({
          min: 0,
          max: audio.duration,
          orientation: "horizontal",
          range: false,
          step: 0.01,
          start: function (event, ui) {
            if (ads || radioFlag) {
              return false;
            } else {
              seeking = true;
              $progress.css("width", (ui.value * 100 / audio.duration) + "%");
              $currentTime.text(timeConvert(ui.value));
            }
          },
          slide: function (event, ui) {
            if (ads || radioFlag) {
              return false;
            } else {
              $progress.css("width", (ui.value * 100 / audio.duration) + "%");
              $currentTime.text(timeConvert(ui.value));
            }
          },
          stop: function (event, ui) {
            if (ads || radioFlag) {
              return false;
            } else {
              seeking = false;
              $progress.css("width", (ui.value * 100 / audio.duration) + "%");
              $currentTime.text(timeConvert(ui.value));
              audio.currentTime = ui.value;
            }
          }
        });
        
        //создаем слайдер громкости
        $volumeSeek.slider({
          min: 0,
          max: 100,
          step: 1,
          orientation: "horizontal",
          range: false,
          slide: function (event, ui) {
            if (ui.value === 0) {
              audio.muted = true;
            } else {
              audio.muted = false;
            }
            volumeTxt(ui.value);
            audio.volume = ui.value / 100;
            adsAudio.volume = ui.value / 100;
            settings.volume = ui.value;
          },
          start: function () {
            $volume_modal.addClass("wptpa_vol_show");
          },
          stop: function () {
            $volume_modal.removeClass("wptpa_vol_show");
            var data = {
              action: 'volume_change',
              volume: audio.volume * 100
            };
            jQuery.post(wptpa_data.ajaxurl, data, function () {
              //console.log(response);
            });
          }
        });
      }
      
      function error(e) {
        console.log(e.target.error.message);
      }
      
      // загрузка трека
      function songChange() {
        var prevIndex = $playlist.find(".crrnt").index(),
          snginf = playlist[currentSong],
          startVal,
          middleVal,
          endVal = 0;
        // удаляем класс текущего трека
        $playlistItem.removeClass("crrnt");
        // получаем урл трека и загружаем его
        audio.src = snginf.audio;
        audio.preload = settings.preload;
        audio.load();
        audio.currentTime = settings.curtm;
        // вычесляем в каком направлении слайдить название
        if (prevIndex < currentSong) {
          startVal = "-30px";
          middleVal = "30px";
        } else {
          startVal = "30px";
          middleVal = "-30px";
        }
        // анимируем cover
        $covers.stop(true, true).animate({
          top: -($cover.height() * currentSong)
        }, 300, "easeInOutCirc");
        
        // анимируем название
        $songInf.stop(true, true).animate({
          top: startVal
        }, 150, "easeInCirc", function () {
          $songInf
            .attr("title", snginf.title !== "" ? snginf.artist + " - " + snginf.title : snginf.artist)
            .html(snginf.title !== "" ? "<b>" + snginf.artist + "</b> - " + snginf.title : "<b>" + snginf.artist + "</b>")
            .css("top", middleVal)
            .stop(true, true)
            .animate({
              top: endVal
            }, 150, "easeOutCirc");
          slidingSngCheck();
        });
        
        
        // подключаем события
        audio.addEventListener("loadedmetadata", loadedmetadata, false);
        
        audio.addEventListener("play", play, false);
        audio.addEventListener("pause", pause, false);
        audio.addEventListener("loadstart", loadstart, false);
        audio.addEventListener("ended", ended, false);
        audio.addEventListener("volumechange", volumechange, false);
        audio.addEventListener("error", error, false);
        
        //autoplay
        if (settings.autoplay) {
          //var playPromise = audio.play();
          audio.play();
        }
      }
      
      // по окончанию трека
      function ended() {
        if (repeatMode == "song") {
          // cancel all and repeat
          var prevSong = currentSong;
          currentSong = prevSong;
          // обновляем данные о треке
          songChange();
          // воспроизводим
          audio.play();
        } else {
          // если включен рендом
          if (shuffleArray) {
            // получаем рендомное значение индекса трека
            currentSong = shuffleArray[0];
            // проверяем если в массиве больше 1 значения берем и скоращаем его, в противном случае обновляем массив
            if (shuffleArray.length > 1) {
              shuffleArray.splice(0, 1);
            } else {
              shuffleArray = shuffle();
            }
            // обновляем данные о треке
            songChange();
            // воспроизводим
            audio.play();
          } else {
            // если не последний трек из плейлиста и не включено повторение трека, берем следующий воспроизводим
            if (currentSong < playlist.length - 1) {
              currentSong = currentSong + 1;
              // обновляем данные о треке
              songChange();
              // воспроизводим
              audio.play();
            } else {
              // если трек последний, проверяем включен ли репит, если да берем превый трек из плейлиста
              if (repeat) {
                if (repeatMode == "playlist") {
                  currentSong = 0;
                }
                // обновляем данные о треке
                songChange();
                // воспроизводим
                audio.play();
              } else {
                // иначе просто останавливаем работу
                audio.currentTime = 0;
              }
            }
          }
        }
        
        // если есть скролл обновляем его 
        if (settings.scroll) {
          $scroll_rail.slider("value", playlist.length - settings.scroll - currentSong);
          $playlistItem.css({
            "padding-right": "10px"
          });
        }
        songCount++;
        if(settings.ads) {
          adsControl();
        }
      }
      
      
      // открытие/закрытие плейлиста
      function playlistToggle() {
        // если открыт меняем иконки и наоборот
        if (plsOpen) {
          $plsToggle.find("path").attr("d", svg.plsOpen);
        } else {
          $plsToggle.find("path").attr("d", svg.plsClose);
        }
        // открываем плейлист
        $playlist.slideToggle(250, function () {
          $playlist.toggleClass("plsopn");
        });
        // меняем значение флага
        plsOpen = !plsOpen;
      }
      
      // рендерим плеер
      function renderPlayer() {
        // заполняем контейнеры
        audio = wrapper.find("#wptpa_audio")[0];
        $cvr_wrapper = wrapper.find(".wptpa_cvr_wrapper");
        $covers = wrapper.find(".wptpa_covers");
        $heading = wrapper.find(".wptpa_heading");
        $songInf = wrapper.find(".wptpa_song_infrmtn");
        $playback = wrapper.find(".wptpa_playback");
        $seek = wrapper.find(".wptpa_seek");
        $progress = wrapper.find(".wptpa_progress");
        $currentTime = wrapper.find(".wptpa_currenttime");
        $duration = wrapper.find(".wptpa_duration");
        $prev = wrapper.find(".wptpa_prev");
        $repeat = wrapper.find(".wptpa_repeat");
        $next = wrapper.find(".wptpa_next");
        $shuffle = wrapper.find(".wptpa_shuffle");
        $share = wrapper.find(".wptpa_share");
        $shareClose = wrapper.find(".wptpa_close_share");
        $window = wrapper.find(".wptpa_window");
        $plsToggle = wrapper.find(".wptpa_pls_toggle");
        $volume = wrapper.find(".wptpa_volume");
        $volumeSeek = wrapper.find(".wptpa_volume_seek");
        $volumeValue = wrapper.find(".wptpa_volume_value");
        $pllst_container = wrapper.find(".wptpa_pllst_container");
        $playlist = wrapper.find(".wptpa_pllst");
        $scroll_rail = wrapper.find(".wptpa_scroll_rail");
        $scroll_bar = wrapper.find(".wptpa_scroll_bar");
        $volume_modal = wrapper.find(".wptpa_volume_modal");
        $f_num = wrapper.find(".wptpa_f_num");
        $s_num = wrapper.find(".wptpa_s_num");
        $t_num = wrapper.find(".wptpa_t_num");
        $share_modal = wrapper.find(".wptpa_share_modal");
        $social_links = wrapper.find(".wptpa_social_links");
        $f_num.append('<li class="wptpa_num"></li>');
        $f_num.append('<li class="wptpa_num">1</li>');
        // формирируем цифры для громкости
        for (i = 0; i < 10; i++) {
          $s_num.append('<li class="wptpa_num">' + i + '</li>');
          $t_num.append('<li class="wptpa_num">' + i + '</li>');
        }
        $s_num.append('<li class="wptpa_num">0</li>');
        $t_num.append('<li class="wptpa_num">0</li>');
        $s_num.append('<li class="wptpa_num"></li>');
        $t_num.append('<li class="wptpa_num"></li>');
        // если плейлист меньше двух треков, удаляем кнопки, и не создаем плейлист
        if (playlist.length < 2) {
          $prev.remove();
          $next.remove();
          $shuffle.remove();
          $scroll_rail.remove();
          var html = '<li class="wptpa_cover">';
          html += '<img src="' + settings.playlist[0].cover + '" />';
          if (settings.stats) {
            html += '<div class="wptpa_single_stats">';
            html += '<div class="wptpa_play_cnt" title="' + settings.playlist[0].all_count + ' Plays">' + settings.playlist[0].all_count + '</div>';
            if (settings.playlist[0].all_dwn > 0) {
              html += '<hr class="wptpa_line">';
              html += '<div class="wptpa_dwn_cnt" title="' + settings.playlist[0].all_dwn + ' Downloads">' + settings.playlist[0].all_dwn + '</div>';
            }
            html += '</div>';
          }
          html += '</li>';
          $covers.append(html);
        } else {
          // создаем плейлист
          $.each(playlist, function (index, value) {
            var html = '<li class="wptpa_pllst_itm">';
            html += '  <div class="wptpa_curent"><div class="wptpa_bars"></div></div>';
            if (value.title !== "") {
              html += '  <div class="wptpa_song" title="' + value.artist + ' - ' + value.title + '"><b>' + value.artist + '</b> - ' + value.title + '</div>';
            } else {
              html += '  <div class="wptpa_song" title="' + value.artist + '"><b>' + value.artist + '</b> </div>';
            }
            if (settings.stats) {
              if (value.all_count > 1000) {
                html += '<hr class="wptpa_line"><div class="wptpa_play_cnt" title="' + value.all_count + ' Plays">' + (value.all_count / 1000).toFixed(2) + 'K</div>';
              } else {
                html += '<hr class="wptpa_line"><div class="wptpa_play_cnt" title="' + value.all_count + ' Plays">' + value.all_count + '</div>';
              }
              if (value.all_dwn > 0) {
                if (value.all_dwn > 1000) {
                  html += '<hr class="wptpa_line"><div class="wptpa_dwn_cnt" title="' + value.all_dwn + ' Downloads">' + (value.all_dwn / 100).toFixed(2) + 'K</div>';
                } else {
                  html += '<hr class="wptpa_line"><div class="wptpa_dwn_cnt" title="' + value.all_dwn + ' Downloads">' + value.all_dwn + '</div>';
                }
              }
            }
            if (value.buy !== "") {
              html += '<hr class="wptpa_line"><a target="_blank" title="Buy" href="' + value.buy + '" class="wptpa_buy"><svg class="wptpa_icon"><path d="M30,13 26,10 26,12 17,12 17,14 26,14 26,16z M14,26 14,24 10,27 14,30 14,28 23,28 23,26z M20,18h3v-2h-2v-1h-2v1.2c-1.2,0.3-2,1.3-2,2.3c0,1.4,1.3,2.5,3,2.5c0.3,0,0.6,0.2,0.6,0.5S20.3,22,20,22h-3v2h2v1h2v-1.2c1.2-0.3,2-1.3,2-2.3c0-1.4-1.3-2.5-3-2.5c-0.3,0-0.6-0.2-0.6-0.5C19.4,18.2,19.7,18,20,18z" /></svg></a>';
            }
            if (value.dwn !== "") {
              html += '<hr class="wptpa_line"><a download title="Download" target="_blank" href="' + value.dwn + '" class="wptpa_dwn"><svg class="wptpa_icon"><path d="M18.8,10 18.8,19 16,19 20,24 24,19 21.2,19 21.2,10z M28,21 28,28 12,28 12,21 10,19 10,27 10,30 30,30 30,19z" /></svg></a>';
            }
            html += "</li>";
            $playlist.append(html);
            html = '<li class="wptpa_cover"><img src="' + value.cover + '" /></li>';
            $covers.append(html);
          });
        }
        // заполняем контейнеры
        $playlistItem = wrapper.find(".wptpa_pllst_itm");
        $playlistSong = wrapper.find(".wptpa_song");
        $download = wrapper.find(".wptpa_dwn");
        $cover = wrapper.find(".wptpa_cover");
        
        // если включен скрол создаем его
        if (settings.scroll) {
          // задоем высоту плейлиста
          $pllst_container.css({
            "max-height": settings.scroll * 40
          });
          $playlistItem.css({
            "padding-right": "10px"
          });
          // создаем слайдер
          $scroll_rail.slider({
            orientation: "vertical",
            min: 0,
            max: playlist.length - settings.scroll,
            step: 1,
            value: playlist.length - settings.scroll,
            slide: function (event, ui) {
              $playlist.stop(true, true).animate({
                top: -(playlist.length - settings.scroll - ui.value) * 40
              }, 250);
              $scroll_bar.stop(true, true).animate({
                bottom: 100 - (playlist.length - settings.scroll - ui.value) * 100 / (playlist.length - settings.scroll) + "%"
              }, 250);
            },
            change: function (event, ui) {
              $playlist.stop(true, true).animate({
                top: -(playlist.length - settings.scroll - ui.value) * 40
              }, 250);
              $scroll_bar.stop(true, true).animate({
                bottom: 100 - (playlist.length - settings.scroll - ui.value) * 100 / (playlist.length - settings.scroll) + "%"
              }, 250);
            }
          });
        } else {
          // если не включен скрол удаляем его
          $scroll_rail.remove();
        }
        // проверяем нужен ли компактный режим
        compactMode();
        
        //выбор трека
        $playlistSong.on("click", function () {
          // если звучит аудиореклама отменяем все действия
          if (ads) {
            return false;
          } else {
            //обновляем статистику
            updateStat();
            audio.pause();
            currentSong = $(this).parent().index();
            songChange();
            audio.play();
          }
        });
        
        //скачать трек
        $download.on("click", function () {
          var song_id, itemIndex, data;
          if (playlist.length > 1) {
            song_id = playlist[$(this).parent().index()].id;
            itemIndex = $(this).parent().index();
          } else {
            song_id = playlist[0].id;
            itemIndex = 0;
          }
          data = {
            action: "wptpa_update_stat_dwn",
            song_id: song_id
          };
          jQuery.post(wptpa_data.ajaxurl, data, function () {
            //console.log(response);
            playlist[itemIndex].all_dwn = parseInt(playlist[itemIndex].all_dwn, 10) + 1;
            if (playlist.length > 1) {
              $playlistItem.eq(itemIndex).find(".wptpa_dwn_cnt").attr("title", playlist[itemIndex].all_dwn + " Downloads");
              if (playlist[itemIndex].all_count >= 1000) {
                $playlistItem.eq(itemIndex).find(".wptpa_dwn_cnt").html((playlist[itemIndex].all_dwn / 1000).toFixed(2) + "K");
              } else {
                $playlistItem.eq(itemIndex).find(".wptpa_dwn_cnt").html(playlist[itemIndex].all_dwn);
              }
            } else {
              wrapper.find(".wptpa_dwn_cnt").attr("title", playlist[itemIndex].all_dwn + " Downloads");
              if (playlist[itemIndex].all_count >= 1000) {
                wrapper.find(".wptpa_dwn_cnt").html((playlist[itemIndex].all_dwn / 1000).toFixed(2) + "K");
              } else {
                wrapper.find(".wptpa_dwn_cnt").html(playlist[itemIndex].all_dwn);
              }
            }
            
          });
        });
          
        // плей/пауз
        $playback.on("click", function () {
          // если звучит аудиореклама отменяем все действия
          if (ads) {
            return false;
          } else {
            if (audio.paused) {
              audio.play();
            } else {
              audio.pause();
            }
          }
        });
          
        // пред трек
        $prev.on("click", function () {
          if (ads) {
            return false;
          } else {
            if (repeatMode == "song") {
              var prevSong = currentSong;
              currentSong = prevSong;
            } else {
              $progress.css("width", "0%");
              //обновляем статистику
              updateStat();
              // если включен рендом
              if (shuffleArray) {
                currentSong = shuffleArray[0];
                if (shuffleArray.length > 1) {
                  shuffleArray.splice(0, 1);
                } else {
                  shuffleArray = shuffle();
                }
              } else {
                if (currentSong !== 0) {
                  currentSong = currentSong - 1;
                } else {
                  if (repeat) {
                    if (repeatMode == "playlist") {
                      currentSong = playlist.length - 1;
                    }
                  } else {
                    currentSong = 0;
                  }
                }
              }
            }
            // если есть скролл
            if (settings.scroll) {
              $playlistItem.css({
                "padding-right": "10px"
              });
              $scroll_rail.slider("value", playlist.length - settings.scroll - currentSong);
            }

            songChange();
            audio.play();
            $prev.find("path").attr("d", svg.prev_anm);
            setTimeout(function () {
              $prev.find("path").attr("d", svg.prev);
            }, 250);
          }
        });
          
        // repeat playlist/song
        $repeat.on("click", function () {
          // устанавливаем режим, в зависимости от предыдущего состояния
          switch (repeatMode) {
          case "none":
            repeatMode = "playlist";
            repeat = true;
            $repeat.addClass('actv');
            $repeat.find("path").attr("d", svg.repeat_anm);
            setTimeout(function () {
              $repeat.find("path").attr("d", svg.repeat);
            }, 250);
            break;
          case "playlist":
            repeatMode = "song";
            repeat = true;
            $repeat.find("path").attr("d", svg.repeat_anm);
            setTimeout(function () {
              $repeat.find("path").attr("d", svg.repeatSong);
            }, 250);
            break;
          case "song":
            repeatMode = "none";
            repeat = false;
            $repeat.removeClass('actv');
            $repeat.find("path").attr("d", svg.repeat_anm);
            setTimeout(function () {
              $repeat.find("path").attr("d", svg.repeat);
            }, 250);
            break;
          }
        });
          
        // след трек
        $next.on("click", function () {
          if (ads) {
            return false;
          } else {
            if (repeatMode == "song") {
              var prevSong = currentSong;
              currentSong = prevSong;
            }
            $progress.css("width", "0%");
            //обновляем статистику
            updateStat();
            if (shuffleArray) {
              currentSong = shuffleArray[0];
              if (shuffleArray.length > 1) {
                shuffleArray.splice(0, 1);
              } else {
                shuffleArray = shuffle();
              }
            } else {
              if (currentSong < playlist.length - 1) {
                currentSong = currentSong + 1;
              } else {
                if (repeat) {
                  if (repeatMode == "playlist") {
                    currentSong = 0;
                  }
                } else {
                  currentSong = playlist.length - 1;
                }
              }
            }

            // если есть скролл
            if (settings.scroll) {
              $scroll_rail.slider("value", playlist.length - settings.scroll - currentSong);
              $playlistItem.css({
                "padding-right": "10px"
              });
            }

            songChange();
            audio.play();
            $next.find("path").attr("d", svg.next_anm);
            setTimeout(function () {
              $next.find("path").attr("d", svg.next);
            }, 250);
          }
        });
        
        // shuffle трек
        $shuffle.on("click", function () {
          var data;
          $shuffle.toggleClass('actv');
          shuffleMode = !shuffleMode;
          if (shuffleMode) {
            shuffleArray = shuffle();
          } else {
            shuffleArray = null;
          }
          data = {
            action: 'shuffle_change',
            shuffle: shuffleMode
          };
          jQuery.post(wptpa_data.ajaxurl, data, function (response) {
            console.log(response);
          });
        });
        
        // share трек
        $share.on("click", function () {
          $share.toggleClass('actv');
          $share_modal.toggleClass('opn');
        });
        // share close
        $shareClose.on("click", function () {
          $share.removeClass('actv');
          $share_modal.removeClass('opn');
        });
        
        // open in new window
        $window.on("click", function () {
          var url = wptpa_data.siteurl + "?do=wptpa&id=" + settings.playlistId;
          if (!audio.paused) {
            url += "&autoplay=true";
          } else {
            url += "&autoplay=false";
          }
          url += "&compact=true&cursng=" + currentSong + "&curtm=" + audio.currentTime + "&curvlm=" + audio.volume * 100 + "&pls=false";
          audio.pause();
          window.open(url, '', 'width=350,height=600,menubar=0,toolbar=0,location=0,status=0,scrollbars=0,resizable=0');

        });
        
        // playlist toggle
        $plsToggle.on("click", function () {
          playlistToggle();
        });
        
        // volume muted
        $volume.on("click", function () {
          $volume_modal.addClass("wptpa_vol_show");
          if (audio.muted) {
            audio.muted = false;
            audio.volume = settings.volume / 100;
            volumeTxt(audio.volume * 100);
            //$volumeValue.css("width", settings.volume + "%");
          } else {
            audio.muted = true;
            audio.volume = 0;
            volumeTxt(0);
            $volumeValue.css("width", "0%");
          }
          adsAudio.volume = audio.volume;
          var data = {
            action: 'volume_change',
            volume: audio.volume * 100
          };
          jQuery.post(wptpa_data.ajaxurl, data, function (response) {
            console.log(response);
          });
          setTimeout(function () {
            $volume_modal.removeClass("wptpa_vol_show");
          }, 250);
        });
          
        // анимация клика
        $(".wptpa_btn").on("click", function () {
          $(".wptpa_btn").removeClass("clck");
          $(this).addClass("clck");
          setTimeout(function () {
            $(".wptpa_btn").removeClass("clck");
          }, 400);
        });
        
        $social_links.on("click", function (e) {
          e.preventDefault();
          window.open($(this).attr('href'), 'share', 'width=500,height=400,resizable=yes,scrollbars=yes,status=yes');
        });

      }
      
      function adsLoad() {
        if (adsList) {
          adsAudio.src = adsList[adsCurrentAdsInList].url;
          adsAudio.load();
          adsAudio.addEventListener("play", adsPlay, false);
          adsAudio.addEventListener("timeupdate", adsTimeupdate, false);
          adsAudio.addEventListener("ended", adsEnded, false);
        }
      }
      
      function adsPlay() {
        // обнуляем таймер
        adsTime = 0;
        $currentTime.fadeOut();
        $duration.fadeOut();
        audio.pause();
        adsAudio.volume = audio.volume;
        ads = true;
        $seek.append("<div class='wptpa_ads'>Аdvertising will end: <b></b></div>");
      }
      
      function adsTimeupdate() {
        $seek.find(".wptpa_ads b").text(timeConvert(adsAudio.duration - adsAudio.currentTime));
        $progress.css("width", (adsAudio.currentTime * 100 / adsAudio.duration) + "%");
      }
      
      function adsEnded() {
        $currentTime.fadeIn();
        $duration.fadeIn();
        audio.play();
        ads = false;
        $seek.find(".wptpa_ads").remove();
        if (adsCurrentAdsInList < adsList.length - 1) {
          adsCurrentAdsInList++;
        } else {
          adsCurrentAdsInList = 0;
        }
        // загружаем рекламу
        adsLoad();
      }
      
      function init() {
        wrapper.addClass("wptpa_wrapper");
        buildPlayer();
        renderPlayer();
        //ели прислан шафл мод
        //то включаем его и получаем массив
        if (settings.shuffleOn) {
          $shuffle.toggleClass('actv');
          shuffleMode = !shuffleMode;
          if (shuffleMode) {
            shuffleArray = shuffle();
          } else {
            shuffleArray = null;
          }
        }
        // берем рендомній трек
        if (shuffleArray) {
          currentSong = shuffleArray[0];
          if (shuffleArray.length > 1) {
            shuffleArray.splice(0, 1);
          } else {
            shuffleArray = shuffle();
          }
        }
        slidingSngCheck();
        if (!settings.showPls) {
          playlistToggle();
        }
        // enable compact
        songChange();
        if (settings.ads) {
          // если включено промо загружаем его
          // парсим массив рекламы
          if (settings.adsUrl) {
            adsList = JSON.parse(settings.adsUrl);
          } else {
            adsList = null;
          }
          // загружаем рекламу
          adsLoad();
        }
        
        // проверяем нужен ли компактный режим
        window.setTimeout(timer, 100);
      }
      
      init();
      
      resize = new ResizeSensor(jQuery('.wptpa_wrapper'), function () {
        // проверяем нужен ли компактный режим
        compactMode();
      });
      
    });

  };
}(jQuery));