jQuery(document).ready(function($){
  "use strict";
  //player settings
  var frame, change = false;
  
  function selectAds(){
    if (frame) {
      frame.open();
      return;
    }
    // Create a new media frame
    frame = wp.media({
      title: 'Select or Upload Media for Advertisement',
      button: {
        text: 'Use this media'
      },
      library : { type : 'audio' },
      multiple: false  // Set to true to allow multiple files to be selected
    });
    frame.on( 'select', function() {
      // Get media attachment details from the frame state
      var attachment = frame.state().get('selection').first().toJSON();
      $("#ads_url").val(attachment.url);
    });
    // Finally, open the modal on click
    frame.open();
  }
  
  // Выбор и загрузка аудио для рекламы
  $('#ads_url_browse').bind('click', function (event) {
    event.preventDefault();
    selectAds();
  });
  $('#ads_url').bind('click', function (event) {
    $('#ads_url_browse').click();
  });
  
  // функция обновления превью работоет через добавление цсс
  function updateColor() {
    var style;
    style = ".wptpa_player{background: " + $("#player-background").val() + ";}";
    style += ".wptpa_song_infrmtn{color: " + $("#player-color").val() + ";}";
    style += ".wptpa_heading:before, .wptpa_heading:after{background: " + $("#player-color").val() + ";}";
    style += ".wptpa_btn{background: " + $("#player-button").val() + ";}";
    style += ".wptpa_btn:hover{background: " + $("#player-button_active").val() + ";}";
    style += ".wptpa_btn:before{background: " + $("#player-button").val() + ";}";
    style += ".wptpa_player .wptpa_seek, .wptpa_volume_seek:before{background: " + $("#player-seek").val() + ";}";
    style += ".wptpa_progress, .wptpa_volume_value{background: " + $("#player-progress").val() + ";}";
    style += ".wptpa_currenttime, .wptpa_duration {color: " + $("#player-timecode").val() + ";}";
    style += ".wptpa_pllst_itm{background: " + $("#playlist-background").val() + "; color: " + $("#playlist-color").val() + "; border-bottom: 1px solid rgba(255, 255, 255, 0.25);}";
    style += ".wptpa_pllst_itm.crrnt, .wptpa_pllst_itm:hover{background: " + $("#playlist-background_current").val() + "; color: " + $("#playlist-color_current").val() + ";}";
    style += ".wptpa_bars, .wptpa_bars:before, .wptpa_bars:after, .wptpa_scroll_bar{background: " + $("#playlist-color_current").val() + ";}";
    style += ".wptpa_pllst_itm .wptpa_icon{background: " + $("#playlist-color_current").val() + ";}";
    
    $(".wptpa_style_css").html("<style>" + style + "</style>");
  }
  // стили при смене через дропдаун список
  $("#theme").on("change", function () {
    switch ($(this).val()) {
    case "1":
      $("#player-background").val("#303841");
      $("#player-color").val("#EEEEEE");
      $("#player-button").val("#EEEEEE");
      $("#player-button_active").val("#D72323");
      $("#player-seek").val("#3A4750");
      $("#player-progress").val("#D72323");
      $("#player-timecode").val("#EEEEEE");
      $("#playlist-background").val("#303841");
      $("#playlist-color").val("#EEEEEE");
      $("#playlist-background_current").val("#3A4750");
      $("#playlist-color_current").val("#EEEEEE");
      break;
    case "2":
      $("#player-background").val("#EAEAEA");
      $("#player-color").val("#252A34");
      $("#player-button").val("#252A34");
      $("#player-button_active").val("#08d9d6");
      $("#player-seek").val("#252A34");
      $("#player-progress").val("#08d9d6");
      $("#player-timecode").val("#EAEAEA");
      $("#playlist-background").val("#252A34");
      $("#playlist-color").val("#EAEAEA");
      $("#playlist-background_current").val("#252A34");
      $("#playlist-color_current").val("#08d9d6");
      break;
    case "3":
      $("#player-background").val("#eef1dd");
      $("#player-color").val("#5c3551");
      $("#player-button").val("#5c3551");
      $("#player-button_active").val("#ed4747");
      $("#player-seek").val("#5c3551");
      $("#player-progress").val("#ed4747");
      $("#player-timecode").val("#eef1dd");
      $("#playlist-background").val("#5c3551");
      $("#playlist-color").val("#eef1dd");
      $("#playlist-background_current").val("#ed4747");
      $("#playlist-color_current").val("#eef1dd");
      break;
    case "4":
      $("#player-background").val("#212831");
      $("#player-color").val("#03e492");
      $("#player-button").val("#2e3846");
      $("#player-button_active").val("#03e492");
      $("#player-seek").val("#2e3846");
      $("#player-progress").val("#03e492");
      $("#player-timecode").val("#212831");
      $("#playlist-background").val("#2e3846");
      $("#playlist-color").val("#03e492");
      $("#playlist-background_current").val("#212831");
      $("#playlist-color_current").val("#03e492");
      break;
    case "5":
      $("#player-background").val("#ededed");
      $("#player-color").val("#222831");
      $("#player-button").val("#222831");
      $("#player-button_active").val("#ff5722");
      $("#player-seek").val("#222831");
      $("#player-progress").val("#ff5722");
      $("#player-timecode").val("#ededed");
      $("#playlist-background").val("#303841");
      $("#playlist-color").val("#ededed");
      $("#playlist-background_current").val("#222831");
      $("#playlist-color_current").val("#ff5722");
      break;
    case "6":
      $("#player-background").val("#F5F5F5");
      $("#player-color").val("#424242");
      $("#player-button").val("#424242");
      $("#player-button_active").val("#B9E937");
      $("#player-seek").val("#424242");
      $("#player-progress").val("#B9E937");
      $("#player-timecode").val("#F5F5F5");
      $("#playlist-background").val("#424242");
      $("#playlist-color").val("#F5F5F5");
      $("#playlist-background_current").val("#B9E937");
      $("#playlist-color_current").val("#424242");
      break;
    case "7":
      $("#player-background").val("#303841");
      $("#player-color").val("#EEEEEE");
      $("#player-button").val("#EEEEEE");
      $("#player-button_active").val("#F6C90E");
      $("#player-seek").val("#3A4750");
      $("#player-progress").val("#F6C90E");
      $("#player-timecode").val("#EEEEEE");
      $("#playlist-background").val("#3A4750");
      $("#playlist-color").val("#EEEEEE");
      $("#playlist-background_current").val("#303841");
      $("#playlist-color_current").val("#F6C90E");
      break;
    case "8":
      $("#player-background").val("#3E3E3E");
      $("#player-color").val("#B3A78C");
      $("#player-button").val("#B3A78C");
      $("#player-button_active").val("#F6E7C1");
      $("#player-seek").val("#B3A78C");
      $("#player-progress").val("#F6E7C1");
      $("#player-timecode").val("#3E3E3E");
      $("#playlist-background").val("#B3A78C");
      $("#playlist-color").val("#F6E7C1");
      $("#playlist-background_current").val("#F6E7C1");
      $("#playlist-color_current").val("#3E3E3E");
      break;
    case "9":
      $("#player-background").val("#E2EFF1");
      $("#player-color").val("#65799B");
      $("#player-button").val("#65799B");
      $("#player-button_active").val("#B6D5E1");
      $("#player-seek").val("#65799B");
      $("#player-progress").val("#B6D5E1");
      $("#player-timecode").val("#555273");
      $("#playlist-background").val("#555273");
      $("#playlist-color").val("#B6D5E1");
      $("#playlist-background_current").val("#65799B");
      $("#playlist-color_current").val("#E2EFF1");
      break;
    case "10":
      $("#player-background").val("#F33535");
      $("#player-color").val("#D8E9F0");
      $("#player-button").val("#33425B");
      $("#player-button_active").val("#D8E9F0");
      $("#player-seek").val("#33425B");
      $("#player-progress").val("#D8E9F0");
      $("#player-timecode").val("#F33535");
      $("#playlist-background").val("#33425B");
      $("#playlist-color").val("#D8E9F0");
      $("#playlist-background_current").val("#F33535");
      $("#playlist-color_current").val("#33425B");
      break;
    case "default":
      $("#player-background").val("#FFFFFF");
      $("#player-color").val("#555555");
      $("#player-button").val("#555555");
      $("#player-button_active").val("#3EC3D5");
      $("#player-seek").val("#555555");
      $("#player-progress").val("#3EC3D5");
      $("#player-timecode").val("#FFFFFF");
      $("#playlist-background").val("#3EC3D5");
      $("#playlist-color").val("#FFFFFF");
      $("#playlist-background_current").val("#42CFE2");
      $("#playlist-color_current").val("#FFFFFF");
      break;
    case "custom":
      $("#player-background").val(wptpa_custom.player.background);
      $("#player-color").val(wptpa_custom.player.color);
      $("#player-button").val(wptpa_custom.player.button);
      $("#player-button_active").val(wptpa_custom.player.button_active);
      $("#player-seek").val(wptpa_custom.player.seek);
      $("#player-progress").val(wptpa_custom.player.progress);
      $("#player-timecode").val(wptpa_custom.player.timecode);
      $("#playlist-background").val(wptpa_custom.playlist.background);
      $("#playlist-color").val(wptpa_custom.playlist.color);
      $("#playlist-background_current").val(wptpa_custom.playlist.background_current);
      $("#playlist-color_current").val(wptpa_custom.playlist.color_current);
      break;
    }
    change = true;
    $("#player-background").change();
    $("#player-color").change();
    $("#player-button").change();
    $("#player-button_active").change();
    $("#player-seek").change();
    $("#player-progress").change();
    $("#player-timecode").change();
    $("#playlist-background").change();
    $("#playlist-color").change();
    $("#playlist-background_current").change();
    $("#playlist-color_current").change();
    updateColor();
    change = false;
  });
  // если меняется в ручную стиль, меняем значение дропдаун на кастом
  $(".fw_color").on("change", function () {
    if(!change){
      wptpa_custom.player.background = $("#player-background").val();
      wptpa_custom.player.color = $("#player-color").val();
      wptpa_custom.player.button = $("#player-button").val();
      wptpa_custom.player.button_active = $("#player-button_active").val();
      wptpa_custom.player.seek = $("#player-seek").val();
      wptpa_custom.player.progress = $("#player-progress").val();
      wptpa_custom.player.timecode = $("#player-timecode").val();
      wptpa_custom.playlist.background = $("#playlist-background").val();
      wptpa_custom.playlist.color = $("#playlist-color").val();
      wptpa_custom.playlist.background_current = $("#playlist-background_current").val();
      wptpa_custom.playlist.color_current = $("#playlist-color_current").val();
      $("#theme").val("custom").change();
      updateColor();
    }
  });
  // загружаем стили при ините
  function init() {
    updateColor();
  }
  init();
});
