jQuery(document).ready(function($){
  "use strcit";
  
  /* SEARCH SONGS */
  // поиск
  $("#wptpa_search_songs").on("keyup focus", function () {
    var searchValue = $(this).val(), data;
    console.log(searchValue);
    // ищем после трех введенных символов
    if (searchValue.length > 2) {
      data = {
        action: "wptpa_search_song",
        searchValue: searchValue
      };
      // ajax
      $.ajax({
        type: "POST",
        url: ajaxurl,
        data: data,
        beforeSend: function () {
          $("#wptpa_search_songs").addClass("loading");
        },
        success: function (response) {
          $("#wptpa_search_songs").removeClass("loading");
          $("#wptpa_search_results").html(response);
          $("#wptpa_search_results").slideDown();
        }
      });
    }
  });
  
  // прячем результаты поиска
  $("#wptpa_search_songs").on("focusout", function () {
    setTimeout(function () {
      $("#wptpa_search_results").slideUp(function () {
        $("#wptpa_search_results").empty();
      });
    }, 50);
  });
  
  /* CHARTS */
  var timeWrapper, countWrapper, dwnWrapper, config, timeChart, countChart, dwnChart, id;
  
  function init(){
    if(document.getElementById("wptpa_time")){
      timeWrapper = document.getElementById("wptpa_time").getContext('2d');
      countWrapper = document.getElementById("wptpa_count").getContext('2d');
      dwnWrapper = document.getElementById("wptpa_dwn").getContext('2d');
    }
  }
  
  init();
  
  function secondsToHms(d) {
    d = Number(d);
    var h, m, s, hDisplay, mDisplay, sDisplay;
    h = Math.floor(d / 3600);
    m = Math.floor(d % 3600 / 60);
    s = Math.floor(d % 3600 % 60);
    
    hDisplay = h > 0 ? h + (h === 1 ? " h, " : " h, ") : "";
    mDisplay = m > 0 ? m + (m === 1 ? " m, " : " m, ") : "";
    sDisplay = s > 0 ? s + (s === 1 ? " s" : " s") : "";
    return hDisplay + mDisplay + sDisplay;
  }
  
  function createConfig(title, label, labels, data) {
    return {
      type: 'line',
      data: {
        labels: labels,
        datasets: [{
          label: label,
          data: data,
          backgroundColor: "rgba(0, 0, 0, 0.05)",
          borderColor: "#3EC3D5",
          pointBackgroundColor: "#3EC3D5",
          pointBorderColor: "#3EC3D5",
          pointRadius: 4,
          pointBorderWidth: 0,
          pointHoverBackgroundColor: "#3EC3D5",
          pointHoverBorderColor: "#3EC3D5",
          pointHoverRadius: 6,
          pointHoverBorderWidth: 0,
          showLine: true,
          fill: true,
          borderWidth: 2
        }]
      },
      options: {
        layout: {
          padding: {
            left: 0,
            right: 0,
            top: 0,
            bottom: 0
          }
        },
        responsive: true,
        maintainAspectRatio: false,
        legend: {
          display: false
        },
        title: {
          display: true,
          text: title,
          padding: 20,
          fontSize: 23,
          fontStyle: "normal",
          fontFamily: "'Roboto', sans-serif",
          fontColor: "rgba(0, 0, 0, 0.75)",
          lineHeight: "0px"
        },
        tooltips: {
          backgroundColor: 'rgba(0, 0, 0, 0.5)',
          titleFontSize: 20,
          titleFontFamily: "'Roboto', sans-serif",
          titleSpacing: 20,
          titleMarginBottom: 10,
          bodyFontSize: 14,
          bodyFontColor: "#eee",
          bodyFontFamily: "'Roboto', sans-serif",
          bodySpacing: 20,
          xPadding: 10,
          yPadding: 10,
          cornerRadius: 0,
          displayColors: false,
          callbacks: {
            label: function (tooltipItem, data) {
              if (label === "playing") {
                return secondsToHms(data.datasets[0].data[tooltipItem.index]) + " " + label;
              } else {
                if (data.datasets[0].data[tooltipItem.index] > 1000) {
                  return (data.datasets[0].data[tooltipItem.index] / 1000).toFixed(0) + "K " + label;
                } else {
                  return data.datasets[0].data[tooltipItem.index] + " " + label;
                }
                
              }
              
            }
          }
        },
        scales: {
          xAxes: [{
            gridLines: {
              display: true,
              color: "rgba(0, 0, 0, 0.05)"
            },
            ticks: {
              display: true,
              fontFamily: "'Roboto', sans-serif",
              fontColor: "rgba(0, 0, 0, 0.5)",
              fontSize: 12
            }
          }],
          yAxes: [{
            gridLines:  {
              display: true,
              color: "rgba(0, 0, 0, 0.05)"
            },
            ticks: {
              display: false,
              fontFamily: "'Roboto', sans-serif",
              fontColor: "rgba(0, 0, 0, 0.5)",
              fontSize: 12
            }
          }]
        }
      }
    };
  }
  
  function updateChart(data) {
    var date = [], count = [], time = [], dwn = [];
    $.each(data, function (index, value) {
      date.push(value.date);
      count.push(value.count);
      time.push(value.time);
      dwn.push(value.download);
    });
    if(timeChart){
      timeChart.data.datasets[0].data = time;
      timeChart.data.labels = date;
      timeChart.update();
      countChart.data.datasets[0].data = count;
      countChart.data.labels = date;
      countChart.update();
      dwnChart.data.datasets[0].data = dwn;
      dwnChart.data.labels = date;
      dwnChart.update();
    } else {
      config = createConfig("Times of Played", "playing", date, time);
      timeChart = new Chart(timeWrapper, config);
      
      config = createConfig("Count of Plays", "times played", date, count);
      countChart = new Chart(countWrapper, config);
      
      config = createConfig("Count of Downloads", "downloads", date, dwn);
      dwnChart = new Chart(dwnWrapper, config);
    }
    
  }
  
  function getDataForStats(id, period) {
    var data;
    data = {
      action: "wptpa_load_period",
      song_id: id,
      period: period
    };
    $.ajax({
      url: ajaxurl,
      data: data,
      type: "POST",
      dataType: "json",
      beforeSend: function () {
        $(".wptpa_loader").show();
      },
      error: function (textStatus) {
        console.log(textStatus);
      },
      success: function (data) {
        //console.log(data);
        updateChart(data);
        $(".wptpa_loader").hide();
      }
    });
  }
  
  if($("#wptpa_chart_range").length > 0){
    getDataForStats($("#wptpa_chart_range").data("sngid"), "");
  }
  
  $("#wptpa_chart_range").on("change", function () {
    getDataForStats($(this).data("sngid"), $(this).val());
  });
  
  
});