(function (blocks, editor, i18n, element) {
  "use strict";
  var el = element.createElement,
    __ = i18n.__,
    RichText = editor.RichText,
    AlignmentToolbar = editor.AlignmentToolbar,
    BlockControls = editor.BlockControls,
    SelectControl = wp.components.SelectControl,
    CheckboxControl = wp.components.ToggleControl,
    Spinner = wp.components.Spinner,
    InspectorControls = wp.editor.InspectorControls,
    Placeholder = wp.components.Placeholder,
    Checkbox = wp.components.CheckboxControl,
    array = [],
    playlistsNew,
    iconEl;
  
  // конвертируем плейлист
  array.push({label: "Select Playlist", value: "default"});
  jQuery.each(playlists_list, function (index, value) {
    array.push({label: value.name, value: value.id});
  });
  playlistsNew = array;
  iconEl =
    el('svg', { width: 20, height: 20 },
      el('path', { d: "M15,5c-0.8,0-1.6,0.2-2.3,0.6V5.3c0-0.2-0.1-0.3-0.3-0.3H10H7.7C7.5,5,7.3,5.1,7.3,5.3v2c0,0.2,0.1,0.3,0.3,0.3H10V18c0,0.2,0.1,0.3,0.3,0.3h2c0.2,0,0.3-0.1,0.3-0.3v-3.6c0.7,0.4,1.5,0.6,2.3,0.6c2.8,0,5-2.2,5-5S17.8,5,15,5z M15,12.3c-1.3,0-2.3-1-2.3-2.3s1-2.3,2.3-2.3s2.3,1,2.3,2.3S16.3,12.3,15,12.3z" }),
      el('path', { d: "M7,12.3H5c-1.3,0-2.3-1-2.3-2.3V7.7H5c0.2,0,0.3-0.1,0.3-0.3v-2C5.3,5.1,5.2,5,5,5H2.7V2c0-0.2-0.1-0.3-0.3-0.3h-2C0.1,1.7,0,1.8,0,2v8c0,2.8,2.2,5,5,5h2c0.2,0,0.3-0.1,0.3-0.3v-2C7.3,12.5,7.2,12.3,7,12.3z" })
     );
  
  
  blocks.registerBlockType('wptpa-block/wptpa', {
    title: "tPlayer",
    icon: {
      foreground: '#3EC3D5',
      src: iconEl
    },
    description: 'Embed tPlayer.',
    category: 'embed',
    keywords: [__('audio'), __('player'), __('radio')],
    attributes: {
      playlistId: {
        type: 'string',
        default: 'default'
      },
      enableOptions: {
        type: 'bolean'
      },
      autoplay: {
        type: 'bolean'
      },
      playlistShow: {
        type: 'bolean'
      },
      covers: {
        type: 'bolean'
      },
      compactMode: {
        type: 'bolean'
      }
    },
    supports:{
      // Add the support for block's alignment (left, center, right, wide, full).
      align: true,
      // Pick which alignment options to display.
      align: ['wide'],
    },
    edit: function (props) {
      var playlistId = props.attributes.playlistId,
        enableOptions = props.attributes.enableOptions,
        autoplay = props.attributes.autoplay,
        playlistShow = props.attributes.playlistShow,
        covers = props.attributes.covers,
        compactMode = props.attributes.compactMode,
        $heading = "",
        $msg = "",
        $plsname = "",
        $id =  Math.random().toString(36).substring(2, 15) + Math.random().toString(36).substring(2, 15);
      //если не выбран блок
      if (!props.isSelected) {
        var data = {
          action: "wptpa_generate_config_gutenberg",
          id: playlistId,
          settings: {}
        }
        // если есть кастомные параметры
        if(enableOptions) {
          data.settings.autoplay = autoplay;
          data.settings.cover = covers;
          data.settings.showPls = playlistShow;
          data.settings.compactMode = compactMode;
        }
        // проеверяем выбран ли плейлист
        if (playlistId !== "default") {
          jQuery.post(ajaxurl, data, function(response) {
            var obj = JSON.parse(response);
            jQuery("#" + $id).wptpa(obj);
          });
          return [
            el('div', {id: $id, class: "wptpa_wrapper"},
              el('div', {class: "wptpa_gap"},
                el(Spinner),
              )            
            )
          ];
        } else {
          // заглушка
          return [
            el(Placeholder, {
              label: "tPlayer",
              instructions: "Select playlist for current player:"
            },
              el(SelectControl, {
                value: playlistId,
                options: playlistsNew,
                onChange: function (newPlaylist) {
                  props.setAttributes({playlistId: newPlaylist});
                }
              })
            )
          ];
        }
      } else {
        return [
          el(Placeholder, {
              label: "tPlayer",
              instructions: "Select playlist for current player:"
          },
            el(SelectControl, {
              value: playlistId,
              options: playlistsNew,
              onChange: function (newPlaylist) {
                props.setAttributes({playlistId: newPlaylist});
              }
            })
          ),
          el(InspectorControls, { key: 'inspector' }, // Display the block options in the inspector panel.
            el(wp.components.PanelBody, {
              title: 'Settings',
              className: 'block-social-links',
              initialOpen: true
            },
              el(SelectControl, {
                label: "Select Playlist",
                value: playlistId,
                options: playlistsNew,
                onChange: function (newPlaylist) {
                  props.setAttributes({playlistId: newPlaylist});
                }
              }),
              el(CheckboxControl, {
                label: "Enable Individual Parameters",
                help: "optional",
                checked: enableOptions,
                onChange: function (check) {
                  props.setAttributes({enableOptions: check});
                }
              }),
              el(CheckboxControl, {
                label: "Autoplay",
                help: "enable autoplay",
                checked: autoplay,
                onChange: function (check) {
                  props.setAttributes({autoplay: check});
                }
              }),
              el(CheckboxControl, {
                label: "Playlist",
                help: "show playlist or hide",
                checked: playlistShow,
                onChange: function (check) {
                  props.setAttributes({playlistShow: check});
                }
              }),
              el(CheckboxControl, {
                label: "Covers",
                help: "enable covers",
                checked: covers,
                onChange: function (check) {
                  props.setAttributes({covers: check});
                }
              }),
                el(CheckboxControl, {
                label: "Compact Mode",
                help: "enable compact mode",
                checked: compactMode,
                onChange: function (check) {
                  props.setAttributes({compactMode: check});
                }
              })
            )
          )
        ];
      }
    },
    save: function (props) {
      var
        attributes = props.attributes,
        playlistId = props.attributes.playlistId,
        enableOptions = props.attributes.enableOptions,
        autoplay = props.attributes.autoplay,
        playlistShow = props.attributes.playlistShow,
        covers = props.attributes.covers,
        compactMode = props.attributes.compactMode,
        config = "";
      if (enableOptions) {
        if (autoplay) {
          config += 'autoplay="true" ';
        } else {
          config += 'autoplay="false" ';
        }
        if (playlistShow) {
          config += 'playlist="true" ';
        } else {
          config += 'playlist="false" ';
        }
        if (covers) {
          config += 'cover="true" ';
        } else {
          config += 'cover="false" ';
        }
        if (compactMode) {
          config += 'compact="true"';
        } else {
          config += 'compact="false"';
        }
      }
      return (
        el('div', {}, '[wptpa id="' + playlistId + '" ' + config + ']')
     );
    }
  });
}(
  window.wp.blocks,
  window.wp.editor,
  window.wp.i18n,
  window.wp.element
));
