<?php
// text input with label
function fw_textInputLabel($heading = null, $subheading = null, $name = null, $value = null) {
?>
  <div class="fw_row">
    <div class="fw_column lg-4 fw_input_field  align_space-between">
      <label for="<?php echo $name; ?>" class="fw_label_2row">
        <?php echo $heading; ?>
        <span class="fw_subheading"><?php echo $subheading; ?></span>
      </label>
    </div>
    <div class="fw_column lg-8 fw_input_field align_end">
      <input type="text" name="<?php echo $name; ?>" id="<?php echo $name; ?>" value="<?php echo $value; ?>">
    </div>
  </div>
<?php
}
// checkbox with label
function fw_checkboxLabel($heading = null, $subheading = null, $name = null, $checked = null) {
?>
  <div class="fw_row">
    <div class="fw_column lg-12 fw_input_field  align_space-between">
      <label for="<?php echo $name; ?>" class="fw_label_2row">
        <?php echo $heading; ?>
        <span class="fw_subheading"><?php echo $subheading; ?></span>
        <input type="checkbox" name="<?php echo $name; ?>" id="<?php echo $name; ?>" <?php checked($checked); ?>>
        <span class="fw_checkbox"></span>
      </label>
    </div>
  </div>
<?php
}
// toggle with label
function fw_toggleLabel($heading = null, $subheading = null, $name = null, $checked = null) {
?>
  <div class="fw_row">
    <div class="fw_column lg-12 fw_input_field  align_space-between">
      <label for="<?php echo $name; ?>" class="fw_label_2row">
        <?php echo $heading; ?>
        <span class="fw_subheading"><?php echo $subheading; ?></span>
        <input type="checkbox" name="<?php echo $name; ?>" id="<?php echo $name; ?>" <?php checked($checked); ?>>
        <span class="fw_toggle"></span>
      </label>
    </div>
  </div>
<?php
}
// DropdownList
function fw_dropdownList($heading = null, $subheading = null, $options = null, $values = null, $name = null, $value = null) {
?>
  <div class="fw_row">
    <div class="fw_column lg-12 fw_input_field  align_space-between">
      <label for="<?php echo $name; ?>" class="fw_label_2row">
        <?php echo $heading; ?>
        <span class="fw_subheading"><?php echo $subheading; ?></span>
        <select name="<?php echo $name; ?>" id="<?php echo $name; ?>">
        <?php 
          foreach($options as $k => $v){
            if($values[$k] == $value){
              echo "<option value='$values[$k]' selected>$v</option>";
            } else {
              echo "<option value='$values[$k]'>$v</option>";
            }
          }                
          ?>
        </select>
      </label>
    </div>
  </div>
<?php
}
// input number
function fw_inputNumber($heading = null, $subheading = null, $name = null, $value = null, $before = null, $after = null, $min = 0, $max = null, $step = null) {
?>
  <div class="fw_row">
    <div class="fw_column lg-9 fw_input_field">
      <label for="<?php echo $name; ?>" class="fw_label_2row">
        <?php echo $heading; ?>
        <span class="fw_subheading"><?php echo $subheading; ?></span>
      </label>
    </div>
    <div class="fw_column lg-3 fw_input_field align_end">
      <?php if($before){?>
        <span class="fw_text_for_input"><?php echo $before; ?></span>
      <?php } ?>
      <input type="number" id="<?php echo $name; ?>" name="<?php echo $name; ?>" value="<?php echo $value; ?>" <?php echo $min !== null ? "min='$min'" : ""; echo $max !== null ? "max='$max'" : ""; echo $step !== null ? "step='$step'" : "";  ?>>
      <?php if($after){?>
        <span class="fw_text_for_input"><?php echo $after; ?></span>
      <?php } ?>
    </div>
  </div>
<?php
}
function fw_browseButton($name = null, $value = null, $button_name = null, $button_text = null) {
?>
  <div class="fw_row align_bottom">
    <div class="fw_column lg-9 fw_input_field">
      <input type="text" class="fw_files_input" value="<?php echo $value; ?>" name="<?php echo $name; ?>" id="<?php echo $name; ?>">
    </div>
    <div class="fw_column lg-3 align_end filled">
      <button class="fw_btn" name="<?php echo $button_name; ?>" id="<?php echo $button_name; ?>"><?php echo $button_text; ?></button>
    </div>
  </div>
<?php
}
function fw_cp($label = null, $name = null, $value = null){
  $i = 1;
  foreach($label as $k => $v){
    if($i % 2){
      echo '<div class="fw_row align_middle">';
    }
  ?>
    <div class="fw_column lg-5 fw_input_field">
      <label for="<?php echo $name.'-'.$k; ?>" class="fw_label_2row">
        <?php echo $v["name"]; ?>
        <span class="fw_subheading"><?php echo $v["subname"]; ?></span>
      </label>
   </div>
    <div class="fw_column lg-1 align_end">
      <input type="text" name="colors<?php echo "[".$name."][".$k."]" ?>" id="<?php echo $name.'-'.$k; ?>" class="fw_color filled" value="<?php echo $value[$k]; ?>">
   </div>
  <?php
    if($i % 2){
      echo '';
    } else {
      echo '</div>';
    }
    if($i === count($label) AND $i % 2){
      echo '</div>';
    }
    $i++;
  }
}
?>