<?php
function wptpa_activation() {
  global $def; // default settings
  global $wpdb; // mysql
  // tables name
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $playlists_table_name = $wpdb->prefix."tpa_playlist";
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  // oldes tables name
  $songs_table_name_OLD = $wpdb->prefix."wptpa_songs";
  $playlists_table_name_OLD = $wpdb->prefix."wptpa_pls";
  $stats_table_name_OLD = $wpdb->prefix."wptpa_stats";
  
  // проверяем были ли старые настройки
  $old_options = get_option("wptpa_optn");
  if($old_options){
    $settings = array(
      "autoplay" => isset($old_options["autoplay"]) ? $old_options["autoplay"] : $def["autoplay"], // если было раньше берем его
      "preload" => isset($old_options["preload"]) ? $old_options["preload"] : $def["preload"], // если было раньше берем его
      "compact" => isset($old_options["compact"]) ? $old_options["compact"] : $def["compact"], // если было раньше берем его
      "playlist" => isset($old_options["playlist"]) ? $old_options["playlist"] : $def["playlist"], // если было раньше берем его
      "covers" => isset($old_options["cover"]) ? $old_options["cover"] : $def["covers"], // если было раньше берем его
      "shuffle" => isset($old_options["shuffle"]) ? $old_options["shuffle"] : $def["shuffle"], // если было раньше берем его
      "share" => isset($old_options["share"]) ? $old_options["share"] : $def["share"], // если было раньше берем его
      "embed" => isset($old_options["embed"]) ? $old_options["embed"] : $def["embed"], // если было раньше берем его
      "stats" =>isset($old_options["stats"]) ? $old_options["stats"] : $def["stats"], // если было раньше берем его
      "volume" =>isset($old_options["volume"]) ? $old_options["volume"] : $def["volume"], // если было раньше берем его
      "scrollbar" =>isset($old_options["scrollbar"]) ? $old_options["scrollbar"] : $def["scrollbar"], // если было раньше берем его
      "font" =>isset($old_options["font"]) ? $old_options["font"] : $def["font"], // если было раньше берем его
      "window" =>isset($old_options["opnnwwndw"]) ? $old_options["opnnwwndw"] : $def["window"], // если было раньше берем его
      "radio_cover" =>isset($old_options["coverRadio"]) ? $old_options["coverRadio"] : $def["radio_cover"], // если было раньше берем его
      "radio_interval" =>isset($old_options["radio_intrvl"]) ? $old_options["radio_intrvl"] : $def["radio_interval"], // если было раньше берем его
      "ads" =>isset($old_options["ads"]) ? $old_options["ads"] : $def["ads"], // если было раньше берем его
      "ads_url" =>isset($old_options["ads_url"]) ? $old_options["ads_url"] : $def["ads_url"], // если было раньше берем его
      "ads_mode" =>isset($old_options["ads_mode"]) ? $old_options["ads_mode"] : $def["ads_mode"], // если было раньше берем его
      "ads_interval_sec" =>isset($old_options["ads_intrvl"]) ? $old_options["ads_intrvl"] : $def["ads_interval_sec"], // если было раньше берем его
      "ads_interval_song" =>isset($old_options["ads_interval_song"]) ? $old_options["ads_interval_song"] : $def["ads_interval_song"], // если было раньше берем его
      "theme" =>isset($old_options["theme"]) ? $old_options["theme"] : $def["theme"] // если было раньше берем его
    );
    
    // проверяем комбинации цветов с версии 1.6 и 1.7
    if(isset($old_opt["color"]["background"])){ // если структура массива с версии 1.6
      // main color
      $colors["player"]["background"] = $old_opt["color"]["background"];
      // main text color
      $colors["player"]["color"] = $old_opt["color"]["color"];
      // button color
      $colors["player"]["button"] = $old_opt["color"]["btn"];
      // button color on hover
      $colors["player"]["button_active"] = $old_opt["color"]["btnactn"];
      // seek color
      $colors["player"]["seek"] = $old_opt["color"]["seek"];
      // progress color
      $colors["player"]["progress"] = $old_opt["color"]["progress"];
      // timecode colors
      $colors["player"]["timecode"] = $old_opt["color"]["curdur"];
      // playlist main color
      $colors["playlist"]["background"] = $old_opt["color"]["background_pls"];
      // playlist main text color
      $colors["playlist"]["color"] = $old_opt["color"]["color_pls"];
      // playlist curent song main color
      $colors["playlist"]["background_current"] = $old_opt["color"]["background_pls_cur"];
      // playlist curent song main text color
      $colors["playlist"]["color_current"] = $old_opt["color"]["color_pls_cur"];
    } elseif(isset($old_opt["color"]["player"]["background"])){ // если структура массива с версии 1.7
      // main color
      $colors["player"]["background"] = $old_opt["color"]["player"]["background"];
      // main text color
      $colors["player"]["color"] = $old_opt["color"]["player"]["color"];
      // button color
      $colors["player"]["button"] = $old_opt["color"]["player"]["btn"];
      // button color on hover
      $colors["player"]["button_active"] = $old_opt["color"]["player"]["btnactn"];
      // seek color
      $colors["player"]["seek"] = $old_opt["color"]["player"]["seek"];
      // progress color
      $colors["player"]["progress"] = $old_opt["color"]["player"]["progress"];
      // timecode colors
      $colors["player"]["timecode"] = $old_opt["color"]["player"]["curdur"];
      // playlist main color
      $colors["playlist"]["background"] = $old_opt["color"]["playlist"]["background_pls"];
      // playlist main text color
      $colors["playlist"]["color"] = $old_opt["color"]["playlist"]["color_pls"];
      // playlist curent song main color
      $colors["playlist"]["background_current"] = $old_opt["color"]["playlist"]["background_pls_cur"];
      // playlist curent song main text color
      $colors["playlist"]["color_current"] = $old_opt["color"]["playlist"]["color_pls_cur"];
    } else {
      // если не было раньше настроек берем дефолтные
      $colors = $def["colors"];
    }
    $settings["colors"] = $colors;
  } else {
    $settings = $def;
  }
  // создаем/обновляем настройки плагина
  update_option("wptpa_optn", $settings);
  
  // проверяем есть нет таблиц, создаем их
  if($wpdb->get_var("show tables like '$songs_table_name'") != $songs_table_name) {
    // таблиц не существует, создем их
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    $sql = "CREATE TABLE ".$songs_table_name." (
      id INT(11) NOT NULL AUTO_INCREMENT,
      artist TEXT NOT NULL,
      title TEXT NOT NULL,
      audio TEXT NOT NULL,
      cover TEXT NOT NULL,
      dwn TEXT NOT NULL,
      buy TEXT NOT NULL,
      all_time INT(11) NOT NULL,
      all_count INT(11) NOT NULL,
      all_dwn INT(11) NOT NULL,
      UNIQUE KEY id (id)
    )
      DEFAULT CHARACTER SET ".DB_CHARSET;
    dbDelta($sql);
    $sql = "CREATE TABLE ".$playlists_table_name." (
      id INT(11) NOT NULL AUTO_INCREMENT,
      name TEXT NOT NULL,
      items TEXT NOT NULL,
      UNIQUE KEY id (id)
    )
      DEFAULT CHARACTER SET ".DB_CHARSET;
    dbDelta($sql);
    $sql = "CREATE TABLE ".$stats_table_name." (
      id INT(11) NOT NULL AUTO_INCREMENT,
      song_id TEXT NOT NULL,
      time INT(11) NOT NULL,
      count INT(11) NOT NULL,
      download INT(11) NOT NULL,
      date date NOT NULL,
      UNIQUE KEY id (id)
    )
      DEFAULT CHARACTER SET ".DB_CHARSET;
    dbDelta($sql);
    // stats
    // проверяем есть ли таблицы статистики с более поздней версии
    if($wpdb->get_var("show tables like '$stats_table_name_OLD'") === $stats_table_name_OLD) {
      
      // получаем количество записей
      $count = $wpdb->get_results("SELECT count(id) as count FROM $stats_table_name_OLD", ARRAY_A);
      // количество записей на страницу
      $perPage = 100;
      // считаем количество страниц
      $pages = ceil((int)$count[0]["count"] / $perPage);
      for($i = 0; $i < $pages; $i++){
        $offset = $i * $perPage; // получаем оффсет
        // берем 100 записей
        $q = $wpdb->get_results("SELECT * FROM $stats_table_name_OLD LIMIT $offset, $perPage", ARRAY_A);
        $comma_separated = null;
        foreach($q as $k => $v){
          $comma_separated[] = "('".implode("','", $v)."')"; // обьеденяем в строку массив значений каждой записи
        }
        // обьеденяем записи в строку
        $comma_separated = implode(",", $comma_separated);
        // добавляем в бд
        $query = $wpdb->query("INSERT INTO $stats_table_name (id, song_id, time, count, download, date) VALUES$comma_separated");
      }
    }
    // songs
    // проверяем есть ли таблицы треков с более поздней версии
    if($wpdb->get_var("show tables like '$songs_table_name_OLD'") === $songs_table_name_OLD) {
      
      // получаем количество записей
      $count = $wpdb->get_results("SELECT count(id) as count FROM $songs_table_name_OLD", ARRAY_A);
      // количество записей на страницу
      $perPage = 100;
      // считаем количество страниц
      $pages = ceil((int)$count[0]["count"] / $perPage);
      for($i = 0; $i < $pages; $i++){
        $offset = $i * $perPage; // получаем оффсет
        // берем 100 записей
        $q = $wpdb->get_results("SELECT * FROM $songs_table_name_OLD LIMIT $offset, $perPage", ARRAY_A);
        $comma_separated = null;
        foreach($q as $k => $v){
          unset($v["type"]);
          unset($v["radiotype"]);
          unset($v["radiohost"]);
          unset($v["radioport"]);
          unset($v["radiomount"]);
          $comma_separated[] = "('".implode("','", $v)."')"; // обьеденяем в строку массив значений каждой записи
        }
        // обьеденяем записи в строку
        $comma_separated = implode(",", $comma_separated);
        // добавляем в бд
        $query = $wpdb->query("INSERT INTO $songs_table_name (id, artist, title, audio, cover, dwn, buy, all_time, all_count, all_dwn) VALUES$comma_separated");
      }
    }
    // playlists
    // проверяем есть ли таблицы статистики с более поздней версии
    if($wpdb->get_var("show tables like '$playlists_table_name_OLD'") === $playlists_table_name_OLD) {
      
      // получаем количество записей
      $count = $wpdb->get_results("SELECT count(id) as count FROM $playlists_table_name_OLD", ARRAY_A);
      // количество записей на страницу
      $perPage = 100;
      // считаем количество страниц
      $pages = ceil((int)$count[0]["count"] / $perPage);
      for($i = 0; $i < $pages; $i++){
        $offset = $i * $perPage; // получаем оффсет
        // берем 100 записей
        $q = $wpdb->get_results("SELECT * FROM $playlists_table_name_OLD LIMIT $offset, $perPage", ARRAY_A);
        $comma_separated = null;
        foreach($q as $k => $v){
          $comma_separated[] = "('".implode("','", $v)."')"; // обьеденяем в строку массив значений каждой записи
        }
        // обьеденяем записи в строку
        $comma_separated = implode(",", $comma_separated);
        // добавляем в бд
        $query = $wpdb->query("INSERT INTO $playlists_table_name (id, name, items) VALUES$comma_separated");
      }
    }
  }
}
?>