<?php
function wptpa_ads_page() {
  $notify = ""; // уведомления
  $heading = __('Advertising Manager (Beta)', 'wptpa'); // заголовок
  $ads_list = get_option("wptpa_ads_list");
  // проверяем есть ли список
  if(!$ads_list){
    // списка нету
    // получаем настройки
    $settings = get_option("wptpa_optn");
    // проверяем есть ли аудио реклама в старых настройках, если не пусто значит есть, добавляем ее в массив
    if(!empty($settings["ads_url"])){
      $ads_list[0]["url"] = $settings["ads_url"];
      $ads_list[0]["name"] = __('Unnamed Advertisement', 'wptpa');
      // удаляем из настроек
      unset($settings["ads_url"]);
      update_option("wptpa_optn", $settings);
      //сохраняем
      update_option("wptpa_ads_list", $ads_list);
    }
  }
  // save
  if(isset($_POST["action"])){
    $ads_list = !empty($_POST["ads_list"]) ? $_POST["ads_list"] : "";
    update_option("wptpa_ads_list", $ads_list);
  }
?>
<div class="wrap">
  <div class="fw_wrapper" style="display: none;">
    <div class="fw_container shadow-depth-0 bg-white-01">
     <div class="fw_row">
       <div class="fw_column lg-12">
         <div class="h5"><?php echo $heading; ?></div>
       </div>
     </div>
    </div>
    <div class="fw_container shadow-depth-0 bg-white-01 txt_align_center">
      <form action="" method="POST">
        <table id="wptpa_playlist" class="hl">
          <thead>
            <tr>
              <th class="fw_input_field">
                <label>
                  <input id="select_all" type="checkbox" name="idList[]" value="">
                  <span class="fw_checkbox"></span>
                </label>
              </th>
              <th colspan="5" class="txt_align_left"><?php _e('Name', 'wptpa'); ?></th>
            </tr>
          </thead>
          <tbody>
            <?php
              if($ads_list){
                print_ads_list($ads_list);
              } else { ?>
            <tr class="fw_container shadow-depth-0 bg-white-01 txt_align_center wptpa_empty_pls">
              <td colspan="6">
                <img width="50px" src="<?php echo WPTPA_URL; ?>assets/img/information.svg">
                <h4><?php _e('No Advertisement Audio', 'wptpa'); ?></h4>
                <h6 class="fw_subheading"><?php _e('Add first advertisiment audio to the manager', 'wptpa'); ?></h6>
              </td>
            </tr>
            <?php } ?>
          </tbody>
        </table>
        <div class="fw_row">
          <div class="fw_column lg-12 align_end">
            <a href="#song_modall" id="add_songs" class="fw_btn flat sml"><i class="fas fa-plus"></i><?php _e('Add', 'wptpa'); ?></a>
            <a href="#song_modall" id="edit_songs" class="fw_btn flat sml"><i class="fas fa-pencil-alt"></i><?php _e('Edit', 'wptpa'); ?></a>
            <a href="#" id="delete_song" class="fw_btn flat sml"><i class="fas fa-trash-alt"></i><?php _e('Delete', 'wptpa'); ?></a>
          </div>
        </div>
        <div class="fw_divider"></div>
        <div class="fw_row">
          <div class="fw_column lg-12 align_end">
            <a href="admin.php?page=wptpa_ads_page" class="fw_btn red"><?php _e('Cancel', 'wptpa'); ?></a>
            <button type="submit" name="action" value="save" class="fw_btn"><?php _e('Save', 'wptpa'); ?></button>
          </div>
        </div>
      </form>
    </div>
    <!-- modal -->
    <div id="song_modall" class="fw_modal shadow-depth-5 bg-white-01">
      <div class="fw_row">
        <div class="fw_column lg-10"><div class="h6">{heading}</div></div>
        <div class="fw_column lg-2 align_end"><i class="fas fa-times fw_close"></i></div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-12 fw_input_field textlabel">
          <input type="text" id="name" value="">
          <label for="artist" class="fw_flying_label"><?php _e('Artist or Radio Name', 'wptpa'); ?></label>
        </div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-9 fw_input_field textlabel">
          <input type="text" id="url" value="">
          <label for="title" class="fw_flying_label"><?php _e('Audio URL', 'wptpa'); ?></label>
        </div>
        <div class="fw_column lg-3 align_end">
          <button type="button" id="wptpa_select_audio" class="fw_btn"><?php _e('Browse', 'wptpa'); ?></button>
        </div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-12 align_end">
          <a href="#" id="fw_mdl_cancel" class="fw_btn flat"><?php _e('Cancel', 'wptpa'); ?></a>
          <a href="#" id="fw_mdl_ok" class="fw_btn"><?php _e('Save', 'wptpa'); ?></a>
        </div>
      </div>
    </div>
    <div class="fw_notify_wrapper"></div>
  </div>
</div>
<?php
}
?>