<?php 
//JSON_UNESCAPED_UNICODE
function wptpa_unescapted($string){
  $unescaped = preg_replace_callback('/\\\\u(\w{4})/', function ($matches) {
    return html_entity_decode('&#x' . $matches[1] . ';', ENT_COMPAT, 'UTF-8');
  }, $string);
  return $unescaped;
}
// randomID
function wptpa_randomID($length = 5) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyz';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}


//настройки по умолчанию
global $def;
$def = array(
  "autoplay" => false,
  "preload" => "auto",
  "compact" => false,
  "playlist" => true,
  "covers" => true,
  "shuffle" => true,
  "share" => true,
  "embed" => true,
  "stats" => true,
  "volume" => 75,
  "scrollbar" => 0,
  "font" => true,
  "window" => true,
  "radio_cover" => true,
  "radio_interval" => 30,
  "ads" => false,
  "ads_url" => null,
  "ads_mode" => "seconds",
  "ads_interval_sec" => 30,
  "ads_interval_song" => 5,
  "theme" => "default",
  "colors" => array(
    "player" => array(
      "background" => "#3C3352",
      "color" => "#359768",
      "button" => "#359768",
      "button_active" => "#FFED8F",
      "seek" => "#359768",
      "progress" => "#FFED8F",
      "timecode" => "#3C3352"
    ),
    "playlist" => array(
      "background" => "#359768",
      "color" => "#3C3352",
      "background_current" => "#FFED8F",
      "color_current" => "#3C3352"
    )
  ),
  "cpblts" => array(
    "playlists_page" => "edit_posts",
    "statistics_page" => "edit_posts",
    "settings_page" => "edit_posts",
    "ads_page" => "edit_posts",
    "data_page" => "edit_posts",
  )
);
/* themes */

function themeLoad($theme){
  switch ($theme) {
    case "1":
      $optn["player"]["background"] = "#303841";
      $optn["player"]["color"] = "#EEEEEE";
      $optn["player"]["button"] = "#EEEEEE";
      $optn["player"]["button_active"] = "#D72323";
      $optn["player"]["seek"] = "#3A4750";
      $optn["player"]["progress"] = "#D72323";
      $optn["player"]["timecode"] = "#EEEEEE";
      $optn["playlist"]["background"] = "#303841";
      $optn["playlist"]["color"] = "#EEEEEE";
      $optn["playlist"]["background_current"] = "#3A4750";
      $optn["playlist"]["color_current"] = "#EEEEEE";
      return $optn;
      break;
    case "2":
      $optn["player"]["background"] = "#EAEAEA";
      $optn["player"]["color"] = "#252A34";
      $optn["player"]["button"] = "#252A34";
      $optn["player"]["button_active"] = "#08d9d6";
      $optn["player"]["seek"] = "#252A34";
      $optn["player"]["progress"] = "#08d9d6";
      $optn["player"]["timecode"] = "#EAEAEA";
      $optn["playlist"]["background"] = "#252A34";
      $optn["playlist"]["color"] = "#EAEAEA";
      $optn["playlist"]["background_current"] = "#252A34";
      $optn["playlist"]["color_current"] = "#08d9d6";
      return $optn;
      break;
    case "3":
      $optn["player"]["background"] = "#eef1dd";
      $optn["player"]["color"] = "#5c3551";
      $optn["player"]["button"] = "#5c3551";
      $optn["player"]["button_active"] = "#ed4747";
      $optn["player"]["seek"] = "#5c3551";
      $optn["player"]["progress"] = "#ed4747";
      $optn["player"]["timecode"] = "#eef1dd";
      $optn["playlist"]["background"] = "#5c3551";
      $optn["playlist"]["color"] = "#eef1dd";
      $optn["playlist"]["background_current"] = "#ed4747";
      $optn["playlist"]["color_current"] = "#eef1dd";
      return $optn;
      break;
    case "4":
      $optn["player"]["background"] = "#212831";
      $optn["player"]["color"] = "#03e492";
      $optn["player"]["button"] = "#2e3846";
      $optn["player"]["button_active"] = "#03e492";
      $optn["player"]["seek"] = "#2e3846";
      $optn["player"]["progress"] = "#03e492";
      $optn["player"]["timecode"] = "#212831";
      $optn["playlist"]["background"] = "#2e3846";
      $optn["playlist"]["color"] = "#03e492";
      $optn["playlist"]["background_current"] = "#212831";
      $optn["playlist"]["color_current"] = "#03e492";
      return $optn;
      break;
    case "5":
      $optn["player"]["background"] = "#ededed";
      $optn["player"]["color"] = "#222831";
      $optn["player"]["button"] = "#222831";
      $optn["player"]["button_active"] = "#ff5722";
      $optn["player"]["seek"] = "#222831";
      $optn["player"]["progress"] = "#ff5722";
      $optn["player"]["timecode"] = "#ededed";
      $optn["playlist"]["background"] = "#303841";
      $optn["playlist"]["color"] = "#ededed";
      $optn["playlist"]["background_current"] = "#222831";
      $optn["playlist"]["color_current"] = "#ff5722";
      return $optn;
      break;
    case "6":
      $optn["player"]["background"] = "#F5F5F5";
      $optn["player"]["color"] = "#424242";
      $optn["player"]["button"] = "#424242";
      $optn["player"]["button_active"] = "#B9E937";
      $optn["player"]["seek"] = "#424242";
      $optn["player"]["progress"] = "#B9E937";
      $optn["player"]["timecode"] = "#F5F5F5";
      $optn["playlist"]["background"] = "#424242";
      $optn["playlist"]["color"] = "#F5F5F5";
      $optn["playlist"]["background_current"] = "#B9E937";
      $optn["playlist"]["color_current"] = "#424242";
      return $optn;
      break;
    case "7":
      $optn["player"]["background"] = "#303841";
      $optn["player"]["color"] = "#EEEEEE";
      $optn["player"]["button"] = "#EEEEEE";
      $optn["player"]["button_active"] = "#F6C90E";
      $optn["player"]["seek"] = "#3A4750";
      $optn["player"]["progress"] = "#F6C90E";
      $optn["player"]["timecode"] = "#EEEEEE";
      $optn["playlist"]["background"] = "#3A4750";
      $optn["playlist"]["color"] = "#EEEEEE";
      $optn["playlist"]["background_current"] = "#303841";
      $optn["playlist"]["color_current"] = "#F6C90E";
      return $optn;
      break;
    case "8":
      $optn["player"]["background"] = "#3E3E3E";
      $optn["player"]["color"] = "#B3A78C";
      $optn["player"]["button"] = "#B3A78C";
      $optn["player"]["button_active"] = "#F6E7C1";
      $optn["player"]["seek"] = "#B3A78C";
      $optn["player"]["progress"] = "#F6E7C1";
      $optn["player"]["timecode"] = "#3E3E3E";
      $optn["playlist"]["background"] = "#B3A78C";
      $optn["playlist"]["color"] = "#F6E7C1";
      $optn["playlist"]["background_current"] = "#F6E7C1";
      $optn["playlist"]["color_current"] = "#3E3E3E";
      return $optn;
      break;
    case "9":
      $optn["player"]["background"] = "#E2EFF1";
      $optn["player"]["color"] = "#65799B";
      $optn["player"]["button"] = "#65799B";
      $optn["player"]["button_active"] = "#B6D5E1";
      $optn["player"]["seek"] = "#65799B";
      $optn["player"]["progress"] = "#B6D5E1";
      $optn["player"]["timecode"] = "#555273";
      $optn["playlist"]["background"] = "#555273";
      $optn["playlist"]["color"] = "#B6D5E1";
      $optn["playlist"]["background_current"] = "#65799B";
      $optn["playlist"]["color_current"] = "#E2EFF1";
      return $optn;
      break;
    case "10":
      $optn["player"]["background"] = "#F33535";
      $optn["player"]["color"] = "#D8E9F0";
      $optn["player"]["button"] = "#33425B";
      $optn["player"]["button_active"] = "#D8E9F0";
      $optn["player"]["seek"] = "#33425B";
      $optn["player"]["progress"] = "#D8E9F0";
      $optn["player"]["timecode"] = "#F33535";
      $optn["playlist"]["background"] = "#33425B";
      $optn["playlist"]["color"] = "#D8E9F0";
      $optn["playlist"]["background_current"] = "#F33535";
      $optn["playlist"]["color_current"] = "#33425B";
      return $optn;
      break;
    case "default":
      $optn["player"]["background"] = "#FFFFFF";
      $optn["player"]["color"] = "#555555";
      $optn["player"]["button"] = "#555555";
      $optn["player"]["button_active"] = "#3EC3D5";
      $optn["player"]["seek"] = "#555555";
      $optn["player"]["progress"] = "#3EC3D5";
      $optn["player"]["timecode"] = "#FFFFFF";
      $optn["playlist"]["background"] = "#3EC3D5";
      $optn["playlist"]["color"] = "#FFFFFF";
      $optn["playlist"]["background_current"] = "#42CFE2";
      $optn["playlist"]["color_current"] = "#FFFFFF";
      return $optn;
      break;
    case "custom":
      break;
  }
}

// вывод списка плейлистов
function print_playlists_list($playlists){
  foreach($playlists as $k => $v) {
    $count = unserialize($v["items"]);
    if($count){
      $count = count($count);
    } else {
      $count = 0;
    }
    ?>
    <tr>
      <td class="fw_input_field"><label><input type="checkbox" name="idList[]" value="<?php echo $v["id"]; ?>"><span class="fw_checkbox"></span></label></td>
      <td><a href="?page=wptpa_playlists_page&action=edit&itemid=<?php echo $v["id"]; ?>"><?php echo $v["name"]; ?></a></td>
      <td>[wptpa id="<?php echo $v["id"]; ?>"]</td>
      <td><?php echo $count; ?></td>
      <td>
        <div class="fw_dropdown_wrapper">
          <div class="fw_select_dropdown">
            <i class="fas fa-ellipsis-v"></i>
          </div>
          <ul class="fw_dropdown_list">
            <li><a href="admin.php?page=wptpa_playlists_page&action=edit&itemid=<?php echo $v["id"]; ?>"><i class="fas fa-pencil-alt"></i><?php echo __("Edit", "wptpa"); ?></a></li>
            <li><a href="admin.php?page=wptpa_playlists_page&action=clone&itemid=<?php echo $v["id"]; ?>"><i class="fas fa-copy"></i><?php echo __("Clone", "wptpa"); ?></a></li>
            <li><a href="admin.php?page=wptpa_playlists_page&action=delete&itemid=<?php echo $v["id"]; ?>"><i class="fas fa-trash-alt"></i><?php echo __("Delete", "wptpa"); ?></a></li>
          </ul>
        </div>
      </td>
    </tr>
  <?php
  }
}

// playlist pagination
function playlistPaginations($total, $pagenum, $order, $typeorder, $link) {
  if($order && $typeorder) {
    $sort = '&order='.$order.'&type='.$typeorder;
  } else {
    $sort = '';
  }
  ?>
  <div class="fw_container shadow-depth-0 bg-white-01">
    <div class="fw_row">
      <div class="fw_column lg-12">
        <ul class="fw_pagination">
          <?php
            if($pagenum !== 1){
              echo '<li><a href="'.$link.$sort.'&pagenum='.($pagenum - 1).'">'.__('Previous', 'wptpa').'</a></li>';
            } else {
              echo '<li class="disabled">'.__('Previous', 'wptpa').'</li>';
            }
            if($pagenum - 4 > 0){
              echo '<li><a href="'.$link.$sort.'&pagenum=1">1</a></li>';
              echo '<li><span>...</span></li>';
            }
            for($i = 3; $i > 0; $i--) {
              if($pagenum - $i > 0){
                echo '<li><a href="'.$link.$sort.'&pagenum='.($pagenum - $i).'">'.($pagenum - $i).'</a></li>';
              }
            }

            echo '<li class="current"><a href="#">'.$pagenum.'</a></li>';

            for($i = 1; $i < 4; $i++) {
              if($pagenum + $i <= $total){
                echo '<li><a href="'.$link.$sort.'&pagenum='.($pagenum + $i).'">'.($pagenum + $i).'</a></li>';
              }
            }
  
            if($pagenum + 4 <= $total){
              echo '<li><span>...</span></li>';
              echo '<li><a href="'.$link.$sort.'&pagenum='.$total.'">'.$total.'</a></li>';
            }
            if($pagenum < $total){
              echo '<li><a href="'.$link.$sort.'&pagenum='.($pagenum + 1).'">'.__('Next', 'wptpa').'</a></li>';
            } else {
              echo '<li class="disabled">'.__('Next', 'wptpa').'</li>';
            }
          ?>
        </ul>
      </div>
    </div>
  </div>
  <?php
}

// вывод треков плейлисте
function print_playlist($playlist) {
  global $wpdb;
  $songs_table_name = $wpdb->prefix."tpa_songs";
  // проверяем есть ли в плелисте треки
  foreach($playlist as $k => $v){
    $song = $wpdb->get_row("SELECT * FROM $songs_table_name WHERE id = ".$v, ARRAY_A);
    // проверяем есть ли трек, так как его могли удалить через статистику
    if($song){
      $dwn = $song['dwn'] ? "on" : "";
      $buy = $song['buy'] ? "on" : "";
      $song = stripslashes_deep($song);
    ?>
      <tr title="<?php echo $song["artist"]; ?><?php echo !empty($song['title']) ? " - ".$song['title'] : ""; ?>">
        <td class="fw_input_field">
          <label>
            <input type="checkbox" name="idList[]" value="<?php echo $song['id']; ?>">
            <span class="fw_checkbox"></span>
          </label>
          <input type="hidden" name="playlist[items][<?php echo $k; ?>][id]" value="<?php echo $song["id"]; ?>">
          <input type="hidden" name="playlist[items][<?php echo $k; ?>][artist]" value="<?php echo htmlspecialchars($song["artist"]); ?>">
          <input type="hidden" name="playlist[items][<?php echo $k; ?>][title]" value="<?php echo htmlspecialchars($song["title"]); ?>">
          <input type="hidden" name="playlist[items][<?php echo $k; ?>][audio]" value="<?php echo $song["audio"]; ?>">
          <input type="hidden" name="playlist[items][<?php echo $k; ?>][cover]" value="<?php echo $song["cover"]; ?>">
          <input type="hidden" name="playlist[items][<?php echo $k; ?>][dwn]" value="<?php echo $song["dwn"]; ?>">
          <input type="hidden" name="playlist[items][<?php echo $k; ?>][buy]" value="<?php echo $song["buy"]; ?>">
        </td>
        <td class="wptpa_drag">
          <i class="fas fa-arrows-alt"></i>
        </td>
        <td class="wptpa_cover">
          <img src="<?php echo $song['cover']; ?>">
        </td>
        <td class="wptpa_song">
          <b><?php echo $song["artist"]; ?></b><?php echo !empty($song['title']) ? " - ".$song['title'] : ""; ?>
        </td>
        <td class="wptpa_dwn <?php echo $dwn; ?>" title="<?php echo __('Download Link', 'wptpa'); ?>">
          <i class='fas fa-download'></i>
        </td>
        <td class="wptpa_buy <?php echo $buy; ?>" title="<?php echo __('Buy Link', 'wptpa'); ?>">
          <i class='fas fa-shopping-cart'></i>
        </td>
      </tr>
      <?php
    }
  }
}

function print_ads_list($ads_list) {
  foreach($ads_list as $k => $v) {
    ?>
    <tr title="<?php echo $v["name"]; ?>">
      <td class="fw_input_field">
        <label>
          <input type="checkbox" name="idList[]" value="<?php echo $k; ?>">
          <span class="fw_checkbox"></span>
        </label>
        <input type="hidden" name="ads_list[<?php echo $k; ?>][name]" value="<?php echo htmlspecialchars($v["name"]); ?>">
        <input type="hidden" name="ads_list[<?php echo $k; ?>][url]" value="<?php echo $v["url"]; ?>">
      </td>
      <td class="wptpa_drag">
        <i class="fas fa-arrows-alt"></i>
      </td>
      <td class="wptpa_song">
        <b><?php echo $v["name"]; ?></b>
      </td>
    </tr>
    <?php
  }
}

// STATS
function convertNum($num){
  if($num >= 1000){
    $num = $num / 1000;
    return round($num, 2)."K";
  } else {
    return $num;
  }
}

function convertTime($secs){
  $bit = array(
    __('year', 'wptpa') => $secs / 31556926 % 12,
    __('week', 'wptpa') => $secs / 604800 % 52,
    __('day', 'wptpa') => $secs / 86400 % 7,
    __('hour', 'wptpa') => $secs / 3600 % 24,
    __('minute', 'wptpa') => $secs / 60 % 60,
    __('second', 'wptpa') => $secs % 60
  );
  $array = array();
  foreach($bit as $k => $v){
    // проверяем если элемент массива больше 0, берем его и останавливаем перебор
    if($v > 0) {
      // значение
      $array["time"] = $v;
      // если множественное число
      if($v > 1) {
        $array["time_name"] = $k.'s '.__('of playing', 'wptpa');
      }
      // если есдинственное число
      if($v == 1){
        $array["time_name"] = $k.' '.__('of playing', 'wptpa');
      }
      break;
    }
  }
  // если массив пустой
  if(!$array){
    $array["time"] = 0;
    $array["time_name"] = __('seconds of playing', 'wptpa');
  }
  return $array;
}


function convertTimeShort($secs){
  $bit = array(
    __('y', 'wptpa') => $secs / 31556926 % 12,
    __('w', 'wptpa') => $secs / 604800 % 52,
    __('d', 'wptpa') => $secs / 86400 % 7,
    __('h', 'wptpa') => $secs / 3600 % 24,
    __('m', 'wptpa') => $secs / 60 % 60,
    __('sec', 'wptpa') => $secs % 60
  );
  $ret = array();
  foreach($bit as $k => $v){
    if($v > 1){
      $ret[] = $v." ".$k.".";
    }
    if($v == 1){
      $ret[] = $v." ".$k.".";
    }
  }
  if($ret){
    return '~'.$ret[0];
  } else {
    return "0 ".__('sec', 'wptpa');
  }
}


// TOP SONGS_LIST

function createTopList($songs) {
  global $wpdb;
  $songs_table_name = $wpdb->prefix."tpa_songs";
  if($songs) {
    echo "<ul class='wptpa_top_list bg-blue-01 txt-white-01'>";
    foreach($songs as $k => $v){
      $id = $v["song_id"];
      $song = $wpdb->get_row("SELECT artist, title FROM $songs_table_name WHERE id = $id", ARRAY_A);
      $song = stripslashes_deep($song);
      if(!empty($song['title'])){
        echo "<li title='".$song['artist']." - ".$song['title']."'><i>".($k+1)."</i><b>".$song['artist']."</b> - ".$song['title']."</li>";
      } else {
        echo "<li title='".$song['artist']."'><i>".($k+1)."</i><b>".$song['artist']."</b></li>";
      }
    }
    echo "</ul>";
  } else {
  ?>
    <div class="fw_row">
      <div class="fw_column lg-12" style="padding: 50px 0;">
        <div class="wptpa_block txt_align_center">
          <img width="50px" src="<?php echo WPTPA_URL; ?>assets/img/information.svg">
          <div class="h5"><?php _e('No data', 'wptpa'); ?></div>
        </div>
      </div>
    </div>
  <?php
  }
}


/* AJAX */


// поиск плейлиста
function wptpa_search_playlist_callback() {
  global $wpdb;
  $pls_table_name = $wpdb->prefix."tpa_playlist";
  $searchValue = $_POST['searchValue'];
  
  $pls_list = $wpdb->get_results("SELECT * FROM $pls_table_name WHERE name LIKE '%$searchValue%' ORDER by name", ARRAY_A);
  // если нашло что-то
  if($pls_list){
    $pls_list = stripslashes_deep($pls_list);
    $html = '<table>';
    foreach($pls_list as $k => $v){
      $html .= '<tr>';
      $html .= '<td><a href="?page=wptpa_playlists_page&action=edit&itemid='.$v["id"].'">'.$v["name"].'</a></td>';
      $html .= '</tr>';
    }  
    $html .= '</table>';
  } else {
    $html = '<h2 style="padding: 20px 0; text-align: center;">Not found</h2>';
  }
  echo $html;
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}
add_action( 'wp_ajax_wptpa_search_playlist', 'wptpa_search_playlist_callback');

// поиск трека в статистике
function wptpa_search_song_callback() {
  global $wpdb;
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $searchValue = $_POST['searchValue'];
  $song_list = $wpdb->get_results("SELECT * FROM $songs_table_name WHERE artist LIKE '%$searchValue%' OR title LIKE '%$searchValue%' ORDER by artist", ARRAY_A);
  // если нашло что-то
  if($song_list) {
    $song_list = stripslashes_deep($song_list);
    $html = '<table>';
    foreach($song_list as $k => $v){
      $html .= '<tr>';
      $name = $v["artist"];
      $name .= !empty($v["title"]) ? " - ".$v["title"] : "";
      $html .= '<td><a href="?page=wptpa_statistics&sngid='.$v["id"].'">'.$name.'</a></td>';
      $html .= '';
      $html .= '</tr>';
    }
    $html .= '</table>';
  } else {
    $html = '<h2 style="padding: 20px 0; text-align: center;">Not found</h2>';
  }
  echo $html;
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}
add_action( 'wp_ajax_wptpa_search_song', 'wptpa_search_song_callback');

// ститистика в админке
function wptpa_load_range_list($song_id) {
  //var_dump($_POST);
  global $wpdb;
  if(!$song_id){
    $song_id = $_POST["song_id"];
  }
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  $q = $wpdb->get_results("SELECT date FROM $stats_table_name WHERE song_id = $song_id GROUP BY DATE_FORMAT(date, '%Y%m') ORDER BY date DESC", ARRAY_A);
  foreach($q as $k => $v){
    $array[$k]["name"] = date("F Y", strtotime($v["date"]));
    $array[$k]["value"] = date("Y-m", strtotime($v["date"]));
  }
  return $array;
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}

add_action('wp_ajax_wptpa_load_range_list', 'wptpa_load_range_list');


function wptpa_load_period() {
  //var_dump($_POST);
  global $wpdb;
  //echo json_encode($_POST);
  $song_id = $_POST["song_id"];
  $period = $_POST["period"];
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  if($period){
    $q = $wpdb->get_results("SELECT * FROM $stats_table_name WHERE date_format(`date`, '%Y%m') = date_format('$period-01', '%Y%m') AND song_id = $song_id ORDER BY date", ARRAY_A);
  } else {
    $q = $wpdb->get_results("SELECT * FROM $stats_table_name WHERE song_id = $song_id ORDER BY date DESC LIMIT 30", "ARRAY_A");
    $q = array_reverse($q);
  }
  foreach($q as $k => $v) {
    $q[$k]["date"] = $newDate = date("j M", strtotime($v["date"]));;
  }
  echo json_encode($q);
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}

add_action('wp_ajax_wptpa_load_period', 'wptpa_load_period');


/* GUTENBERG */
// guttenberg config generate
function wptpa_generate_config_gutenberg() {
  global $wpdb;
  
  $atts = $_POST["settings"];
  $id = $_POST["id"];
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $pls_table_name = $wpdb->prefix."tpa_playlist";
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  $wptpa_settings = get_option("wptpa_optn");
  // перевеоди в буль
  foreach($atts as $k => $v){
    if($v == "false"){
      $atts[$k] = false;
    }
    if($v == "true"){
      $atts[$k] = true;
    }
  }
  // обьеденяем массивы
  $wptpa_settings = array_merge($wptpa_settings, $atts);
  
  // проверяем если выбран топ 10 выводим его, если нет просто плс
  switch($id) {
    case "default":
      $pls = false;
      break;
    case "topweek":
      $topweek = $wpdb->get_results("SELECT song_id, SUM(count) AS weekcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 7 DAY GROUP BY song_id ORDER BY weekcount DESC LIMIT 0,10", ARRAY_A);
      if($topweek){
        if(count($topweek) >= 10){
          $pls["id"] = "topweek";
          $pls["name"] = "topweek";
          foreach($topweek as $k => $v){
            $pls["items"][] = $v["song_id"];
          }
          $pls["items"] = serialize($pls["items"]);
        }
      }
      break;
    case "topmonth":
      $topmonth = $wpdb->get_results("SELECT song_id, SUM(count) AS monthcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 30 DAY GROUP BY song_id ORDER BY monthcount DESC LIMIT 0,10", ARRAY_A);
      if($topmonth) {
        if(count($topmonth) >= 10) {
          $pls["id"] = "topmonth";
          $pls["name"] = "topmonth";
          foreach($topmonth as $k => $v){
            $pls["items"][] = $v["song_id"];
          }
          $pls["items"] = serialize($pls["items"]);
        }
      }
      break;
    case "mostplayed":
      $mostPlayed = $wpdb->get_results("SELECT * FROM $songs_table_name ORDER BY `all_count` DESC LIMIT 0,10", ARRAY_A);
      if($mostPlayed) {
        if(count($mostPlayed) >= 10) {
          $pls["id"] = "mostplayed";
          $pls["name"] = "mostplayed";
          foreach($mostPlayed as $k => $v){
            $pls["items"][] = $v["id"];
          }
          $pls["items"] = serialize($pls["items"]);
        }
      }
      break;
    default:
      $pls = $wpdb->get_row("SELECT * FROM $pls_table_name WHERE id = ".$id, ARRAY_A);
      break;
  }
  //если есть плейлист
  if($pls){
    // конвертируем список песен в массив
    $sngs_id = unserialize($pls["items"]);
    // получаем треки
    foreach($sngs_id as $k => $v){
      $wptpa_songs[] = stripslashes_deep($wpdb->get_row("SELECT * FROM $songs_table_name WHERE id = $v", "ARRAY_A"));
    }
    $wptpa_settings["playlist"] = $wptpa_songs;
    $wptpa_settings["playlistId"] = $id;
    // переводим в json
    $wptpa_settings = (wptpa_unescapted(json_encode($wptpa_settings)));
    echo $wptpa_settings;
  }
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}

add_action('wp_ajax_wptpa_generate_config_gutenberg', 'wptpa_generate_config_gutenberg');








//frontend
// shuffle
function shuffle_change(){
  if($_POST['shuffle'] === "true") {
    setcookie('shuffle', 1, time()+1209600, COOKIEPATH, COOKIE_DOMAIN, false);
    echo "shuffle on";
  } else {
    setcookie('shuffle', '', time() - 3600, COOKIEPATH, COOKIE_DOMAIN, false);
    echo "shuffle off";
  }
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}
add_action('wp_ajax_shuffle_change', 'shuffle_change');
add_action('wp_ajax_nopriv_shuffle_change', 'shuffle_change');

// volume
function volume_change(){
  setcookie('volume', $_POST['volume'], time()+1209600, COOKIEPATH, COOKIE_DOMAIN, false);
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}
add_action('wp_ajax_volume_change', 'volume_change');
add_action('wp_ajax_nopriv_volume_change', 'volume_change');

// update_stat
function wptpa_update_stat(){
  global $wpdb;
  $song_id = intval($_POST["song_id"]);
  $date = current_time("Y-m-d", 1);
  $time = intval($_POST["time"]);
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  // обновляем данные трека, берем старые
  $q = $wpdb->get_row("SELECT all_time, all_count FROM $songs_table_name WHERE id = $song_id", ARRAY_A);
  // добавляем к ним полученные
  $data_song = array(
    "all_count" => intval($q["all_count"]) + 1,
    "all_time" => intval($q["all_time"]) + $time
  );
  // обновляем данные
  $q = $wpdb->update($songs_table_name, $data_song, array("id" => $song_id));
  echo "обновляем данные трека, результат обновления = $q |";
  // проверяем есть ли запись за сегодня
  $q = $wpdb->get_row("SELECT * FROM $stats_table_name WHERE song_id = $song_id AND date = '$date'", ARRAY_A);
  // если есть запись за сегодня обновляем ее
  if($q){
    // получаем текущие данные в статистике
    $q = $wpdb->get_row("SELECT time, count FROM $stats_table_name WHERE song_id = $song_id AND date = '$date'", ARRAY_A);
    // добавляем к ним полученные
    $data_stat = array(
      "time" => intval($q["time"]) + $time,
      "count" => intval($q["count"]) + 1
    );
    // обновляем статистику
    $q = $wpdb->update($stats_table_name, $data_stat, array("song_id" => $song_id, "date" => $date));
    echo "статистка: есть запись за сегодня, результат обновления = $q |";
  } else {
    // если записи нет, добавляем новую запись
    $data_stat = array(
      "date" => $date,
      "song_id" => $song_id,
      "time" => $time,
      "count" => 1,
      "download" => 0
    );
    $q = $wpdb->insert($stats_table_name, $data_stat);
    echo "статистка: нету запись за сегодня, результат добавления = $q |";
  }
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}
add_action('wp_ajax_wptpa_update_stat', 'wptpa_update_stat');
add_action('wp_ajax_nopriv_wptpa_update_stat', 'wptpa_update_stat');

// update_stat dwn
function wptpa_update_stat_dwn(){
  global $wpdb;
  $song_id = intval($_POST["song_id"]);
  $date = current_time("Y-m-d", 1);
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  // обновляем данные трека, берем старые
  $q = $wpdb->get_row("SELECT all_dwn FROM $songs_table_name WHERE id = $song_id", ARRAY_A);
  // добавляем к ним полученные
  $data_song = array(
    "all_dwn" => intval($q["all_dwn"]) + 1
  );
  // обновляем данные
  $q = $wpdb->update($songs_table_name, $data_song, array("id" => $song_id));
  echo "обновляем данные трека, результат обновления = $q |";
  // проверяем есть ли запись за сегодня
  $q = $wpdb->get_row("SELECT * FROM $stats_table_name WHERE song_id = $song_id AND date = '$date'", ARRAY_A);
  // если есть запись за сегодня обновляем ее
  if($q){
    // получаем текущие данные в статистике
    $q = $wpdb->get_row("SELECT download FROM $stats_table_name WHERE song_id = $song_id AND date = '$date'", ARRAY_A);
    // добавляем к ним полученные
    $data_stat = array(
      "download" => intval($q["download"]) + 1
    );
    // обновляем статистику
    $q = $wpdb->update($stats_table_name, $data_stat, array("song_id" => $song_id, "date" => $date));
    echo "статистка: есть запись за сегодня, результат обновления = $q |";
  } else {
    // если записи нет, добавляем новую запись
    $data_stat = array(
      "date" => $date,
      "song_id" => $song_id,
      "time" => 0,
      "count" => 0,
      "download" => 1
    );
    $q = $wpdb->insert($stats_table_name, $data_stat);
    echo "статистка: нету запись за сегодня, результат добавления = $q |";
  }
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}
add_action('wp_ajax_wptpa_update_stat_dwn', 'wptpa_update_stat_dwn');
add_action('wp_ajax_nopriv_wptpa_update_stat_dwn', 'wptpa_update_stat_dwn');


// get curent song

function CurlConnect($url){
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 5);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 6.0; en-US; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11 (.NET CLR 3.5.30729)');
  //проверяем на ошибки, если есть ошибки возращаем нулл, нет ошибок - отдаем реузльтат
  if(curl_exec($ch) === false){
    $result = null;
  } else {
    $result = curl_exec($ch);
  }
  curl_close($ch);
  return $result;
}

function getSong($scheme, $host, $port, $mount){
  //в первую очередь проверим mount если есть слово stream, значит это шоуткаст
  if(strripos($mount, "stream")){
    //мы знаем что это шоуткаст получаем сид
   // shoutcast
    preg_match('/\d+/', $mount, $matches);
    $sid = $matches[0];
    //проверям если получили json ответ значит это шоуткас в2
    // формируем ссылку из присланных данных
    $ch = @file_get_contents("$scheme://$host:$port/currentsong?sid=$sid&json=1");
    //если вернул ответ значит новый шоуткаст
    if($ch){
      // Shoutcast NEW
      $data = explode("-", $ch); // рабзбиваем на артиста и название
      // если есть минимум два э-та то берем название и артиста если нет возращаем название
      if(count($data) > 1){
        $song["artist"] = trim($data[0]);
        $song["title"] = trim($data[1]);
        return $song;
      } else {
        return $data[0];
      }
    } else {
      // Shoutcast Old
      $ch = CurlConnect("$scheme://$host:$port/7.html");
      $ch = strip_tags($ch); // читстим от хтмл
      $pieces = explode(",", $ch); //разбиваем на массив через запятые
      $data = $pieces[count($pieces)-1]; // берем последний эл-т массива
      $data = explode("-", $data); // рабзбиваем на артиста и название
      // если есть минимум два э-та то берем название и артиста если нет возращаем название
      if(count($data) > 1){
        $song["artist"] = trim($data[0]);
        $song["title"] = trim($data[1]);
        return $song;
      } else {
        return $data[0];
      }
    }
  } else {
    // icecast
    $ch = CurlConnect("$scheme://$host:$port$mount.xspf");
    $xml = simplexml_load_string($ch);
    $data = trim($xml->trackList->track->title);
    $data = explode("-", $data); // рабзбиваем на артиста и название
    // если есть минимум два э-та то берем название и артиста если нет возращаем название
    if(count($data) > 1){
      $song["artist"] = trim($data[0]);
      $song["title"] = trim($data[1]);
      return $song;
    } else {
      return $data[0];
    }
  }
}

function getCover($data){
  $artist = $data["artist"];
  $title = $data["title"];
  // удаляем все что в скобках - баг, так как скобки считаются маской в регулярных выражениях
  $title = preg_replace('/\\s*\\([^()]*\\)\\s*/', '', $title);
  // запрашиваем джесон с песнями артиста
  $url = "https://itunes.apple.com/search?term=".urlencode($artist);
  $result = CurlConnect($url);
  // декодируем джесон в масиив
  $result = json_decode($result, true);
  //var_dump($url);
  //var_dump($result);
  //делаем проверку получили или нет, если не пришел нулл, то работаем, если нулл или нет инфы то останавливаемся
  if($result != null AND $result["resultCount"] != 0){
    // перибираем массив, ищем соответсвие и возращаем ключ, берем последний результат
    foreach($result['results'] as $key => $value){
	 if(preg_match("/^$title/i", $value['trackName'])){
	   $index = $key;
     }
	}
    // если прислан ключ, формирируем ссылку на картинку, нету возращаем нулл
    if(isset($index)){
      $img = substr($result['results'][$index]['artworkUrl100'], 0, -13);
			$result = $img.'500x500bb.jpg';
    } else {
      $result = null;
    }
  } else {
    $result = null;
  }
  return $result;
}

function wptpa_getCurrentSong(){
  $cover = $_POST["cover"];
  $url = $_POST["url"];
  $parseUrl = parse_url($url);
  $data = getSong($parseUrl["scheme"], $parseUrl["host"], $parseUrl["port"], $parseUrl["path"]);
  if($cover){
    $data["cover"] = getCover($data);
  }
  echo json_encode($data);
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}
add_action('wp_ajax_wptpa_getCurrentSong', 'wptpa_getCurrentSong');
add_action('wp_ajax_nopriv_wptpa_getCurrentSong', 'wptpa_getCurrentSong');


function wptpa_getType(){
  $url = $_POST["url"];
  $parseUrl = parse_url($url);
  //var_dump($parseUrl);
  if(isset($parseUrl["port"])){
    echo "true";
  } else {
    echo "false";
  }
  wp_die(); // выход нужен для того, чтобы в ответе не было ничего лишнего, только то что возвращает функция
}
add_action('wp_ajax_wptpa_getType', 'wptpa_getType');
add_action('wp_ajax_nopriv_wptpa_getType', 'wptpa_getType');



// export sql wptpa

function wptpa_export_data() {
  global $wpdb;
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $playlists_table_name = $wpdb->prefix."tpa_playlist";
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  
  $tables[] = $songs_table_name;
  $tables[] = $playlists_table_name;
  $tables[] = $stats_table_name;
  
  $sqlScript = "";
  
  foreach($tables as $table){
    // Prepare SQLscript for creating table structure
    //$result = $wpdb->get_results("SHOW CREATE TABLE $table", ARRAY_A);
    //$sqlScript .= "\n\n" . $result[0]['Create Table'] . ";\n\n";
    
    $result = $wpdb->get_results("SELECT * FROM $table", ARRAY_A);
    // Prepare SQLscript for dumping data for each table
    $sqlScript .= "INSERT INTO $table (";
    foreach($result as $row){
      $array = null;
      foreach($row as $columnName => $columnValue){
        $array[] = "`".$columnName."`";
      }
      $string = implode(", ", $array);
      break;
    }
    $sqlScript .= $string.") VALUES \n";
    $arrayRow = null;
    foreach($result as $row){
      $stringVal = "(";
      $arrayVal = null;
      foreach($row as $columnName => $columnValue){
        $arrayVal[] = '"' . $columnValue . '"';
      }
      $stringVal .= implode(",", $arrayVal);
      $stringVal .= ')';
      $arrayRow[] = $stringVal;
    }
    $rows = implode(",\n", $arrayRow);
    $sqlScript .= $rows.";\n\n";
  }
  echo $sqlScript;
  wp_die();
}
add_action('wp_ajax_wptpa_export_data', 'wptpa_export_data');

?>