<?php
function wptpa_block_for_gutenberg() {
  global $wpdb;
  $pls_table_name = $wpdb->prefix."tpa_playlist";
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  $songs_table_name = $wpdb->prefix."tpa_songs";
  //получаем плейлисты
  $pls_list = $wpdb->get_results("SELECT id, name FROM $pls_table_name", ARRAY_A);
  $pls_list = stripslashes_deep($pls_list);
  $topweek = $wpdb->get_results("SELECT song_id, SUM(count) AS weekcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 7 DAY GROUP BY song_id ORDER BY weekcount DESC LIMIT 0,10", ARRAY_A);
  $topmonth = $wpdb->get_results("SELECT song_id, SUM(count) AS monthcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 30 DAY GROUP BY song_id ORDER BY monthcount DESC LIMIT 0,10", ARRAY_A);
  $mostPlayed = $wpdb->get_results("SELECT * FROM $songs_table_name ORDER BY `all_count` DESC LIMIT 0,10", ARRAY_A);
  if($mostPlayed){
    if(count($mostPlayed) >= 10){
      array_unshift($pls_list, array("id" => "mostplayed", "name" => "Top 10 of Most Played"));
    }
  }
  if($topmonth){
    if(count($topmonth) >= 10){
      array_unshift($pls_list, array("id" => "topmonth", "name" => "Top 10 of The Month"));
    }
  }
  if($topweek){
    if(count($topweek) >= 10){
      array_unshift($pls_list, array("id" => "topweek", "name" => "Top 10 of Week"));
    }
  }
  
  wp_register_style(
    'wptpa_style_editor',
    WPTPA_URL.'/assets/css/wptpa_block_editor.css',
    array('wp-edit-blocks')
  );
  
  wp_register_script(
    'wptpa_script_editor',
    WPTPA_URL.'/block/block.js',
    array( 'wp-blocks', 'wp-element', 'wp-editor', 'wp-components' )
  );
  
  wp_localize_script('wptpa_script_editor', 'playlists_list', 
    $pls_list
  ); 
  
  register_block_type('wptpa-block/wptpa', array(
    'editor_script' => 'wptpa_script_editor',
    'editor_style' => 'wptpa_style_editor',
  ));
}

if (function_exists('register_block_type')) {
  add_action('init', 'wptpa_block_for_gutenberg');
}

?>