<?php
function wptpa_statistics_page() {
  global $wpdb;
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  $notify = ""; // уведомления
  
  // если прислано удалить трек
  if(isset($_POST["action"]) == "delete") {
    // проверяем, если присланы айди, удаляем
    if(isset($_POST["idList"])) {
      $idlist = $_POST["idList"];
      foreach($idlist as $k => $v){
        // получаем имя удаляемого плейлиста
        $song = $wpdb->get_row("SELECT artist, title FROM $songs_table_name WHERE id = ".$v, ARRAY_A);
        if(!empty($song['title'])){
          $song = $song['artist']." - ".$song['title'];
        } else {
          $song = $song['artist'];
        }
        // удаляем со статистики
        $wpdb->delete($stats_table_name, array("song_id" => $v));
        // очищаем статистику трека
        $wpdb->update($songs_table_name,
          array('all_time' => 0, "all_dwn" => 0, "all_count" => 0),
          array('id' => $v)
        );
        $notify .= 'notifyFW.send({"heading": "'.__('Clear', 'wptpa').'","text": "'.__('Item', 'wptpa').'<b>'.$song.'</b>'.__('was Cleared.', 'wptpa').'"});';
      }
    } else {
      // если не прислали айди
      // выводим ошибку
      $notify .= 'notifyFW.send({"heading": "'.__('Clear', 'wptpa').'", "text": "'.__("Please, <b>Select</b> the item for Deleting.", 'wptpa').'"});';
    }
  }

  // получаем топы
  //день
  $topday = $wpdb->get_results("SELECT song_id, count FROM $stats_table_name WHERE date = CURDATE() ORDER BY count DESC LIMIT 0,10", ARRAY_A);
  //var_dump($topday);
  //неделя
  $topweek = $wpdb->get_results("SELECT song_id, SUM(count) AS weekcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 7 DAY GROUP BY song_id ORDER BY weekcount DESC LIMIT 0,10", ARRAY_A);
  //var_dump($topweek);
  //месяц
  $topmonth = $wpdb->get_results("SELECT song_id, SUM(count) AS monthcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 30 DAY GROUP BY song_id ORDER BY monthcount DESC LIMIT 0,10", ARRAY_A);
  //var_dump($topmonth);
  // кол-во записей на страницу
  $onpage = 10;
  //извлекаем номер текущей страницы, если отсуствует то берем первую
  $pagenum = isset($_GET["pagenum"]) ? $_GET["pagenum"] : 1;
  
  // если прислан тип сортировки получаем его
  $order = isset($_GET["order"]) ? $_GET["order"] : "artist";
  // если прислан порядок сортировки получаем его
  $typeorder = isset($_GET["type"]) ? $_GET["type"] : "ASC";

  // cоздаем массив линков  
  $orderLinks["name"] = "?page=wptpa_statistics_page&pagenum=$pagenum&order=artist&type=";
  $orderLinks["all_time"] = "?page=wptpa_statistics_page&pagenum=$pagenum&order=all_time&type=";
  $orderLinks["all_count"] = "?page=wptpa_statistics_page&pagenum=$pagenum&order=all_count&type=";
  $orderLinks["all_dwn"] = "?page=wptpa_statistics_page&pagenum=$pagenum&order=all_dwn&type=";
  
  //генерируем порядок сортировки
  switch($order) {
    case "artist":
      $orderLinks["name"] .= $typeorder == "DESC" ? "ASC" : "DESC";
      $orderLinks["all_time"] .= "DESC";
      $orderLinks["all_count"] .= "DESC";
      $orderLinks["all_dwn"] .= "DESC";
    break;
    case "all_time":
      $orderLinks["name"] .= "ASC";
      $orderLinks["all_time"] .= $typeorder == "DESC" ? "ASC" : "DESC";
      $orderLinks["all_count"] .= "DESC";
      $orderLinks["all_dwn"] .= "DESC";
    break;
    case "all_count":
      $orderLinks["name"] .= "ASC";
      $orderLinks["all_time"] .= "DESC";
      $orderLinks["all_count"] .= $typeorder == "DESC" ? "ASC" : "DESC";
      $orderLinks["all_dwn"] .= "DESC";
    break;
    case "all_dwn":
      $orderLinks["name"] .= "ASC";
      $orderLinks["all_time"] .= "DESC";
      $orderLinks["all_count"] .= "DESC";
      $orderLinks["all_dwn"] .= $typeorder == "DESC" ? "ASC" : "DESC";
    break;
  }
  
  // Вытаскиваем кол-во записей, всего времени, прослушиваний и загрузок
  $q = $wpdb->get_row("SELECT COUNT(id) AS countsongs, sum(all_time) AS all_time, sum(all_count) AS all_count, sum(all_dwn) AS all_dwn FROM $songs_table_name", ARRAY_A);
  // кол-во записей
  $countsongs = intval($q["countsongs"]);
  // находим общие кол-во страниц
  $total = intval(($countsongs - 1) / $onpage) + 1;
  //определяем начало записей для текущей страницы
  $pagenum = intval($pagenum);
  // Если значение $pagenum меньше единицы или отрицательно
  // переходим на первую страницу
  // А если слишком большое, то переходим на последнюю
  if(empty($pagenum) or $pagenum < 0) $pagenum =1;
  if($pagenum > $total) $pagenum = $total;
  // Вычисляем начиная к какого номера
  // следует выводить сообщения
  $start = $pagenum * $onpage - $onpage;
  // получаем песни
  $songs = $wpdb->get_results("SELECT id, artist, title, all_time, all_count, all_dwn FROM $songs_table_name ORDER by $order $typeorder LIMIT $start, $onpage", ARRAY_A);
  $songs = stripslashes_deep($songs);
?>
<div class="wrap">
  <div class="fw_wrapper" style="display: none;">
    <?php if(!isset($_GET["sngid"])){ ?>
    <div class="fw_container shadow-depth-0 bg-white-01">
      <div class="fw_row">
        <div class="fw_column lg-6">
          <div class="h5"><?php _e('Statistics of Songs', 'wptpa'); ?></div>
        </div>
        <div class="fw_column lg-6 fw_input_field">
          <input id="wptpa_search_songs" type="text" placeholder="<?php _e('Search Song', 'wptpa'); ?>" class="fw_filled">
          <div id="wptpa_search_results" class="shadow-depth-5 bg-white-01"></div>
        </div>
      </div>
    </div>
    <!-- MAIN -->
    <!-- TOP ALL -->
    <div class="fw_container shadow-depth-0 bg-white-01">
     <!-- ALL STATS -->
      <div id="wptpa_stats_all" class="fw_row">
        <div class="fw_column lg-4 txt_align_center">
          <!-- times -->
          <div class="wptpa_stat_wrapper bg-white-02">
            <?php
            if($q["all_time"]) {
              $time = convertTime($q["all_time"]);
            ?>
            <div class="h1 txt-blue-01">~<?php echo $time["time"]; ?></div>
            <div class="fw_subheading"><?php echo $time["time_name"]; ?></div>
            <?php } else { ?>
            <div class="h1 txt-blue-01"><?php echo __('No data', 'wptpa'); ?></div>
            <?php } ?>
          </div>
        </div>
        <div class="fw_column lg-4 txt_align_center">
          <!-- count -->
          <div class="wptpa_stat_wrapper bg-white-02">
            <?php if($q["all_count"]) { ?>
            <div class="h1 txt-blue-01"><?php echo convertNum($q["all_count"]); ?></div>
            <div class="fw_subheading"><?php echo __('times played', 'wptpa'); ?></div>
            <?php } else { ?>
            <div class="h1 txt-blue-01"><?php echo __('No data', 'wptpa'); ?></div>
            <?php } ?>
          </div>
        </div>
        <div class="fw_column lg-4 txt_align_center">
          <!-- download -->
          <div class="wptpa_stat_wrapper bg-white-02">
            <?php if($q["all_dwn"]) { ?>
            <div class="h1 txt-blue-01"><?php echo convertNum($q["all_dwn"]); ?></div>
            <div class="fw_subheading"><?php echo __('times downloaded', 'wptpa'); ?></div>
            <?php } else { ?>
            <div class="h1 txt-blue-01"><?php echo __('No data', 'wptpa'); ?></div>
            <?php } ?>
          </div>
        </div>
      </div>
      <!-- TOP 10 -->
      <div class="fw_row" id="top_heading">
        <!-- TOP day -->
        <div class="fw_column lg-4 txt_align_center">
          <div class="wptpa_block bg-white-02">
            <div class="h4 "><?php _e('TOP OF THE DAY', 'wptpa'); ?></div>
          </div>
        </div>
        <!-- TOP week -->
        <div class="fw_column lg-4 txt_align_center">
          <div class="wptpa_block bg-white-02">
            <div class="h4"><?php _e('TOP OF THE WEEK', 'wptpa'); ?></div>
          </div>
        </div>
        <!-- TOP month -->
        <div class="fw_column lg-4 txt_align_center">
          <div class="wptpa_block bg-white-02">
            <div class="h4"><?php _e('TOP OF THE MONTH', 'wptpa'); ?></div>
          </div>
        </div>
      </div>
      <div class="fw_row align_top">
        <!-- TOP day -->
        <div class="fw_column lg-4">
          <?php createTopList($topday); ?>
        </div>
        <!-- TOP week -->
        <div class="fw_column lg-4">
          <?php createTopList($topweek); ?>
        </div>
        <!-- TOP month -->
        <div class="fw_column lg-4">
          <?php createTopList($topmonth); ?>
        </div>
      </div>
      <!--- SONG STATS -->
      <?php if($songs) { ?>
      <form action="" method="post">
        <table id="wptpa_song_list" class="hl">
          <thead>
            <tr>
              <th class="fw_input_field">
                <label>
                  <input id="select_all" type="checkbox">
                  <span class="fw_checkbox"></span>
                </label>
              </th>
              <th title="<?php _e('Song', 'wptpa'); ?>"><a href="<?php echo $orderLinks["name"]; ?>"><?php _e('Song', 'wptpa'); ?></a> <i class="fas fa-sort"></i></th>
              <th title="<?php _e('Time', 'wptpa'); ?>"><a href="<?php echo $orderLinks["all_time"]; ?>"><?php _e('Time', 'wptpa'); ?></a> <i class="fas fa-sort"></i></th>
              <th title="<?php _e('Plays', 'wptpa'); ?>"><a href="<?php echo $orderLinks["all_count"]; ?>"><?php _e('Plays', 'wptpa'); ?></a> <i class="fas fa-sort"></i></th>
              <th title="<?php _e('Downloads', 'wptpa'); ?>"><a href="<?php echo $orderLinks["all_dwn"]; ?>"><?php _e('Downloads', 'wptpa'); ?> </a><i class="fas fa-sort"></i></th>
            </tr>
          </thead>
          <tbody>
            <?php foreach($songs as $k => $v) { ?>
              <tr>
                <td class="fw_input_field"><label><input type="checkbox" name="idList[]" value="<?php echo $v["id"]; ?>"><span class="fw_checkbox"></span></label></td>
                <td><a title="<?php if(!empty($v['title'])){ echo $v["artist"].' - '.$v["title"]; } else { echo $v["artist"]; } ?>" href="?page=wptpa_statistics_page&sngid=<?php echo $v["id"]; ?>">
                <?php if(!empty($v['title'])){ echo '<b>'.$v["artist"].'</b> - '.$v["title"]; } else { echo '<b>'.$v["artist"].'</b>'; } ?>
                </a></td>
                <td title="<?php echo number_format($v["all_time"], 0, "", " ")." sec"; ?>"><?php echo convertTimeShort($v["all_time"]); ?></td>
                <td title="<?php echo number_format($v["all_count"], 0, "", " "); ?>"><?php echo convertNum($v["all_count"]); ?></td>
                <td title="<?php echo number_format($v["all_dwn"], 0, "", " "); ?>"><?php echo convertNum($v["all_dwn"]); ?></td>
              </tr>
            <?php } ?>
          </tbody>
        </table>
        <div class="fw_row">
          <div class="fw_column lg-12 align_end">
            <button type="submit" name="action" value="delete" class="fw_btn red"><i class="fas fa-trash-alt"></i><?php _e('Delete', 'wptpa'); ?></button>
          </div>
        </div>
      </form>
      <?php } else { ?>
      <div class="fw_row">
        <div class="fw_column lg-12" style="padding: 50px 0;">
          <div class="wptpa_block txt_align_center">
            <img width="50px" src="<?php echo WPTPA_URL; ?>assets/img/information.svg">
            <div class="h5"><?php _e('No data', 'wptpa'); ?></div>
          </div>
        </div>
      </div>
      <?php } ?>
    </div>
      <!--- pagination -->
      <?php 
      // если больше одной страницы выводим навигацию
      if($total > 1){
        playlistPaginations($total, $pagenum, $order, $typeorder, "?page=wptpa_statistics_page");
      }
      ?>
  <?php } else {
    $song_id =$_GET["sngid"];
    $period = wptpa_load_range_list($song_id);
  ?>
    <div class="fw_container shadow-depth-0 bg-white-01">
      <div class="fw_row">
        <div class="fw_column lg-8">
          <div class="h5"><?php _e('Statistics of Songs', 'wptpa'); ?></div>
        </div>
        <div class="fw_column lg-4 fw_input_field">
          <select name="wptpa_chart_range" id="wptpa_chart_range" data-sngid="<?php echo $_GET["sngid"]; ?>">
            <option selected value=''>Last 30 days</option>
            <?php
              foreach($period as $k => $v){
                echo '<option value="'.$v["value"].'">'.$v["name"].'</option>';
              }
            ?>
          </select>
        </div>
      </div>
    </div>
    <!-- STATS CHARTS -->
    <div class="fw_container shadow-depth-0 bg-white-01">
      <div class="fw_row"><canvas height="300" id="wptpa_time"></canvas></div>
      <div class="fw_row"><canvas height="300" id="wptpa_count"></canvas></div>
      <div class="fw_row"><canvas height="300" id="wptpa_dwn"></canvas></div>
    </div>
  <?php } ?>
    <div class="fw_notify_wrapper"></div>
  </div>
</div>
<script>
jQuery(document).ready(function($){
  <?php echo $notify; ?>
});
</script>
<?php
}
?>