<?php

// Action to add custom css in head
add_action('wp_footer', "wptpa_add_custom_css", 20);
add_action('admin_head', 'wptpa_add_custom_css');
function wptpa_add_custom_css() {
  $wptpa_settings = get_option("wptpa_optn");
  
  // проверяем есть ли настройки
  if($wptpa_settings){
    // если выбрана не пользовательская тема, загружаем ее палитру
    if($wptpa_settings["theme"] !== "custom"){
      $wptpa_settings["colors"] = themeLoad($wptpa_settings["theme"]);
    }
    // получаем цвета
    $color = $wptpa_settings["colors"];
    // получаем шрифт
    if($wptpa_settings["font"]){
      $font = "'Roboto', sans-serif";
    } else {
      $font = "inherit";
    }
    if(isset($_GET["page"]) != "wptpa_settings_page") {
  ?>
<style>
  .wptpa_song_infrmtn,
  .wptpa_currenttime,
  .wptpa_duration,
  .wptpa_song,
  .wptpa_dwn_cnt,
  .wptpa_play_cnt,
  .wptpa_num,
  .wptpa_h2,
  .wptpa_ads{
    font-family: <?php echo $font; ?>;
  }
  .wptpa_player {
    background: <?php echo $color["player"]['background']; ?> !important;
  }
  .wptpa_heading:before,
  .wptpa_heading:after {
    background: <?php echo $color["player"]['color']; ?> !important;
  }
  .wptpa_song_infrmtn {
    color: <?php echo $color["player"]['color']; ?> !important;
  }
  .wptpa_btn .wptpa_icon {
    fill: <?php echo $color["player"]['button']; ?>;
  }

  .wptpa_btn.actv .wptpa_icon,
  .wptpa_btn:hover .wptpa_icon{
    fill: <?php echo $color["player"]['button_active']; ?>;
  }
  .wptpa_btn:before{
    background: <?php echo $color["player"]['button']; ?> !important;
  }

  .wptpa_player .wptpa_seek,
  .wptpa_player .wptpa_loader {
    background: <?php echo $color["player"]['seek']; ?> !important;
  }
  .wptpa_player .wptpa_seek span,
  .wptpa_progress {
    background: <?php echo $color["player"]['progress']; ?> !important;
  }
  .wptpa_ads,
  .wptpa_currenttime,
  .wptpa_duration {
    color: <?php echo $color["player"]['timecode']; ?> !important;
  }
  .wptpa_volume_seek:before {
    background: <?php echo $color["player"]['seek']; ?> !important;
  }

  .wptpa_volume_value {
    background: <?php echo $color["player"]['progress']; ?> !important;
  }
  .wptpa_pllst_itm {
    border-bottom: 1px solid rgba(255, 255, 255, 0.25) !important;
    background: <?php echo $color["playlist"]['background']; ?> !important;
    color: <?php echo $color["playlist"]['color']; ?> !important;
  }
  .wptpa_pllst_itm.crrnt,
  .wptpa_pllst_itm:hover {
    background: <?php echo $color["playlist"]['background_current']; ?> !important;
    color: <?php echo $color["playlist"]['color_current']; ?> !important;
  }
  .wptpa_pllst_itm:last-child {
    border-bottom: 0px solid rgba(255, 255, 255, 0.25) !important;
  }
  .wptpa_bars,
  .wptpa_bars:before,
  .wptpa_bars:after{
    background: <?php echo $color["playlist"]['color']; ?> !important;
  }
  .wptpa_line {
    border-color: <?php echo $color["playlist"]['color']; ?> !important;
  }
  .wptpa_pllst_itm .wptpa_icon {
    fill: <?php echo $color["playlist"]['color']; ?>;
  }
  .wptpa_dwn_cnt,
  .wptpa_play_cnt {
    color: <?php echo $color["playlist"]['color']; ?> !important;
  }
  .wptpa_scroll_bar {
    background: <?php echo $color["playlist"]['color']; ?> !important;
  }
  </style>
  <?php
    }
  }
}
?>