<?php
/*
Plugin Name: tPlayer - Audio Player for WordPress
Plugin URI: http://codecanyon.net/item/tplayerhtml5-audio-player-with-playlist-for-wp/12005417
Description: Comfortable and functional jQuery based player for WordPress. tPlayer supports mp3 audio files playback, as well as radio streaming (Shoutcast and Icecast). tPlayer supports unlimited number of playlists and each playlist can have unlimited tracks. tPlayer is one of the most impressive HTML5 mp3 players available for sale.
Version: 1.2.1.6
Author: Derick Wire
Author URI: http://codecanyon.net/user/mmetrodw

	Copyright 2020  Derick Wire  (email: artgure@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// Путь к папке с плагином и адресс к папке
define('WPTPA_DIR', plugin_dir_path(__FILE__));
define('WPTPA_URL', plugin_dir_url(__FILE__));

// Подключаем файлы

// main functions 
require_once('inc/wptpa_functions.php');
// plugin activation 
require_once('inc/wptpa_activation.php');
// Playlists Page 
require_once('inc/wptpa_playlists_page.php');
// Stats Page 
require_once('inc/wptpa_statistics_page.php');
// import/export data Page 
require_once('inc/wptpa_data_page.php');
// help Page 
require_once('inc/wptpa_help_page.php');
// Settings Page 
require_once('inc/wptpa_settings_page.php');
// Подключаем wptpa_media_btn
//require_once('inc/wptpa_media_btn.php');
// Подключаем wptpa_gutenberg
require_once('inc/wptpa_gutenberg.php');
// Подключаем стили плеера
require_once('inc/wptpa_styles.php');
// Подключаем шорткод
require_once('inc/wptpa_shortcode.php');
// Подключаем widget
require_once('inc/wptpa_widget.php');
// Подключаем embed
require_once('inc/wptpa_embed.php');
// Подключаем embed
require_once('inc/wptpa_ads_page.php');


// обновление плагина
require 'plugin-updates/plugin-update-checker.php';
$ExampleUpdateChecker = PucFactory::buildUpdateChecker('http://bein.pp.ua/updtplgns/wptpa/info.json', __FILE__);


// Подключаем перевод
function wptpa_translate() {
  load_plugin_textdomain('wptpa', false, dirname(plugin_basename(__FILE__)).'/languages/'); 
}
add_action('plugins_loaded', 'wptpa_translate');


// Активация плагина
register_activation_hook(__FILE__, 'wptpa_activation');


// Подключение скриптов и стилей плагина

// общие скрипты
function wptpa_admin_script(){
  // for guttenberg
  wp_enqueue_style('wptpa_player-style', WPTPA_URL.'assets/css/wptpa_style.css');
  wp_enqueue_script('ResizeSensor-script', WPTPA_URL.'assets/js/ResizeSensor.js', array('jquery'));
  wp_enqueue_script('wptpa_player-script', WPTPA_URL.'assets/js/wptpa_script.js', array('jquery'));
  wp_localize_script('wptpa_player-script', 'wptpa_data', array(
    'ajaxurl' => admin_url('admin-ajax.php'),
    'siteurl' => get_site_url())
  );
  wp_enqueue_script('jquery');
  wp_enqueue_script('jquery.easing', WPTPA_URL.'assets/js/jquery.easing.js', array('jquery'));
  
}
add_action('admin_enqueue_scripts', 'wptpa_admin_script');

function wptpa_load_media_files() {
  wp_enqueue_media();
}
add_action('admin_enqueue_scripts', 'wptpa_load_media_files');

// Страница плейлистов
function wptpa_playlists_page_scripts(){
  wp_enqueue_style('fontawesome', 'https://use.fontawesome.com/releases/v5.11.2/css/all.css');
  wp_enqueue_style('fw_framework-css', WPTPA_URL.'assets/css/fw_all.css');
  wp_enqueue_style('wptpa_playlists_page-style', WPTPA_URL.'assets/css/wptpa_playlists_page.css');
  // scripts
  wp_enqueue_script('jquery.easing', WPTPA_URL.'assets/js/jquery.easing.js', array('jquery'));
  wp_enqueue_script('fw_forms-js', WPTPA_URL.'assets/js/fw_forms.js', array('jquery'));
  wp_enqueue_script('fw_dropdownlist-js', WPTPA_URL.'assets/js/fw_dropdownlist.js', array('jquery'));
  wp_enqueue_script('fw_notify-js', WPTPA_URL.'assets/js/fw_notify.js', array('jquery'));
  wp_enqueue_script('fw_modal-js', WPTPA_URL.'assets/js/fw_modal.js', array('jquery'));
  wp_enqueue_script('wptpa_playlists_page-script', WPTPA_URL.'assets/js/wptpa_playlists_page.js', array('jquery'));
}

// Страница настроек
function wptpa_settings_page_scripts(){
  wp_enqueue_style('fw_framework-css', WPTPA_URL.'assets/css/fw_all.css');
  wp_enqueue_style('fw_cp-css', WPTPA_URL.'assets/css/fw_cp.css');
  wp_enqueue_style('wptpa_player-style', WPTPA_URL.'assets/css/wptpa_style.css');
  // scripts
  $settings = get_option("wptpa_optn");
  wp_enqueue_script('jquery-ui-sortable');
  wp_enqueue_script('jquery.easing', WPTPA_URL.'assets/js/jquery.easing.js', array('jquery'));
  wp_enqueue_script('fw_cp-js', WPTPA_URL.'assets/js/fw_cp.js', array('jquery'));
  wp_enqueue_script('fw_tabs-js', WPTPA_URL.'assets/js/fw_tabs.js', array('jquery'));
  wp_enqueue_script('fw_dropdownlist-js', WPTPA_URL.'assets/js/fw_dropdownlist.js', array('jquery'));
  wp_enqueue_script('wptpa_settings_page-script', WPTPA_URL.'assets/js/wptpa_settings_page.js', array('jquery'));
  // добавляем кастомные цвета
  $array = isset($settings["colors"]) ? $settings["colors"] : null;
  wp_localize_script( 'wptpa_settings_page-script', 'wptpa_custom', $array);
}

// статистика
function wptpa_statistics_scripts() {
  wp_enqueue_style('fontawesome', 'https://use.fontawesome.com/releases/v5.11.2/css/all.css');
  wp_enqueue_style('fw_framework-css', WPTPA_URL.'assets/css/fw_all.css');
  wp_enqueue_style('wptpa_statistics_page-style', WPTPA_URL.'assets/css/wptpa_statistics_page.css');
  
  // scripts
  wp_enqueue_script('jquery.easing', WPTPA_URL.'assets/js/jquery.easing.js', array('jquery'));
  wp_enqueue_script('fw_dropdownlist-js', WPTPA_URL.'assets/js/fw_dropdownlist.js', array('jquery'));
  wp_enqueue_script('fw_notify-js', WPTPA_URL.'assets/js/fw_notify.js', array('jquery'));
  wp_enqueue_script('chart-js', WPTPA_URL.'assets/js/chart.js', array('jquery'));
  wp_enqueue_script('wptpa_statistics_page-script', WPTPA_URL.'assets/js/wptpa_statistics_page.js', array('jquery'));
}

// daata
function wptpa_data_scripts() {
  wp_enqueue_style('fontawesome', 'https://use.fontawesome.com/releases/v5.11.2/css/all.css');
  wp_enqueue_style('fw_framework-css', WPTPA_URL.'assets/css/fw_all.css');
  wp_enqueue_style('wptpa_data-css', WPTPA_URL.'assets/css/wptpa_data.css');

  // scripts
  wp_enqueue_script('jquery.easing', WPTPA_URL.'assets/js/jquery.easing.js', array('jquery'));
  wp_enqueue_script('fw_notify-js', WPTPA_URL.'assets/js/fw_notify.js', array('jquery'));
  wp_enqueue_script('wptpa_imp_exp_data-js', WPTPA_URL.'assets/js/wptpa_imp_exp_data.js', array('jquery'));
}

// help
function wptpa_help_scripts() {
  wp_enqueue_style('fontawesome', 'https://use.fontawesome.com/releases/v5.11.2/css/all.css');
  wp_enqueue_style('fw_framework-css', WPTPA_URL.'assets/css/fw_all.css');
  
  // scripts
  wp_enqueue_script('jquery.easing', WPTPA_URL.'assets/js/jquery.easing.js', array('jquery'));
  wp_enqueue_script('fw_accordion-js', WPTPA_URL.'assets/js/fw_accordion.js', array('jquery'));
  
}

// ads page
function wptpa_ads_scripts() {
  wp_enqueue_style('fontawesome', 'https://use.fontawesome.com/releases/v5.11.2/css/all.css');
  wp_enqueue_style('fw_framework-css', WPTPA_URL.'assets/css/fw_all.css');
  wp_enqueue_style('wptpa_playlists_page-style', WPTPA_URL.'assets/css/wptpa_playlists_page.css');
  
  // scripts
  wp_enqueue_script('jquery.easing', WPTPA_URL.'assets/js/jquery.easing.js', array('jquery'));
  wp_enqueue_script('fw_forms-js', WPTPA_URL.'assets/js/fw_forms.js', array('jquery'));
  wp_enqueue_script('fw_notify-js', WPTPA_URL.'assets/js/fw_notify.js', array('jquery'));
  wp_enqueue_script('fw_modal-js', WPTPA_URL.'assets/js/fw_modal.js', array('jquery'));
  wp_enqueue_script('wptpa_ads_page-js', WPTPA_URL.'assets/js/wptpa_ads_page.js', array('jquery'));
  
}



// Регистрируем страницы плагина
function wptpa_pages_register(){
  $tplayerIcon = WPTPA_URL."assets/img/tp_logo.png";
  
  $settings = get_option("wptpa_optn");
  if(!isset($settings["cpblts"])){
    $settings["cpblts"]["playlists_page"] = "edit_posts";
    $settings["cpblts"]["statistics_page"] = "edit_posts";
    $settings["cpblts"]["settings_page"] = "edit_posts";
    $settings["cpblts"]["ads_page"] = "edit_posts";
    $settings["cpblts"]["data_page"] = "edit_posts";
  }
  
  add_menu_page(__('tPlayer', 'wptpa'), __('tPlayer', 'wptpa'), $settings["cpblts"]["playlists_page"], 'wptpa_playlists_page', 'wptpa_playlists_page', $tplayerIcon, '80.2');
  $wptpa_playlists_page = add_submenu_page('wptpa_playlists_page', __('tPlayer - Playlist Generator', 'wptpa'), __('Playlist Generator', 'wptpa'), $settings["cpblts"]["playlists_page"], 'wptpa_playlists_page');
  $wptpa_statistics_page = add_submenu_page('wptpa_playlists_page', __('tPlayer - Songs Statistics', 'wptpa'), __('Songs Statistics', 'wptpa'), $settings["cpblts"]["statistics_page"], 'wptpa_statistics_page', 'wptpa_statistics_page');
  $wptpa_settings_page = add_submenu_page('wptpa_playlists_page', __('tPlayer - Settings', 'wptpa'), __('Player Settings', 'wptpa'), $settings["cpblts"]["settings_page"], 'wptpa_settings_page', 'wptpa_settings_page');
  $wptpa_ads_page = add_submenu_page('wptpa_playlists_page', __('tPlayer - Advertising Manager (Beta)', 'wptpa'), __('Advertising Manager  (Beta)', 'wptpa'), $settings["cpblts"]["ads_page"], 'wptpa_ads_page', 'wptpa_ads_page');
  $wptpa_data_page = add_submenu_page('wptpa_playlists_page', __('tPlayer - Import/Export Data', 'wptpa'), __('Import/Export Data', 'wptpa'), $settings["cpblts"]["data_page"], 'wptpa_data_page', 'wptpa_data_page');
  $wptpa_help_page = add_submenu_page('wptpa_playlists_page', __('tPlayer - Help', 'wptpa'), __('Help', 'wptpa'), "edit_posts", 'wptpa_help_page', 'wptpa_help_page');
  
  //подключаем страницы
  add_action('admin_print_scripts-' . $wptpa_playlists_page, 'wptpa_playlists_page_scripts');
  add_action('admin_print_scripts-' . $wptpa_settings_page, 'wptpa_settings_page_scripts');
  add_action('admin_print_scripts-' . $wptpa_statistics_page, 'wptpa_statistics_scripts');
  add_action('admin_print_scripts-' . $wptpa_data_page, 'wptpa_data_scripts');
  add_action('admin_print_scripts-' . $wptpa_help_page, 'wptpa_help_scripts');
  add_action('admin_print_scripts-' . $wptpa_ads_page, 'wptpa_ads_scripts');
}
add_action('admin_menu', 'wptpa_pages_register');

?>